#include "rotate_plan.h"
#include "ptz_header_file.h"
#include "gd32f4xx.h"
#include "angle_poweroffsave.h"
#include "mb85rc64.h"
static BSP_OS_SEM ptz_power_off_mutex;//Դ

static float power_v;//ʵʱѹ
static float power_v1;//ڱжϵѹ߻ǽ͵Ļѹ

PowerOffData power_off_data;

//ѹɼ
static float ptz_voltage_adc1()
{
  unsigned short int adc1_value;
  float float_adc1;
  
  adc_software_trigger_enable(ADC1,ADC_INSERTED_CHANNEL);
  adc1_value = ADC_IDATA1(ADC1);
  
  float_adc1 = (float)adc1_value / 4096.0 * 36.3;
  return float_adc1;
}

static float ptz_power_off_data_crc(PowerOffData data)
{
  float crc = 0;
  crc = data.hori_as5047d.as5047d_ptz_init_angle       +
        data.hori_as5047d.as5047d_ptz_angle_max        +
        data.hori_as5047d.as5047d_ptz_angle_K          +
        data.hori_as5047d.as5047d_ptz_angle_wf_actual  +
        data.hori_as5047d.as5047d_ptz_angle_wf_last    +
        data.hori_as5047d.as5047d_ptz_angle_actual     +
        data.hori_as5047d.as5047d_ptz_angle_last       +
        data.hori_as5047d.as5047d_remain_angle         +
        data.hori_as5047d.as5047d_cycle_num            +
        data.hori_as5047d.as5047d_cycle_count          +
        data.hori_as5047d.as5047d_cycle_count_last     +
        data.hori_as5047d.as5047d_angle_actual         +
        data.hori_as5047d.as5047d_dir                  +
        data.hori_as5047d.as5047d_angle_last           +
        data.hori_as5047d.as5047d_angle_difference     +
        data.hori_as5047d.as5047d_state                +
        data.hori_as5047d.as5047d_data_reset           + 
  
        data.vert_as5047d.as5047d_ptz_init_angle       +
        data.vert_as5047d.as5047d_ptz_angle_max        +
        data.vert_as5047d.as5047d_ptz_angle_K          +
        data.vert_as5047d.as5047d_ptz_angle_wf_actual  +
        data.vert_as5047d.as5047d_ptz_angle_wf_last    +
        data.vert_as5047d.as5047d_ptz_angle_actual     +
        data.vert_as5047d.as5047d_ptz_angle_last       +
        data.vert_as5047d.as5047d_remain_angle         +
        data.vert_as5047d.as5047d_cycle_num            +
        data.vert_as5047d.as5047d_cycle_count          +
        data.vert_as5047d.as5047d_cycle_count_last     +
        data.vert_as5047d.as5047d_angle_actual         +
        data.vert_as5047d.as5047d_dir                  +
        data.vert_as5047d.as5047d_angle_last           +
        data.vert_as5047d.as5047d_angle_difference     +
        data.vert_as5047d.as5047d_state                +
        data.vert_as5047d.as5047d_data_reset           +
        data.vert_angle                                +
        data.hori_angle                                +
        data.power_down_offset_anle                    +

          
        data.num;
  
  return crc;
}




char ptz_power_off_data_save(unsigned short int add)
{
  BSP_OS_SemWait(&ptz_power_off_mutex, 0u);
  PowerOffData power_off_data_b;
  int i;
  memcpy(&power_off_data.hori_as5047d, &g_ptz.hori_as5047d, sizeof(g_ptz.hori_as5047d));
  memcpy(&power_off_data.vert_as5047d, &g_ptz.vert_as5047d, sizeof(g_ptz.vert_as5047d));
  power_off_data.vert_angle = g_ptz.vert_angle_actual;
  power_off_data.hori_angle = g_ptz.hori_angle_actual; 
  power_off_data.power_down_offset_anle = g_ptz.offset_angle.offset_anle;//
  power_off_data.crc = ptz_power_off_data_crc(power_off_data);
  
  for(i = 0; i < PTZ_POWER_OFF_DATA_SAVE_NUM; i++)
  {
    memset(&power_off_data_b, 0, sizeof(power_off_data_b));
    mb85rc64_page_write(add, (unsigned char *)&power_off_data, sizeof(power_off_data));
    asm("nop");
    asm("nop");
    mb85rc64_add_read(add, (unsigned char *)&power_off_data_b, sizeof(power_off_data_b));
    if(memcmp(&power_off_data_b, &power_off_data, sizeof(power_off_data)) == 0)//жϲǷȷ
    {
      BSP_OS_SemPost(&ptz_power_off_mutex);
      return 1;
    }
  }
  BSP_OS_SemPost(&ptz_power_off_mutex);
  return 0;
}

char ptz_power_off_data_read()
{
  BSP_OS_SemWait(&ptz_power_off_mutex, 0u);
  char i;
  PowerOffData power_off_data_a;
  PowerOffData power_off_data_b;
  char data_a = 0;
  char data_b = 0;
  
  memset(&power_off_data, 0, sizeof(power_off_data));
  //ȡ洢a
  for(i = 0; i < PTZ_POWER_OFF_DATA_READ_NUM; i++)
  {
    memset(&power_off_data_a, 0, sizeof(power_off_data_a));
    mb85rc64_add_read(PTZ_MB85RC64_ADD_A, (unsigned char *)&power_off_data_a, sizeof(power_off_data_a));
    if(power_off_data_a.crc == ptz_power_off_data_crc(power_off_data_a) && power_off_data_a.crc != 0)
    {
       data_a = 1;
       break;
    }
  }
  
  //ȡ洢b
  for(i = 0; i < PTZ_POWER_OFF_DATA_READ_NUM; i++)
  {
    memset(&power_off_data_b, 0, sizeof(power_off_data_b));
    mb85rc64_add_read(PTZ_MB85RC64_ADD_B, (unsigned char *)&power_off_data_b, sizeof(power_off_data_b));
    if(power_off_data_b.crc == ptz_power_off_data_crc(power_off_data_b) && power_off_data_b.crc != 0)
    {
       data_b = 1;
       break;
    }
  }
  
  if(data_a == 1 && data_b == 0)//ֻд洢AǶԵ,ֻA
  {
    memcpy(&power_off_data, &power_off_data_a, sizeof(power_off_data));
    memcpy(&g_ptz.hori_as5047d, &power_off_data.hori_as5047d, sizeof(g_ptz.hori_as5047d));
    memcpy(&g_ptz.vert_as5047d, &power_off_data.vert_as5047d, sizeof(g_ptz.vert_as5047d));
    
    g_ptz.offset_angle.offset_anle = power_off_data.power_down_offset_anle;//ȡƫ
    
    if(power_off_data.num == 65535)
    {
      power_off_data.num = 0;
    }
    else
    {
      power_off_data.num ++;
    }
    
    BSP_OS_SemPost(&ptz_power_off_mutex);
    return 1;
  }
  
  
  if(data_a == 0 && data_b == 1)//ֻд洢BǶԵ,ֻB
  {
    memcpy(&power_off_data, &power_off_data_b, sizeof(power_off_data));
    memcpy(&g_ptz.hori_as5047d, &power_off_data.hori_as5047d, sizeof(g_ptz.hori_as5047d));
    memcpy(&g_ptz.vert_as5047d, &power_off_data.vert_as5047d, sizeof(g_ptz.vert_as5047d));
    
    g_ptz.offset_angle.offset_anle = power_off_data.power_down_offset_anle;//ȡƫ
    
    if(power_off_data.num == 65535)
    {
      power_off_data.num = 0;
    }
    else
    {
      power_off_data.num ++;
    }
    
    BSP_OS_SemPost(&ptz_power_off_mutex);
    return 1;
  }
  
  if(data_a == 1 && data_b == 1)//洢AǶԵģ洢BҲǶԵ
  {
    if(power_off_data_a.num > power_off_data_b.num)
    {
      if((power_off_data_a.num - power_off_data_b.num) == 1)
      {
        memcpy(&power_off_data, &power_off_data_a, sizeof(power_off_data));
        memcpy(&g_ptz.hori_as5047d, &power_off_data.hori_as5047d, sizeof(g_ptz.hori_as5047d));
        memcpy(&g_ptz.vert_as5047d, &power_off_data.vert_as5047d, sizeof(g_ptz.vert_as5047d));
        
        g_ptz.offset_angle.offset_anle = power_off_data.power_down_offset_anle;//ȡƫ
        
        if(power_off_data.num == 65535)
        {
          power_off_data.num = 0;
        }
        else
        {
          power_off_data.num ++;
        }
        
        BSP_OS_SemPost(&ptz_power_off_mutex);
        return 1;
      }
      
      if((power_off_data_a.num - power_off_data_b.num) == 65535)
      {
        memcpy(&power_off_data, &power_off_data_b, sizeof(power_off_data));
        memcpy(&g_ptz.hori_as5047d, &power_off_data.hori_as5047d, sizeof(g_ptz.hori_as5047d));
        memcpy(&g_ptz.vert_as5047d, &power_off_data.vert_as5047d, sizeof(g_ptz.vert_as5047d));
        
        g_ptz.offset_angle.offset_anle = power_off_data.power_down_offset_anle;//ȡƫ
        
        if(power_off_data.num == 65535)
        {
          power_off_data.num = 0;
        }
        else
        {
          power_off_data.num ++;
        }

        BSP_OS_SemPost(&ptz_power_off_mutex);
        return 1;
      }
    }
    
    if(power_off_data_b.num > power_off_data_a.num)
    {
      if((power_off_data_b.num - power_off_data_a.num) == 1)
      {
        memcpy(&power_off_data, &power_off_data_b, sizeof(power_off_data));
        memcpy(&g_ptz.hori_as5047d, &power_off_data.hori_as5047d, sizeof(g_ptz.hori_as5047d));
        memcpy(&g_ptz.vert_as5047d, &power_off_data.vert_as5047d, sizeof(g_ptz.vert_as5047d));
        
        g_ptz.offset_angle.offset_anle = power_off_data.power_down_offset_anle;//ȡƫ
        
        if(power_off_data.num == 65535)
        {
          power_off_data.num = 0;
        }
        else
        {
          power_off_data.num ++;
        }

        BSP_OS_SemPost(&ptz_power_off_mutex);
        return 1;
      }
      
      if((power_off_data_b.num - power_off_data_a.num) == 65535)
      {
        memcpy(&power_off_data, &power_off_data_a, sizeof(power_off_data));
        memcpy(&g_ptz.hori_as5047d, &power_off_data.hori_as5047d, sizeof(g_ptz.hori_as5047d));
        memcpy(&g_ptz.vert_as5047d, &power_off_data.vert_as5047d, sizeof(g_ptz.vert_as5047d));
        
        g_ptz.offset_angle.offset_anle = power_off_data.power_down_offset_anle;//ȡƫ
        
        if(power_off_data.num == 65535)
        {
          power_off_data.num = 0;
        }
        else
        {
          power_off_data.num ++;
        }
        
        BSP_OS_SemPost(&ptz_power_off_mutex);
        return 1;
      }
    }
    
  }
  
  
  BSP_OS_SemPost(&ptz_power_off_mutex);
  return 0;
}

char ptz_power_off_data_erase(unsigned short int add)
{
  BSP_OS_SemWait(&ptz_power_off_mutex, 0u);
  PowerOffData power_off_data_a;
  int i;
  memset(&power_off_data, 0, sizeof(power_off_data));
  power_off_data.crc = -100;

  for(i = 0; i < PTZ_POWER_OFF_DATA_SAVE_NUM; i++)
  {
    memset(&power_off_data_a, 0, sizeof(power_off_data_a));
    mb85rc64_page_write(add, (unsigned char *)&power_off_data, sizeof(power_off_data));
    asm("nop");
    asm("nop");
    mb85rc64_add_read(add, (unsigned char *)&power_off_data_a, sizeof(power_off_data_a));
    if(memcmp(&power_off_data_a, &power_off_data, sizeof(power_off_data)) == 0)//жϲǷȷ
    {
      BSP_OS_SemPost(&ptz_power_off_mutex);
      return 1;
    }
  }
  BSP_OS_SemPost(&ptz_power_off_mutex);
  return 0;
}





#define  ADC1_NUM    5 //ѹɼ

static char ptz_power_off_task()
{
  unsigned short int number;
#ifdef PTZ_POWER_OFF_ADC_MANY 
  static float adc1_v[ADC1_NUM];
  float tem;
  char i,j;
#endif
  while(1)
  {
#ifdef PTZ_POWER_OFF_ADC_MANY    
    //ȡѹ
    for(i = 0; i < ADC1_NUM; i++)
    {
      tem = 0;
      tem = ptz_voltage_adc1();
      if(tem < 0 || isnan(tem) == 1)
      {
        tem = 0;
      }
      adc1_v[i] = tem;
      OSTimeDlyHMSM(0u, 0u, 0u, 1u);
    }
    //Զȡѹ
    for(i = 0; i < ADC1_NUM-1; i++)//ֵС
    {
      for(j = 0; j < ADC1_NUM-i-1; j++)
      {
        if(adc1_v[j] > adc1_v[j+1])
        {
           tem         = adc1_v[j];
           adc1_v[j]   = adc1_v[j+1];
           adc1_v[j+1] = tem;
        }
       }
     }
    //ȥһСֵһֵ
    tem = 0;
    for(i = 1; i < ADC1_NUM - 1; i++)
    {
      tem = tem + adc1_v[i];
    }
    tem = tem /((float)(ADC1_NUM - 2));//ȥһֵһСֵƽֵ
    
    
    g_ptz.Voltage = tem;
    power_v = tem;
#endif    

#ifdef PTZ_POWER_OFF_ADC_SINGLE  
    
    OSTimeDlyHMSM(0u, 0u, 0u, 2u);
    //ȡʵʱѹ
    g_ptz.Voltage = ptz_voltage_adc1();
    //ж϶ĵѹǷ0ԼǷһ
    if(g_ptz.Voltage < 0 || isnan(g_ptz.Voltage) == 1)
    {
      g_ptz.Voltage = 0;
    }
    if(g_ptz.Voltage == 0)//ɼֵΪ0ɼ쳣Ϊ0ߵѹȷʵ0ٴ²ɼһΣ
                          //Էֹĳʱֵ̳ѹɼ̨ΪԴص
    {
      //OSTimeDlyHMSM(0u, 0u, 0u, 1u);
      asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
      g_ptz.Voltage = ptz_voltage_adc1();//ٲɼһ
      asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
      g_ptz.Voltage = ptz_voltage_adc1();//ٲɼһ
      //ж϶ĵѹǷС0ԼǷһ
      if(g_ptz.Voltage < 0 || isnan(g_ptz.Voltage) == 1)
      {
        g_ptz.Voltage = 0;
      }
    }
    power_v = g_ptz.Voltage;

#endif   
    
/*****************************************ǿƱλ********************************************************/       
    if(g_ptz.no_self_check_force_save == 1)
    {
      //洢̨ǰе
      if((power_off_data.num & 1) == 0)//ż
      {
        if(ptz_power_off_data_save(PTZ_MB85RC64_ADD_A) == 1)//洢̨ǰе
        {
          if(power_off_data.num == 65535)
          {
            
            power_off_data.num = 0;
          }
          else
          {
            power_off_data.num ++;
          }
        }
      }
      else
      {
        if(ptz_power_off_data_save(PTZ_MB85RC64_ADD_B) == 1)//洢̨ǰе
        {
          if(power_off_data.num == 65535)
          {
            power_off_data.num = 0;
          }
          else
          {
            power_off_data.num ++;
          }
        }
      }
      g_ptz.no_self_check_force_save = 2;//ʾǿƱ̨
    }
    
    if((g_ptz.hori_start_stop_set == PTZ_HORI_START || g_ptz.vert_start_stop_set == PTZ_VERT_START)
       && g_ptz.no_self_check_force_save == 2)
    {//ǿƱݺ̨תˣָֻԶжϵ籣湦
      g_ptz.no_self_check_force_save = 0;
    }
/**************************************ǿƲλ******************************************************/   
    if(g_ptz.no_self_check_force_erase == 1)
    {
      ptz_power_off_data_erase(PTZ_MB85RC64_ADD_A);
      ptz_power_off_data_erase(PTZ_MB85RC64_ADD_B);
      g_ptz.no_self_check_force_erase = 2;
    }
/********************************************Զλ*****************************************************/      
    if(g_ptz.hori_self_check == PTZ_HORI_SELF_CHECK_END &&
       g_ptz.vert_self_check == PTZ_VERT_SELF_CHECK_END && 
       g_ptz.no_self_check_force_save  != 2 && 
       g_ptz.no_self_check_force_erase != 2 &&
       g_ptz.no_self_check_state       != 1 &&
       g_ptz.hori_angle_state          == 1 &&
       g_ptz.vert_angle_state          == 1  )
    {
      //ѹִ½
      if(power_v < power_v1 && ((power_v1 - power_v) >= PTZ_POWER_DOWN_INC))
      {
        if((power_off_data.num & 1) == 0)//ż
        {
          if(ptz_power_off_data_save(PTZ_MB85RC64_ADD_A) == 1)//洢̨ǰе
          {
            if(power_off_data.num == 65535)
            {
              power_off_data.num = 0;
            }
            else
            {
              power_off_data.num ++;
            }
            
            power_v1 = power_v;
          }
        }
        else
        {
          if(ptz_power_off_data_save(PTZ_MB85RC64_ADD_B) == 1)//洢̨ǰе
          {
            if(power_off_data.num == 65535)
            {
              power_off_data.num = 0;
            }
            else
            {
              power_off_data.num ++;
            }
            
            power_v1 = power_v;
          }
        }
        
        
      }
      
      //ѹ
      if(power_v > power_v1)
      {
        power_v1 = power_v;
      }
//      term_printf("\n               power down save angle        \r\n\r\n");//
 
    }
   
/**********************************ֻҪ̨һתҪԭȱλ**************************************/          
    if(g_ptz.no_self_check_state == 1 && 
      (g_ptz.hori_start_stop_set == PTZ_HORI_START || g_ptz.vert_start_stop_set == PTZ_VERT_START))
    {
      number = power_off_data.num;
      ptz_power_off_data_erase(PTZ_MB85RC64_ADD_A);
      ptz_power_off_data_erase(PTZ_MB85RC64_ADD_B);
      power_off_data.num = number;
      g_ptz.no_self_check_state = 2;
    }
    
  }
}


static OS_STK  task_power_off_stk[POWER_OFF_STK_SIZE];
static  void  creat_task_power_off(void)
{ 
   CPU_INT08U  task_err;   
   CPU_INT08U  name_err;
   
   task_err = OSTaskCreateExt((void (*)(void *)) ptz_power_off_task,           
		   (void           *) 0,
		   (OS_STK         *)&task_power_off_stk[POWER_OFF_STK_SIZE - 1],
		   (INT8U           ) POWER_OFF_PRIO,                   
		   (INT16U          ) POWER_OFF_PRIO,
		   (OS_STK         *)&task_power_off_stk[0],
		   (INT32U          ) POWER_OFF_STK_SIZE,
		   (void           *) 0,
		   (INT16U          )(OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR));     
    #if (OS_TASK_NAME_EN > 0)
    OSTaskNameSet(POWER_OFF_PRIO, "ptz_power_off_task", &name_err);
    #endif
       

}

void init_power_off_module(void)
{
#ifdef PTZ_NO_SELF_CHECK 
  mb85rc64_gpio_init();
  
  BSP_OS_SemCreate(&ptz_power_off_mutex,1u,"ptz_power_off_mutex");//ź
  
  creat_task_power_off();
#endif
}