#include "device_dac_out.h"
#include "gd32f4xx.h"


/// @brief      DACʼ 
/// @param[in]  none
/// @return     none 
/// @note       ޸־
///             LH2022-05-26
void init_dac_out_module(void)
{
  //DACʱʹ
  rcu_periph_clock_enable(RCU_DAC);
  //DACPA4--DAC0PA5--DAC1
  gpio_mode_set(GPIOA, GPIO_MODE_ANALOG, GPIO_PUPD_NONE, GPIO_PIN_4);
  gpio_mode_set(GPIOA, GPIO_MODE_ANALOG, GPIO_PUPD_NONE, GPIO_PIN_5);
  
  dac_deinit();
  /* configure the DAC0 */
  dac_trigger_disable(DAC0);//Ǵʽ
  dac_wave_mode_config(DAC0, DAC_WAVE_DISABLE);
  dac_output_buffer_enable(DAC0);//
  /* configure the DAC1 */
  dac_trigger_disable(DAC1);//Ǵʽ
  dac_wave_mode_config(DAC1, DAC_WAVE_DISABLE);
  dac_output_buffer_enable(DAC1);//
  
  /* enable DAC0 and set data */
  dac_enable(DAC0);
  dac_data_set(DAC0, DAC_ALIGN_12B_R, 0);
  /* enable DAC1 and set data */
  dac_enable(DAC1);
  dac_data_set(DAC1, DAC_ALIGN_12B_R, 0);
}

/// @brief      ˮƽDAC0 
/// @param[in]  data:ֵ12λҶ
/// @return     none 
/// @note       ޸־
///             LH2022-05-26
void hori_dac0_data_out(unsigned short int data)
{
  uint16_t buff;
  buff = (uint16_t)data;
  dac_data_set(DAC0, DAC_ALIGN_12B_R, buff);
}

/// @brief      ֱDAC1 
/// @param[in]  data:ֵ12λҶ
/// @return     none 
/// @note       ޸־
///             LH2022-05-26
void vert_dac1_data_out(unsigned short int data)
{
  uint16_t buff;
  buff = (uint16_t)data;
  dac_data_set(DAC1, DAC_ALIGN_12B_R, buff);
}





