/// 
/// @file       device_dipswitch.c 
/// @function   ̵ʼ
/// @author     ypc 
/// @date       2019-05-25
/// @note       v1.0 2019-05-25
///             v2.0 2022-03-22
///

#include "device_relay.h"
#include "ptz_header_file.h"
#include "service_selfcheck.h"
#include "service_statusmonitor.h"
#include "ptz_type_select.h"
///̵ʼ
void init_relay_module()
{
#ifdef PTZ_MOTOR_RELAY
  gpio_mode_set(GPIOB, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_9);
  gpio_output_options_set(GPIOB, GPIO_OTYPE_PP, GPIO_OSPEED_25MHZ, GPIO_PIN_9);
  
  PTZ_MOTOR_RELAY_OFF;
  g_ptz.ptz_motor_relay_state = PTZ_RELAY_OFF;
#endif

}
///̵̨
void ptz_motor_relay_on()
{
#ifdef PTZ_MOTOR_RELAY
  PTZ_MOTOR_RELAY_ON;
  g_ptz.ptz_motor_relay_state = PTZ_RELAY_ON;
#endif
  //̵򿪺Ҫ³ʼ

  //ر̨Լ
  if(g_ptz.vert_self_check != PTZ_VERT_SELF_CHECK_END)
  {
    OSTaskDel(TASK_VERT_SELF_CHECK_PRIO);
  }
  if(g_ptz.hori_self_check != PTZ_HORI_SELF_CHECK_END)
  {
    OSTaskDel(TASK_HORI_SELF_CHECK_PRIO); 
  }
  g_ptz.hori_self_check = PTZ_HORI_SELF_CHECK_END;
  g_ptz.vert_self_check = PTZ_VERT_SELF_CHECK_END;
  
  //رԶɨ
  OSTaskDel(TASK_AREA_SCAN_PRIO);
  OSTaskDel(TASK_PRESET_BIT_SCAN_PRIO);
  
  //رչϼ
  OSTaskDel(TASK_FAULT_DETECT_PRIO);
  //й
  g_ptz.fault_detect.hori_rotate_fault      = NO_FAULT;//ˮƽת  
  g_ptz.fault_detect.vert_rotate_fault      = NO_FAULT;//ֱת 
  g_ptz.fault_detect.hori_hall_fault        = NO_FAULT;//ˮƽ 
  g_ptz.fault_detect.vert_hall_fault        = NO_FAULT;//ֱ 
  g_ptz.fault_detect.temperature_fault      = NO_FAULT;//¶쳣 
  g_ptz.fault_detect.voltage_fault          = NO_FAULT;//ѹ쳣 
  g_ptz.fault_detect.electric_current_fault = NO_FAULT;//쳣 
  g_ptz.fault_detect.fault                  = NO_FAULT;//ܱ־ 
  
  //ɲͣתе
  ptz_sem_post_stop_mutex();//ͷͣԴ
  OSTimeDlyHMSM(0u, 0u, 0u, 20u);//ȴһʱ
  g_ptz.vert_angleP.angle_allow_max = 60.0;
  g_ptz.vert_angleP.angle_allow_min = -60.0;  
  ptz_hori_stop(PTZ_HORI_STOP_TIME);
  ptz_vert_stop(PTZ_VERT_STOP_TIME);
  //رɨ
  g_area_scan.state = AREA_SCAN_CLOSE_A;
  //رԤλɨ
  g_preset_bit_scan.state = PRESET_BIT_SCAN_CLOSE_A;
  
#ifdef TMC2160
  tmc2160_init();
#endif
}
///̵̨ر
void ptz_motor_relay_off()
{
#ifdef PTZ_MOTOR_RELAY
  PTZ_MOTOR_RELAY_OFF;
  g_ptz.ptz_motor_relay_state = PTZ_RELAY_OFF;
#endif
  //´ɾ
  init_area_scan_module();
  init_preset_bit_scan_module();
  init_status_monitor_module();
}


