#include "bsp_os.h"
#include "ptz_header_file.h"
#include "enet_to_udp.h"
#include "service_areascan.h" 

static BSP_OS_SEM ptz_area_crc_mutex;

PtzArea g_area[AREA_AMOUNT];
AreaScan g_area_scan;

//̨ɨϢ
void ptz_send_area_data(char dev, unsigned short int ScanNum)
{
  unsigned char AreaData[7];
  unsigned short int data;
  
  //ˮƽ߽A
  data = (unsigned short int)(g_area[ScanNum].hori_start_angle * 100);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_HA;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  
  ptz_send_data(dev, AreaData, sizeof(AreaData));
  
  
  //ˮƽ߽B
  data = (unsigned short int)(g_area[ScanNum].hori_end_angle * 100);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_HB;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] =MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //ֱ߽A
  data = (unsigned short int)(g_area[ScanNum].vert_start_angle * 100);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_VA;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //ֱ߽B
  data = (unsigned short int)(g_area[ScanNum].vert_end_angle * 100);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_VB;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //ˮƽǶ
  data = (unsigned short int)(g_area[ScanNum].hori_step_angle * 100);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_INT_H;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //ֱǶ
  data = (unsigned short int)(g_area[ScanNum].vert_step_angle * 100);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_INT_V;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //תٶ
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_SPEED;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(g_area[ScanNum].hori_scan_speed * 10);
  AreaData[5] = (unsigned char)(g_area[ScanNum].vert_scan_speed * 10);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //ɨֹͣʱ
  data = (unsigned short int)(g_area[ScanNum].step_stop_time);
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_STOP_TIME;
  AreaData[3] = ScanNum;
  AreaData[4] = (unsigned char)(data >> 8);
  AreaData[5] = (unsigned char)(data & 0x00ff);
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData,sizeof(AreaData));

  
  //ɨ跽ʽ
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_WAY;
  AreaData[3] = ScanNum;
  AreaData[4] = g_area[ScanNum].scan_mode;
  AreaData[5] = 0;
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData, sizeof(AreaData));

  
  //̨ɨʹ
  memset(AreaData,0,sizeof(AreaData));
  AreaData[0] = 0xff;
  AreaData[1] = g_ptz.address;
  AreaData[2] = SCAN_ENABLE;
  AreaData[3] = ScanNum;
  AreaData[4] = g_area[ScanNum].enable;
  AreaData[5] = 0;
  AreaData[6] = MotorCalPelcoDSUM(AreaData,sizeof(AreaData));
  ptz_send_data(dev,AreaData, sizeof(AreaData));

}



///Զʹ
char ptz_area_auto_enable(PtzArea area)
{
  if(area.hsa == 1 &&
     area.hea == 1 &&
     area.vsa == 1 &&
     area.vea == 1 &&
     area.h_step == 1 &&
     area.v_step == 1)
  {
    return 1;
  }
  return 0;
}

///ÿ ӦЧ
unsigned int  ptz_area_crc(PtzArea area)
{
  BSP_OS_SemWait(&ptz_area_crc_mutex, 0u);
  float crc1 = 0;
  unsigned int crc = 0;
  
  crc1 = crc1 + area.hori_start_angle;//ˮƽʼ߽
  crc1 = crc1 + area.hsa;//ˮƽ߽AǷã1á0δ
 
  crc1 = crc1 + area.hori_end_angle;//ˮƽ߽
  crc1 = crc1 + area.hea;//ˮƽ߽BǷã1á0δ
 
  crc1 = crc1 + area.vert_start_angle;//ֱʼ߽
  crc1 = crc1 + area.vsa;//ֱ߽AǷã1á0δ
  
  crc1 = crc1 + area.vert_end_angle;//ֱ߽
  crc1 = crc1 + area.vea;//ֱ߽BǷã1á0δ
  
  crc1 = crc1 + area.hori_step_angle;//ˮƽǶ
  crc1 = crc1 + area.h_step;//ˮƽǶǷã1á0δ
  
  crc1 = crc1 + area.vert_step_angle;//ֱǶ
  crc1 = crc1 + area.v_step;//ֱǶǷã1á0δ
  
  crc1 = crc1 + area.hori_scan_speed;//ˮƽתٶ
  crc1 = crc1 + area.vert_scan_speed;//ֱתٶ
  crc1 = crc1 + area.step_stop_time;//תÿλõֹͣʱ䣬λmsұڵĬϵֹͣʱ
  crc1 = crc1 + area.scan_mode;//0Ĭɨ裬1ɨ裬2ɨ
  crc1 = crc1 + area.enable;//ɨǷЧ1Ч0Ч

  BSP_OS_SemPost(&ptz_area_crc_mutex);
  crc = (unsigned int)crc1;
  return crc;
}


///ɨ
char ptz_area_save()
{
  char i,j;
  static PtzArea area[AREA_AMOUNT];
  
  //д洢
  for(i = 0; i < AREA_SAVE_FLASH_NUM; i++)
  {
    memset(area, 0, sizeof(area));
    write_many_data(sizeof(g_area),(unsigned char *)g_area,AREA_FLASH_ADD);
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
    Flash_Read((unsigned char *)area,AREA_FLASH_ADD,sizeof(g_area));
    if(memcmp(g_area, area, sizeof(g_area)) == 0)//ждǷȷ
    {
      break;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
  }
  //д뱸ݴ洢
  for(j = 0; j < AREA_SAVE_FLASH_NUM; j++)
  {
    memset(area, 0, sizeof(area));
    write_many_data(sizeof(g_area),(unsigned char *)g_area,AREA_BACKUP_FLASH_ADD);
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
    Flash_Read((unsigned char *)area,AREA_BACKUP_FLASH_ADD,sizeof(g_area));
    if(memcmp(g_area, area, sizeof(g_area)) == 0)//ждǷȷ
    {
      break;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
  }
  if(i < AREA_SAVE_FLASH_NUM || j < AREA_SAVE_FLASH_NUM)//ждǷɹ
  {
    //дɹ
    return 1;
  }
  //дʧ
  return 0;
}

///ɨȡ**ڳʼѾȫ
char ptz_area_read()
{
  unsigned int i = 0;
  char flag = 0;
  Flash_Read((unsigned char *)g_area,AREA_FLASH_ADD,sizeof(g_area));
  for(i = 0; i < AREA_AMOUNT; i++)//ֹݲһ
  {
    if(isnan(g_area[i].hori_start_angle) == 1)
    {
      g_area[i].hori_start_angle = 0;
      flag = 1;
    }
    if(isnan(g_area[i].hsa) == 1)
    {
      g_area[i].hsa = 0;
      flag = 1;
    }
    if(isnan(g_area[i].hori_end_angle) == 1)
    {
      g_area[i].hori_end_angle = 0;
      flag = 1;
    }
    if(isnan(g_area[i].hea) == 1)
    {
      g_area[i].hea = 0;
      flag = 1;
    }
    if(isnan(g_area[i].vert_start_angle) == 1)
    {
      g_area[i].vert_start_angle = 0;
      flag = 1;
    }
    if(isnan(g_area[i].vsa) == 1)
    {
      g_area[i].vsa = 0;
      flag = 1;
    }
    if(isnan(g_area[i].vert_end_angle) == 1)
    {
      g_area[i].vert_end_angle = 0;
      flag = 1;
    }
    if(isnan(g_area[i].vea) == 1)
    {
      g_area[i].vea = 0;
      flag = 1;
    }
    if(isnan(g_area[i].hori_step_angle) == 1)
    {
      g_area[i].hori_step_angle = 0;
      flag = 1;
    }
    if(isnan(g_area[i].h_step) == 1)
    {
      g_area[i].h_step = 0;
      flag = 1;
    }
    if(isnan(g_area[i].vert_step_angle) == 1)
    {
      g_area[i].vert_step_angle = 0;
      flag = 1;
    }
    if(isnan(g_area[i].v_step) == 1)
    {
      g_area[i].v_step = 0;
      flag = 1;
    }
    if(isnan(g_area[i].hori_scan_speed) == 1)
    {
      g_area[i].hori_scan_speed = 0;
      flag = 1;
    }
    if(isnan(g_area[i].vert_scan_speed) == 1)
    {
      g_area[i].vert_scan_speed = 0;
      flag = 1;
    }
    if(isnan(g_area[i].step_stop_time) == 1)
    {
      g_area[i].step_stop_time = 0;
      flag = 1;
    }   
    if(isnan(g_area[i].scan_mode) == 1)
    {
      g_area[i].scan_mode = 0;
      flag = 1;
    }
    if(isnan(g_area[i].enable) == 1)
    {
      g_area[i].enable = 0;
      flag = 1;
    }
    if(isnan(g_area[i].crc) == 1)
    {
      g_area[i].crc = 0;
      flag = 1;
    }

    //жǷҪ¼Ч
    if(flag == 1)
    {
      flag = 0;
      g_area[i].crc = ptz_area_crc(g_area[i]);//Ҫ¼Ч
    }
    
    if(i % 10 == 0)
    {
      OSTimeDlyHMSM(0u, 0u, 0u, 1u);
    }
  }
  return 1;
}


///жɨǷЧ
static char ptz_area_data_check(PtzArea area)
{
  if(area.crc != ptz_area_crc(area))
  {
    return 0;
  }
  if(area.enable != AREA_ENABLE)
  {
    return 0;
  }
  if(area.hori_start_angle > g_ptz.hori_angleP.angle_allow_max)
  {
    return 0;
  }
  if(area.hori_start_angle < g_ptz.hori_angleP.angle_allow_min)
  {
    return 0;
  }
  if(area.vert_end_angle > g_ptz.vert_angleP.angle_allow_max)
  {
    return 0;
  }
  if(area.vert_end_angle < g_ptz.vert_angleP.angle_allow_min)
  {
    return 0;
  }
  return 1;
}

///ɨ
static void ptz_area_scan_task()
{
  short int i;
  float tem;
  while(1)
  {
    switch(g_area_scan.state)
    {

///ɨ        
      case AREA_SCAN_START://ɨ
        if(g_area_scan.start_num >= AREA_AMOUNT)
        {
          g_area_scan.start_num = AREA_AMOUNT - 1;
        }
        if(g_area_scan.end_num >= AREA_AMOUNT)
        {
          g_area_scan.end_num = AREA_AMOUNT - 1;
        }
        //ݵɨ軹Ƕɨ裬ȷɨ˳
        if(g_area_scan.sin_mul_mode == AREA_MUL_SCAN)
        {
          if(g_area_scan.start_num <= g_area_scan.end_num)
          {
            g_area_scan.order = 1;//Сɨ
          }
          else
          {
            g_area_scan.order = -1;//ɴСɨ
          }
        }
        //жɨŷΧڣжҪܹɨ
        g_area_scan.allow_scan_area_num = 0;
        if(g_area_scan.sin_mul_mode == AREA_MUL_SCAN)//Ƕɨ
        {
          if(g_area_scan.start_num <= g_area_scan.end_num)
          {
            for(i = g_area_scan.start_num; i <= g_area_scan.end_num; i++)
            {
              if(ptz_area_data_check(g_area[i]) == 1)
              {
                g_area_scan.allow_scan_area_num ++;
              }
            }
          }
          else
          {
            for(i = g_area_scan.start_num; i >= g_area_scan.end_num; i--)
            {
              if(ptz_area_data_check(g_area[i]) == 1)
              {
                g_area_scan.allow_scan_area_num ++;
              }
            }
          }
        }
        else//ǵɨ
        {
          if(ptz_area_data_check(g_area[g_area_scan.start_num]) == 1)
          {
            g_area_scan.allow_scan_area_num ++;
          }
        }
        if(g_area_scan.allow_scan_area_num > 0)
        {//пɨ
          g_area_scan.actual_num = g_area_scan.start_num;
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_START + 1;
          g_area_scan.state_a = g_area_scan.state;
          g_area_scan.start_flag = 1;
        }
        else//ûõɨ裬رɨ
        {
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_CLOSE_A;
          g_area_scan.state_a = g_area_scan.state;
        }
        break;
        
      case AREA_SCAN_START + 1:
        if(g_area_scan.start_flag == 0)
        {//ǵһ
                  if(g_area_scan.sin_mul_mode == AREA_MUL_SCAN)//Ƕɨ
                  {//ֱӽһ
                    g_area_scan.actual_num = g_area_scan.actual_num + g_area_scan.order;
                    if(g_area_scan.order == 1)
                    {
                      if(g_area_scan.actual_num > g_area_scan.end_num)
                      {
                        g_area_scan.actual_num = g_area_scan.start_num;
                      }
                    }
                    else //order == -1
                    {
                      if(g_area_scan.actual_num < g_area_scan.end_num)
                      {
                        g_area_scan.actual_num = g_area_scan.start_num;
                      }
                    }
                  }
        }
        else//ǵһ
        {
          g_area_scan.start_flag = 0;
        }
        
        //жٶǷΧ
        //ȡת
        g_area_scan.hori_speed = g_area[g_area_scan.actual_num].hori_scan_speed;
        if(g_area_scan.hori_speed < PTZ_HORI_MIN_SPEED)
        {
          g_area_scan.hori_speed = PTZ_HORI_MIN_SPEED;
        }
        if(g_area_scan.hori_speed > PTZ_HORI_MAX_SPEED)
        {
          g_area_scan.hori_speed = PTZ_HORI_MAX_SPEED;
        }
        
        g_area_scan.vert_speed = g_area[g_area_scan.actual_num].vert_scan_speed;
        if(g_area_scan.vert_speed < PTZ_VERT_MIN_SPEED)
        {
          g_area_scan.vert_speed = PTZ_VERT_MIN_SPEED;
        }
        if(g_area_scan.vert_speed > PTZ_VERT_MAX_SPEED)
        {
          g_area_scan.vert_speed = PTZ_VERT_MAX_SPEED;
        }
        
        //ȡת߽
        g_area_scan.hori_start_angle = g_area[g_area_scan.actual_num].hori_start_angle;
        g_area_scan.hori_end_angle = g_area[g_area_scan.actual_num].hori_end_angle;
        g_area_scan.vert_start_angle = g_area[g_area_scan.actual_num].vert_start_angle;
        g_area_scan.vert_end_angle = g_area[g_area_scan.actual_num].vert_end_angle;
        
        //ȡɨģʽжǵɨ軹ɨ
        g_area_scan.scan_mode = g_area[g_area_scan.actual_num].scan_mode;
        
        //ȡʱ
        g_area_scan.step_stop_time = g_area[g_area_scan.actual_num].step_stop_time;
        
        //ȡǶ
        g_area_scan.hori_step_angle = g_area[g_area_scan.actual_num].hori_step_angle;
        if(g_area_scan.hori_step_angle < 0)
        {//ֹˮƽǶΪˮƽǶԶΪ
          g_area_scan.hori_step_angle = g_area_scan.hori_step_angle * -1;
        }
        
        g_area_scan.vert_step_angle = g_area[g_area_scan.actual_num].vert_step_angle;
        if(g_area_scan.vert_start_angle >= g_area_scan.vert_end_angle)
        {//¸ɨ赥ǶΪֵ
          if(g_area_scan.vert_step_angle > 0)
          {
            g_area_scan.vert_step_angle = g_area_scan.vert_step_angle * -1;
          }
        }
        else
        {//¸ɨ赥ǶΪֵ
          if(g_area_scan.vert_step_angle < 0)
          {
            g_area_scan.vert_step_angle = g_area_scan.vert_step_angle * -1;
          }
        }
        
        //ˮƽһܲʹֱܲ
        if(g_area_scan.hori_step_angle != 0)
        {//ˮƽһܲ
          //ˮƽ߽֮ܽǶ
          if(g_area_scan.hori_start_angle < g_area_scan.hori_end_angle)
          {
            tem = fabs(g_area_scan.hori_end_angle - g_area_scan.hori_start_angle);
          }
          else
          {
            tem = fabs(g_area_scan.hori_end_angle - 0) + fabs(360.0 - g_area_scan.hori_start_angle);
          }
          g_area_scan.hori_step_num_b = tem / g_area_scan.hori_step_angle;
          g_area_scan.hori_step_num_a = (unsigned int)(g_area_scan.hori_step_num_b + 0.5);
        }
        else
        {
          g_area_scan.hori_step_num_a = 0;
        }
        
        if(g_area_scan.vert_step_angle != 0)
        {//㴹ֱܲ
          tem = fabs(g_area_scan.vert_end_angle - g_area_scan.vert_start_angle);
          g_area_scan.vert_step_num_b = tem / fabs(g_area_scan.vert_step_angle);
          g_area_scan.vert_step_num_a = (unsigned int)(g_area_scan.vert_step_num_b + 0.5);
        }
        else
        {
          g_area_scan.vert_step_num_a = 0;
        }
        
        //0
        g_area_scan.hori_step_count = 0;
        g_area_scan.vert_step_count = 0; 
        
        //жǷȷ
        if(ptz_area_data_check(g_area[g_area_scan.actual_num]) == 1)
        {//ȷЧɨģʽɨ衣
          //תɨʼλ
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_START + 2;
          g_area_scan.state_a = g_area_scan.state;
        }
        else//ȷǶɨһǵرɨ
        {
          if(g_area_scan.sin_mul_mode == AREA_MUL_SCAN)//Ƕɨ
          {//˳һ
            g_area_scan.state = AREA_SCAN_START + 1;
            g_area_scan.state_a = g_area_scan.state;
          }
          else//ǵɨ
          {//ֱӹرɨ
            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_CLOSE_A;
            g_area_scan.state_a = g_area_scan.state;
          }
        }
        break;
        
      case AREA_SCAN_START + 2://תɨʼλ
        g_area_scan.hori_target_angle = g_area[g_area_scan.actual_num].hori_start_angle;
        g_area_scan.vert_target_angle = g_area[g_area_scan.actual_num].vert_start_angle;
        
        g_area_scan.hori_step_count = 0;//0
        g_area_scan.vert_step_count = 0; 
        g_area_scan.step_stop_time_count = 0;
        g_area_scan.vert_scan_dir = 1;
        g_area_scan.hori_scan_dir = 1;
        
        g_ptz.vert_angle_control = g_area_scan.vert_target_angle;
        g_ptz.vert_speed_control = g_area_scan.vert_speed;
        ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
        g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  
        
        g_ptz.hori_angle_control = g_area_scan.hori_target_angle;
        g_ptz.hori_speed_control = g_area_scan.hori_speed;
        ptz_hori_rotate_plan(PTZ_HORI_MIN_DISTANCE);
        g_ptz.hori_rotate_monitor_switch = PTZ_HORI_MIN_DISTANCE;  
        
        g_ptz.hori_arrive_flag = 1;//ж̨ǷתָǶ
        g_ptz.vert_arrive_flag = 1;
        
        g_area_scan.last_state = g_area_scan.state;
        g_area_scan.state = AREA_SCAN_START + 3;
        g_area_scan.state_a = g_area_scan.state;
        break; 
        
      case AREA_SCAN_START + 3://жǷ񵽴ʼλ
        if(g_ptz.hori_arrive_flag == 0 && g_ptz.vert_arrive_flag == 0)
        {//ɹʼλ
          //ݸɨģʽжǵɨ軹ɨ
          if(g_area_scan.scan_mode == AREA_SCAN_MODE_STEP)
          {//ɨģʽ
            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_STEP;
            g_area_scan.state_a = g_area_scan.state;
          }
          else
          {//ɨģʽ
                if(fabs(g_area_scan.hori_start_angle - g_area_scan.hori_end_angle) == 360.0)
                {//360ȫΧɨ
                  g_area_scan.last_state = g_area_scan.state;
                  g_area_scan.state = AREA_SCAN_CONT_360;
                  g_area_scan.state_a = g_area_scan.state;
                }
                else
                {//ɨ
                  g_area_scan.last_state = g_area_scan.state;
                  g_area_scan.state = AREA_SCAN_CONT;
                  g_area_scan.state_a = g_area_scan.state;
                }
          }
         
        }
        break;
             

        
        
        
        
///ɨ
      case AREA_SCAN_STEP://ֹͣʱʱ
        //ɨ赽λش
        ptz_area_step_scan_location_return_return(PTZ_HORI);
        ptz_area_step_scan_location_return_return(PTZ_VERT);
        for(g_area_scan.step_stop_time_count = 0; g_area_scan.step_stop_time_count < g_area_scan.step_stop_time; g_area_scan.step_stop_time_count ++)
        {
          if(g_area_scan.state == AREA_SCAN_STEP)
          {//ȼͬҪһжϣʵʱӦɨֹͣͣرյָ
            OSTimeDlyHMSM(0u, 0u, 0u, 1u);
          }
          else
          {
            g_area_scan.step_stop_time_count = 0;
            g_area_scan.last_state = g_area_scan.state;
            
            break;
          }
        }
        if(g_area_scan.state == AREA_SCAN_STEP)
        {//ȼͬҪһжϣʵʱӦԤλֹͣͣرյָ
          //ֹͣʱ䵽
          g_area_scan.step_stop_time_count = 0;
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_STEP + 1;
          g_area_scan.state_a = g_area_scan.state;
        }
        break;
        
      case AREA_SCAN_STEP + 1://һҪˮƽǶȽǶ
        g_area_scan.hori_step_count = g_area_scan.hori_step_count + 1;
        //жһǷɨ
        if(g_area_scan.hori_step_count > g_area_scan.hori_step_num_a)
        {//һɨ
          g_area_scan.hori_step_count = 0;
          g_area_scan.hori_scan_dir = g_area_scan.hori_scan_dir * -1;
          
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_STEP + 5;
          g_area_scan.state_a = g_area_scan.state;
        }
        else
        {
          //ˮƽһľǶ
          if(g_area_scan.hori_scan_dir == 1)
          {
            if(g_area_scan.hori_step_count == g_area_scan.hori_step_num_a)
            {
              g_area_scan.hori_target_angle = g_area_scan.hori_end_angle;
            }
            else
            {
              g_area_scan.hori_target_angle = 
                g_area_scan.hori_start_angle + g_area_scan.hori_step_angle * g_area_scan.hori_step_count;
              if(g_area_scan.hori_target_angle > 360.0)
              {
                g_area_scan.hori_target_angle = g_area_scan.hori_target_angle - 360.0;
              }
            }
          }
          else
          {
            if(g_area_scan.hori_step_count == g_area_scan.hori_step_num_a)
            {
              g_area_scan.hori_target_angle = g_area_scan.hori_start_angle;
            }
            else
            {
              g_area_scan.hori_target_angle = 
                g_area_scan.hori_end_angle - g_area_scan.hori_step_angle * g_area_scan.hori_step_count;
              if(g_area_scan.hori_target_angle < 0)
              {
                g_area_scan.hori_target_angle = g_area_scan.hori_target_angle + 360.0;
              }
            }
          }
          
          g_ptz.hori_angle_control = g_area_scan.hori_target_angle;
          g_ptz.hori_speed_control = g_area_scan.hori_speed;
          ptz_hori_rotate_plan(PTZ_HORI_MIN_DISTANCE);
          g_ptz.hori_rotate_monitor_switch = PTZ_HORI_MIN_DISTANCE;  
          
          g_ptz.hori_arrive_flag = 1;//ж̨ǷתָǶ
          
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_STEP + 2;
          g_area_scan.state_a = g_area_scan.state;
        }
        break; 
        
      case AREA_SCAN_STEP + 2://жǷ񵽴ָλ
        if(g_ptz.hori_arrive_flag == 0 && g_ptz.vert_arrive_flag == 0)
        {
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_STEP;
          g_area_scan.state_a = g_area_scan.state;
        }
        break; 
        
/***ɨʱв޸ģʹ̨תΧԶֻɨѭת***/
      case AREA_SCAN_STEP + 5://һˮƽת
         g_area_scan.vert_step_count = g_area_scan.vert_step_count + 1;
         //жǷɨ
         if(g_area_scan.vert_step_count > g_area_scan.vert_step_num_a)
         {//ɨ
           if(g_area_scan.sin_mul_mode == AREA_SIN_SCAN)
           {//ǵɨ裬ѭ
             ptz_area_scan_end_return_return();//֪ͨƶһɨ
             g_area_scan.hori_step_count = 0; //
             g_area_scan.vert_step_count = 0;
             //תֱʼλ
             g_ptz.vert_angle_control = g_area_scan.vert_start_angle;
             g_ptz.vert_speed_control = g_area_scan.vert_speed;
             ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
             g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  

             g_ptz.vert_arrive_flag = 1;//ж̨ǷתָǶ

             g_area_scan.last_state = g_area_scan.state;
             g_area_scan.state = AREA_SCAN_STEP + 6;//жǷ񵽴ֱָλ
             g_area_scan.state_a = g_area_scan.state;
           }else{
             ptz_area_scan_end_return_return();//֪ͨƶһɨ
             g_area_scan.vert_step_count = 0;
             g_area_scan.last_state = g_area_scan.state;
             g_area_scan.state = AREA_SCAN_START + 1;//һɨ
             g_area_scan.state_a = g_area_scan.state;
           }
         }
         else
         {
            //ˮƽһľǶ
            g_area_scan.vert_target_angle = 
              g_area_scan.vert_start_angle + g_area_scan.vert_step_angle * g_area_scan.vert_step_count;
            if(g_area_scan.vert_step_count == g_area_scan.vert_step_num_a)  
            {
              g_area_scan.vert_target_angle = g_area_scan.vert_end_angle;
            }
            g_ptz.vert_angle_control = g_area_scan.vert_target_angle;
            g_ptz.vert_speed_control = g_area_scan.vert_speed;
            ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
            g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  

            g_ptz.vert_arrive_flag = 1;//ж̨ǷתָǶ

            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_STEP + 6;//жǷ񵽴ֱָλ
            g_area_scan.state_a = g_area_scan.state;
         }
        break; 
        
      case AREA_SCAN_STEP + 6://жǷ񵽴ֱָλ
        if(g_ptz.hori_arrive_flag == 0 && g_ptz.vert_arrive_flag == 0)
        {
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = AREA_SCAN_STEP;
          g_area_scan.state_a = g_area_scan.state;
        }
        break; 
        

        
      

        
///ɨ        
      case AREA_SCAN_CONT://ʼλãһҪˮƽλã
                          //ˮƽʼ߽תˮƽ߽
                          //ߴˮƽλתˮƽʼλ
        //ˮƽһľǶ
        if(g_area_scan.hori_scan_dir == 1)
        {
          g_area_scan.hori_target_angle = g_area_scan.hori_end_angle;
          
          g_ptz.hori_angle_control = g_area_scan.hori_target_angle;
          g_ptz.hori_speed_control = g_area_scan.hori_speed;
          ptz_hori_rotate_plan(PTZ_HORI_RIGHT_ANGLE);
          g_ptz.hori_rotate_monitor_switch = PTZ_HORI_RIGHT_ANGLE;  
        }
        else
        {
          g_area_scan.hori_target_angle = g_area_scan.hori_start_angle;
          
          g_ptz.hori_angle_control = g_area_scan.hori_target_angle;
          g_ptz.hori_speed_control = g_area_scan.hori_speed;
          ptz_hori_rotate_plan(PTZ_HORI_LEFT_ANGLE);
          g_ptz.hori_rotate_monitor_switch = PTZ_HORI_LEFT_ANGLE;  
        }
        
        g_area_scan.hori_scan_dir = g_area_scan.hori_scan_dir * -1;
        
        g_ptz.hori_arrive_flag = 1;//ж̨ǷתָǶ
        
        g_area_scan.last_state = g_area_scan.state;
        g_area_scan.state = AREA_SCAN_CONT + 2;
        g_area_scan.state_a = g_area_scan.state;
        break;

       case AREA_SCAN_CONT + 2://жǷתָˮƽ߽
          if(g_ptz.hori_arrive_flag == 0 && g_ptz.vert_arrive_flag == 0)
          {
            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_CONT + 3;
            g_area_scan.state_a = g_area_scan.state;
          }
         break;
         
/***ɨʱв޸ģʹ̨תΧԶֻɨѭת***/
       case AREA_SCAN_CONT + 3://һֱת
          g_area_scan.vert_step_count = g_area_scan.vert_step_count + 1;
         //жǷɨ
         if(g_area_scan.vert_step_count > g_area_scan.vert_step_num_a)
         {//ɨ
           if(g_area_scan.sin_mul_mode == AREA_SIN_SCAN)
           {//ǵɨ裬ѭ
             ptz_area_scan_end_return_return();//֪ͨƶһɨ
             g_area_scan.vert_step_count = 0;
             //תֱʼλ
             g_ptz.vert_angle_control = g_area_scan.vert_start_angle;
             g_ptz.vert_speed_control = g_area_scan.vert_speed;
             ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
             g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  
             
             g_ptz.vert_arrive_flag = 1;//ж̨ǷתָǶ
             
             g_area_scan.last_state = g_area_scan.state;
             g_area_scan.state = AREA_SCAN_CONT + 4;//жǷ񵽴ֱָλ
             g_area_scan.state_a = g_area_scan.state;
           }else{
            ptz_area_scan_end_return_return();//֪ͨƶһɨ
            g_area_scan.vert_step_count = 0;
            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_START + 1;//һɨ
            g_area_scan.state_a = g_area_scan.state;
           }
         }
         else
         {
            //ˮƽһľǶ
            g_area_scan.vert_target_angle = 
              g_area_scan.vert_start_angle + g_area_scan.vert_step_angle * g_area_scan.vert_step_count;
            if(g_area_scan.vert_step_count == g_area_scan.vert_step_num_a)  
            {
              g_area_scan.vert_target_angle = g_area_scan.vert_end_angle;
            }
            g_ptz.vert_angle_control = g_area_scan.vert_target_angle;
            g_ptz.vert_speed_control = g_area_scan.vert_speed;
            ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
            g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  

            g_ptz.vert_arrive_flag = 1;//ж̨ǷתָǶ

            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_CONT + 4;//жǷ񵽴ֱָλ
            g_area_scan.state_a = g_area_scan.state;
         }
         break;
         
       case AREA_SCAN_CONT + 4://жǷ񵽴ֱָλ
         if(g_ptz.hori_arrive_flag == 0 && g_ptz.vert_arrive_flag == 0)
         {
           g_area_scan.last_state = g_area_scan.state;
           g_area_scan.state = AREA_SCAN_CONT;
           g_area_scan.state_a = g_area_scan.state;
         }
         break;

         
         
         
         
///360ȫɨ
       case AREA_SCAN_CONT_360://360ȫɨ״
         g_ptz.hori_speed_control = g_area_scan.hori_speed;
         //жת
        if(g_area_scan.hori_start_angle <= g_area_scan.hori_end_angle)
        {//תɨ
          g_area_scan.hori_scan_dir_360 = PTZ_HORI_DIR_RIGHT;
        }
        else
        {//תɨ
          g_area_scan.hori_scan_dir_360 = PTZ_HORI_DIR_LEFT;
        }
        //ˮƽת
        if(g_area_scan.hori_scan_dir_360 == PTZ_HORI_DIR_RIGHT)
        {
          ptz_hori_rotate_plan(PTZ_HORI_RIGHT_KEEP);
          g_ptz.hori_rotate_monitor_switch = PTZ_HORI_RIGHT_KEEP;
        }
        else
        {
          ptz_hori_rotate_plan(PTZ_HORI_LEFT_KEEP);
          g_ptz.hori_rotate_monitor_switch = PTZ_HORI_LEFT_KEEP;
        }
        g_area_scan.last_state = g_area_scan.state;
        g_area_scan.state = AREA_SCAN_CONT_360 + 1;
        g_area_scan.state_a = g_area_scan.state;
         break;
       
       case AREA_SCAN_CONT_360 + 1://жһתʼλúͽλ
         //ʼǶ
         g_area_scan.hori_start_angle_360 = g_ptz.hori_angle_actual;
         //Ƕ
         if(g_area_scan.hori_scan_dir_360 == PTZ_HORI_DIR_RIGHT)
         {
           g_area_scan.hori_end_angle_360 = g_area_scan.hori_start_angle_360 + AREA_SCAN_END_ANGLE_INC_360;
           if(g_area_scan.hori_end_angle_360 >= 360.0)
           {
             g_area_scan.hori_end_angle_360 = g_area_scan.hori_end_angle_360 - 360.0;
           }
         }
         else//g_area_scan.hori_scan_dir_360 = PTZ_HORI_DIR_LEFT
         {
           g_area_scan.hori_end_angle_360 = g_area_scan.hori_start_angle_360 - AREA_SCAN_END_ANGLE_INC_360;
           if(g_area_scan.hori_end_angle_360 < 0)
           {
             g_area_scan.hori_end_angle_360 = g_area_scan.hori_end_angle_360 + 360.0;
           }
         }
         g_area_scan.last_state = g_area_scan.state;
         g_area_scan.state = AREA_SCAN_CONT_360 + 2;
         g_area_scan.state_a = g_area_scan.state;
         break;
       
       case AREA_SCAN_CONT_360 + 2://жһǷɨһ
         if(g_area_scan.hori_scan_dir_360 == PTZ_HORI_DIR_RIGHT)
         {
           if(g_area_scan.hori_start_angle_360 <= g_ptz.hori_angle_actual)
           {
             if(fabs(g_ptz.hori_angle_actual - g_area_scan.hori_start_angle_360) >= 180.0 &&
                fabs(360.0 - g_ptz.hori_angle_actual + g_area_scan.hori_start_angle_360) > 50.0)
             {
               g_area_scan.last_state = g_area_scan.state;
               g_area_scan.state = AREA_SCAN_CONT_360 + 3;
               g_area_scan.state_a = g_area_scan.state;
             }
           }
           else
           {
             if(fabs(360.0 - g_area_scan.hori_start_angle_360 + g_ptz.hori_angle_actual) >= 180.0 &&
                fabs(g_area_scan.hori_start_angle_360 - g_ptz.hori_angle_actual) >= 50.0)
             {
               g_area_scan.last_state = g_area_scan.state;
               g_area_scan.state = AREA_SCAN_CONT_360 + 3;
               g_area_scan.state_a = g_area_scan.state;
             }
           }
         }
         else
         {
           if(g_area_scan.hori_start_angle_360 >= g_ptz.hori_angle_actual)
           {
             if(fabs(g_area_scan.hori_start_angle_360 - g_ptz.hori_angle_actual) >= 180.0 &&
                fabs(360.0 - g_area_scan.hori_start_angle_360 + g_ptz.hori_angle_actual) >= 50.0)
             {
               g_area_scan.last_state = g_area_scan.state;
               g_area_scan.state = AREA_SCAN_CONT_360 + 3;
               g_area_scan.state_a = g_area_scan.state;
             }
           }
           else
           {
             if(fabs(360.0 - g_ptz.hori_angle_actual + g_area_scan.hori_start_angle_360) >= 180.0 &&
                fabs(g_ptz.hori_angle_actual - g_area_scan.hori_start_angle_360) >= 50.0)
             {
               g_area_scan.last_state = g_area_scan.state;
               g_area_scan.state = AREA_SCAN_CONT_360 + 3;
               g_area_scan.state_a = g_area_scan.state;
             }
           }
         }
         break;
         
       case AREA_SCAN_CONT_360 + 3://жһʣµһǷɨɣжһǷɨ
         //жһʣµһǷɨɵԭתƶλԭͬ
         //
         g_area_scan.hori_near_angle_360 = 
           fabs(g_ptz.hori_angle_actual - g_area_scan.hori_start_angle_360);
         if(g_area_scan.hori_near_angle_360 > 360.0 / 2.0)
         {
           g_area_scan.hori_near_angle_360 = 360.0 - g_area_scan.hori_near_angle_360;
         }
         //Զľ
         g_area_scan.hori_far_angle_360 = 
           fabs(g_ptz.hori_angle_actual - g_area_scan.hori_start_angle_360);
         if(g_area_scan.hori_far_angle_360 > 360.0 / 2.0)
         {
           g_area_scan.hori_far_angle_360 = 360.0 - g_area_scan.hori_far_angle_360;
         }
         //жһɨǷ
         if(g_area_scan.hori_far_angle_360 +  g_area_scan.hori_near_angle_360 <=  
            AREA_SCAN_END_ANGLE_INC_360)
         {//һɨ
           g_area_scan.hori_far_angle_360 = 0;
           g_area_scan.hori_near_angle_360 = 0;
           g_area_scan.hori_end_angle_360 = 0;
           g_area_scan.last_state = g_area_scan.state;
           g_area_scan.state = AREA_SCAN_CONT_360 + 4;
           g_area_scan.state_a = g_area_scan.state;
         }
         break;
         
       case AREA_SCAN_CONT_360 + 4://滮תһֱ
         g_area_scan.vert_step_count = g_area_scan.vert_step_count + 1;
         //жǷɨ
         if(g_area_scan.vert_step_count > g_area_scan.vert_step_num_a)
         {//ɨ
           
            g_area_scan.vert_step_count = 0;
            
            if(g_area_scan.sin_mul_mode == AREA_MUL_SCAN)
            {//Ƕɨ
              ptz_area_scan_end_return_return();//֪ͨƶһɨ
              g_area_scan.last_state = g_area_scan.state;
              g_area_scan.state = AREA_SCAN_START + 1;//һɨ
              g_area_scan.state_a = g_area_scan.state;
            }
            else
            {//ǵɨg_area_scan.sin_mul_mode == AREA_SIN_SCAN
             //ֱӻصֱʼ㣬ˮƽת״̬ı
              ptz_area_scan_end_return_return();//֪ͨƶһɨ
              g_area_scan.vert_target_angle = g_area_scan.vert_start_angle;
              g_ptz.vert_angle_control = g_area_scan.vert_target_angle;
              g_ptz.vert_speed_control = g_area_scan.vert_speed;
              ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
              g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  

              g_ptz.vert_arrive_flag = 1;//ж̨ǷתָǶ

              g_area_scan.last_state = g_area_scan.state;
              g_area_scan.state = AREA_SCAN_CONT_360 + 5;//жǷ񵽴ֱָλ
              g_area_scan.state_a = g_area_scan.state;
            }
         }
         else
         {
            //ˮƽһľǶ
            g_area_scan.vert_target_angle = 
              g_area_scan.vert_start_angle + g_area_scan.vert_step_angle * g_area_scan.vert_step_count;
            if(g_area_scan.vert_step_count == g_area_scan.vert_step_num_a)  
            {
              g_area_scan.vert_target_angle = g_area_scan.vert_end_angle;
            }
            g_ptz.vert_angle_control = g_area_scan.vert_target_angle;
            g_ptz.vert_speed_control = g_area_scan.vert_speed;
            ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
            g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  

            g_ptz.vert_arrive_flag = 1;//ж̨ǷתָǶ

            g_area_scan.last_state = g_area_scan.state;
            g_area_scan.state = AREA_SCAN_CONT_360 + 5;//жǷ񵽴ֱָλ
            g_area_scan.state_a = g_area_scan.state;
         }
         break;
         
       case AREA_SCAN_CONT_360 + 5://жǷ񵽴ֱָλ
         if(g_ptz.vert_arrive_flag == 0)
         {
           g_area_scan.last_state = g_area_scan.state;
           g_area_scan.state = AREA_SCAN_CONT_360 + 1;
           g_area_scan.state_a = g_area_scan.state;
         }
         break;
         
         
      
      
      
//ɨ 

//ͣɨ
      case AREA_SCAN_PAUSE_A://ɨͣ
        //ȱв
        g_area_scan.pause_state = g_area_scan.state_a;
        g_area_scan.pause_hori_angle = g_ptz.hori_angle_actual;
        g_area_scan.pause_vert_angle = g_ptz.vert_angle_actual;
        g_area_scan.pause_hori_arrive_flag = g_ptz.hori_arrive_flag;
        g_area_scan.pause_vert_arrive_flag = g_ptz.vert_arrive_flag;
        g_area_scan.pause_hori_start_stop = g_ptz.hori_start_stop_set;
        g_area_scan.pause_vert_start_stop = g_ptz.vert_start_stop_set;
        g_area_scan.pause_hori_direction = g_ptz.hori_direction_set;
        g_area_scan.pause_vert_direction = g_ptz.vert_direction_set;
        //ֹ̨ͣת
        g_ptz.vert_rotate_monitor_switch = PTZ_VERT_DEC_BRAKE_A;
        g_ptz.hori_rotate_monitor_switch = PTZ_HORI_DEC_BRAKE_A;
        g_area_scan.last_state = g_area_scan.state;
        g_area_scan.state = AREA_SCAN_PAUSE_B;
        g_area_scan.state_a = g_area_scan.state;
        break;
        
      case AREA_SCAN_PAUSE_B://ɨͣ
        
        break; 

        
        
        
//ָɨ       
      case AREA_SCAN_RECOVERY://ɨָͣ
                              //ȹ滮תϵλ
        g_ptz.vert_angle_control = g_area_scan.pause_vert_angle;
        g_ptz.vert_speed_control = g_area_scan.vert_speed;
        ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
        g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;  
        
        g_ptz.hori_angle_control = g_area_scan.pause_hori_angle;
        g_ptz.hori_speed_control = g_area_scan.hori_speed;
        ptz_hori_rotate_plan(PTZ_HORI_MIN_DISTANCE);
        g_ptz.hori_rotate_monitor_switch = PTZ_HORI_MIN_DISTANCE;  
        
        g_ptz.hori_arrive_flag = 1;//ж̨ǷתָǶ
        g_ptz.vert_arrive_flag = 1;
        
        g_area_scan.last_state = g_area_scan.state;
        g_area_scan.state = AREA_SCAN_RECOVERY + 1;
        g_area_scan.state_a = g_area_scan.state;
        break;

      case AREA_SCAN_RECOVERY + 1://ͣʱλ
                                  //ָ̨ɨͣǰ״̬//g_area_scan.vert_target_angle
        if(g_ptz.hori_arrive_flag == 0 && g_ptz.vert_arrive_flag == 0)
        {
          if(g_area_scan.pause_hori_arrive_flag == 1)
          {//ָλת
            g_ptz.hori_angle_control = g_area_scan.hori_target_angle;
            g_ptz.hori_speed_control = g_area_scan.hori_speed;
            ptz_hori_rotate_plan(PTZ_HORI_MIN_DISTANCE);
            g_ptz.hori_rotate_monitor_switch = PTZ_HORI_MIN_DISTANCE;
            g_ptz.hori_arrive_flag = 1;
          }
          else
          {//ָλת
            if(g_area_scan.pause_hori_start_stop == PTZ_HORI_START)
            {//ȴһֱת״̬,Ҫ360ɨ
              if(g_area_scan.pause_hori_direction == PTZ_HORI_DIR_RIGHT)
              {
                ptz_hori_rotate_plan(PTZ_HORI_RIGHT_KEEP);
                g_ptz.hori_rotate_monitor_switch = PTZ_HORI_RIGHT_KEEP;
              }
              else
              {
                ptz_hori_rotate_plan(PTZ_HORI_LEFT_KEEP);
                g_ptz.hori_rotate_monitor_switch = PTZ_HORI_LEFT_KEEP;
              }
            }
          }
          
          if(g_area_scan.pause_vert_arrive_flag == 1)
          {//ָλת
            g_ptz.vert_angle_control = g_area_scan.vert_target_angle;
            g_ptz.vert_speed_control = g_area_scan.vert_speed;
            ptz_vert_rotate_plan(PTZ_VERT_ANGLE);
            g_ptz.vert_rotate_monitor_switch = PTZ_VERT_ANGLE;
            g_ptz.vert_arrive_flag = 1;
          }
          //ָ֮ǰɨ״̬
          g_area_scan.last_state = g_area_scan.state;
          g_area_scan.state = g_area_scan.pause_state;
          g_area_scan.state_a = g_area_scan.state;
        }
        break;



//رɨ        
      case AREA_SCAN_CLOSE_A: //رɨ
        memset(&g_area_scan, 0, sizeof(g_area_scan));
        g_ptz.vert_rotate_monitor_switch = PTZ_VERT_DEC_BRAKE_A;
        g_ptz.hori_rotate_monitor_switch = PTZ_HORI_DEC_BRAKE_A;
        g_area_scan.last_state = g_area_scan.state;
        g_area_scan.state = AREA_SCAN_CLOSE_B;
        g_area_scan.state_a = g_area_scan.state;
        break;
        
     case AREA_SCAN_CLOSE_B://ɨر
        
        break;  
    }
    
    OSTimeDlyHMSM(0u, 0u, 0u, 10u);
    
  }
}


///ɨشݱ
void ptz_area_scan_end_return_save(char dev)
{ 
  if(dev == PTZ_UDP)
  {
    g_ptz.area_scan_return.area_scan_end_fromlen = ptz_fromlen;
    memcpy(&g_ptz.area_scan_return.area_scan_end_from, &ptz_from, ptz_fromlen);
  }
}
///ɨظ
void ptz_area_scan_end_return_return()
{
  unsigned char area[7] = {0xff,0x00,0x00,0x00,0x00,0x00,0x00};
  area[1] = g_ptz.address;
  area[2] = 0xc4;
  area[3] = AREA_SCAN_END_RETURN_DATA;//ʾش
  area[4] = g_area_scan.actual_num;//ǰɨɵ
  area[6] = MotorCalPelcoDSUM(area,sizeof(area));
  
  if(g_ptz.area_scan_return.area_scan_end_udp_switch == AREA_SCAN_RETURN_ON)
  {
    //
    send_udp_data_aim(area, sizeof(area), 
                      (struct sockaddr*)&g_ptz.area_scan_return.area_scan_end_from, g_ptz.area_scan_return.area_scan_end_fromlen);

  }
  
  if(g_ptz.area_scan_return.area_scan_end_uart_422_switch == AREA_SCAN_RETURN_ON)
  {
    ptz_send_data(PTZ_UART_422, area, sizeof(area));
  }
  
  if(g_ptz.area_scan_return.area_scan_end_uart_485_switch == AREA_SCAN_RETURN_ON)
  {
    ptz_send_data(PTZ_UART_485, area, sizeof(area));
  }
}


///ɨ赽λشݱ
void ptz_area_step_scan_location_return_save(char dev)
{ 
  if(dev == PTZ_UDP)
  {
    g_ptz.area_scan_return.area_step_scan_location_fromlen = ptz_fromlen;
    memcpy(&g_ptz.area_scan_return.area_step_scan_location_from, &ptz_from, ptz_fromlen);
  }
}

///ɨ赽λش
void ptz_area_step_scan_location_return_return(char angle_choice)
{
  unsigned short int uint16_angle = 0;
  unsigned char area[7] = {0xff,0x00,0x00,0x00,0x00,0x00,0x00};
  
  area[1] = g_ptz.address;
  area[2] = 0xc4;
  if(angle_choice == PTZ_HORI)
  {
     uint16_angle = (unsigned short int)(g_area_scan.hori_target_angle * 100 + 0.5);
     area[3] = AREA_STEP_SCAN_LOCATION_RETURN_HORI;//ʾش
     area[4] = (u_int16_t)(uint16_angle >> 8);
     area[5] = (u_int16_t)(uint16_angle & 0x00ff);
     area[6] = MotorCalPelcoDSUM(area,sizeof(area));
  }
  else
  {
     uint16_angle = (unsigned short int)(g_area_scan.vert_target_angle * 100 + 0.5);
     area[3] = AREA_STEP_SCAN_LOCATION_RETURN_VERT;//ʾش
     area[4] = (u_int16_t)(uint16_angle >> 8);
     area[5] = (u_int16_t)(uint16_angle & 0x00ff);
     area[6] = MotorCalPelcoDSUM(area,sizeof(area));
  }

  if(g_ptz.area_scan_return.area_step_scan_location_udp_switch == AREA_SCAN_RETURN_ON)
  {
    //
    send_udp_data_aim(area, sizeof(area), 
                      (struct sockaddr*)&g_ptz.area_scan_return.area_step_scan_location_from, g_ptz.area_scan_return.area_step_scan_location_fromlen);
  }
  
  if(g_ptz.area_scan_return.area_step_scan_location_uart_422_switch == AREA_SCAN_RETURN_ON)
  {
    ptz_send_data(PTZ_UART_422, area, sizeof(area));
  }
  
  if(g_ptz.area_scan_return.area_step_scan_location_uart_485_switch == AREA_SCAN_RETURN_ON)
  {
    ptz_send_data(PTZ_UART_485, area, sizeof(area));
  }
}









static OS_STK  task_area_scan_stk[TASK_AREA_SCAN_STK_SIZE];
static  void  creat_task_area_scan(void)
{ 
   CPU_INT08U  task_err;   
   CPU_INT08U  name_err;
   
   task_err = OSTaskCreateExt((void (*)(void *)) ptz_area_scan_task,           
		   (void           *) 0,
		   (OS_STK         *)&task_area_scan_stk[TASK_AREA_SCAN_STK_SIZE - 1],
		   (INT8U           ) TASK_AREA_SCAN_PRIO,                   
		   (INT16U          ) TASK_AREA_SCAN_PRIO,
		   (OS_STK         *)&task_area_scan_stk[0],
		   (INT32U          ) TASK_AREA_SCAN_STK_SIZE,
		   (void           *) 0,
		   (INT16U          )(OS_TASK_OPT_STK_CHK | OS_TASK_OPT_STK_CLR));     
    #if (OS_TASK_NAME_EN > 0)
    OSTaskNameSet(TASK_AREA_SCAN_PRIO, "ptz_area_scan_task", &name_err);
    #endif
       if ((task_err == OS_ERR_NONE) && (name_err == OS_ERR_NONE)) {
          pdebug(DEBUG_LEVEL_INFO,"create ptz_area_scan_task  success...\n\r");
	} else { 
          pdebug(DEBUG_LEVEL_FATAL,"create ptz_area_scan_task  failed...\n\r");
	}

}

void init_area_scan_module()
{
  ptz_area_read();
  creat_task_area_scan();
}





























