#ifndef __PTZ_UPDATE_H_
#define __PTZ_UPDATE_H_

#include "comm_types.h"




#pragma pack(push,1)

#define HARD_WARE_TYPE_DEFAULT_K (*((u_int8_t *)"G"))
#define HARD_WARE_TYPE_DEFAULT_6 (*((u_int8_t *)"D"))

//.hpkļͷ
typedef struct _UpdateFileHead_
{
        u_int32_t flag;                 // 4byte	־Ϊ"HYPK"	ļԴ˿ͷΪǷǷļ
        u_int32_t head_len;             //4byte	ͷ	ļͷȣ"־"
        u_int8_t file_type;             //1byte	ļͣ1	1Ӧó 2:bootloader
        u_int16_t file_format_ver;      //2byte ļʽ汾ţ1	ȷļĴʽ
        u_int8_t hardware_type[2];      //2byte	Ӳ	õӲ
        u_int16_t hardware_ver;         //2byte	Ӳ汾	õӲ汾
        u_int32_t software_ver;         //4byte	汾	Ӧ汾
        u_int32_t data_len;             //4byte ݳ
        u_int32_t addr;                 //4byte дַ
        u_int8_t head_checksum;         //1byte	ͷУ	ݵchecksum"־"ֽ
}UpdateFileHead;

#define UPDATE_BUFF_SIZE      750 //ݰС
#define UPDATE_BUFF_FIFO_NUM  2    //ѭ洢ݰ

//ļ
#define UPDATE_FILE_TYPE_APP         1 //ļapplicationӦó
#define UPDATE_FILE_TYPE_BOOT_LOADER 2 //ļbootloader
#define UPDATE_FILE_TYPE_CERT        3 //оƬ֤
#define UPDATE_FILE_TYPE_PUB_KEY     4 //Կ
#define UPDATE_FILE_TYPE_CFG_FILE    5 //ļ
#define UPDATE_FILE_TYPE_CFG_IP      6 //IPļ
#define UPDATE_FILE_TYPE_NW_INFO     7 //̨Ϣ  

//Э֡
#define UPDATE_FRAME_TYPE_SEND 0X20 //̨
#define UPDATE_FRAME_TYPE_RECE 0X21 //̨

#define UPDATE_FRAME_TYPE_KEEP_ALIVE         0X01 //Ա
#define UPDATE_FRAME_TYPE_GET_DEVICE_INFO    0X02 //ڻȡ豸ϢӲ汾
#define UPDATE_FRAME_TYPE_RESET_DEVICE       0X03 //豸λ
#define UPDATE_FRAME_TYPE_BOOT_APP           0X04 //Ҫ豸Ӧ
#define UPDATE_FRAME_TYPE_UPGRADE_REQ        0X05 //豸һupgrade_requestṹ
#define UPDATE_FRAME_TYPE_UPGRADE_DATE       0X06 //豸ݣһupgrade_frameṹ
#define UPDATE_FRAME_TYPE_UPGRADE_FINISH     0X07 //豸SRV->Deviceݿ
                                             //Device->Srvǲupgrade_retrans_table
#define UPDATE_FRAME_TYPE_ERROR              0XF0 //Ϣ
#define UPDATE_FRAME_TYPE_VER_INFO           0XF1 //汾Ϣ


#define UPDATE_FRAME_HEAD_FLAG               0X5AA5//֡ͷ

#define DEVICE_ID_LEN                        17    //豸ID

#define PTZ_UPDATE_PORT                      9999  //̨˿

#define PTZ_UPDATE_SERV_IP_A                 "192.168.8.222"  //IPַ
#define PTZ_UPDATE_SERV_IP_B                 "192.168.8.168"
#define PTZ_UPDATE_SERV_PORT_A               8880  //˶˿
#define PTZ_UPDATE_SERV_PORT_B               8881  //˶˿

#define BITS_PER_UNIT                        8     //һֽڵbit                    

#define MAX_RETRANS_TABLE_LEN                256   //С

//ȡÿһ֡CRC16У
#define UPDATE_FRAME_GET_CRC16(x) (*(u_int16_t *)(&((x)->data[(x)->data_len])))
//֡ͷ
#define UPDATE_FRAME_HEAD_SIZE(x) (((char *)((x)->data)) - (char *)(x))
//֡ܳ
#define UPDATE_FRAME_SIZE(x) (((char *)&((x)->data[(x)->data_len])) - (char *)(x) + sizeof(u_int16_t))
///ļܳ
#define UPDATE_FILE_TOTAL_LEN(x) ((x)->data_len + sizeof(*(x)) + sizeof(u_int16_t))
///㲹С
#define UPDATE_RETRANS_TABLE_SIZE(x) (((x)->count * sizeof((x)->index[0])) +sizeof((x)->count))

#define ON_CHIP_FLASH_SECTOR_SIZE          2048

#define UPDATE_ON_CHIP_FLASH_SECTOR_SIZE   2048
#define UPDATE_EXT_FLASH_SECTOR_SIZE       (1024*4)
#define UPDATE_EXT_FLASH_BLOCK_NUM         (0)
#define UPDATE_EXT_FLASH_BLOCK_NUM16       (16)


//ƬflashʱʹõĵַϢ
#define UPDATE_FLASH_BUFF_BEGIN_ADDR   (1024*64*24)//1.5M-2M      
#define UPDATE_FLASH_BUFF_END_ADDR     (1024*64*32-1)
#define UPDATE_FLASH_BUFF_SIZE         (1024*64*8)//512k
#define UPDATE_FLASH_BUFF_BEGIN_BLOCK  (UPDATE_FLASH_BUFF_BEGIN_ADDR / Flash_BLOCKBYTE_LENGTH)

//bootloaderַϢ--Ƭ
#define UPDATE_BOOTLOADER_ADDR_BEGIN   (0x08000000)//Bootloaderʼַ
#define UPDATE_BOOTLOADER_ADDR_END     (0x0800BFFF)//bootloaderַ64KBռ40123
#define UPDATE_BOOTLOADER_SECTOR_BEGIN CTL_SECTOR_NUMBER_0 //Bootloaderʼsector

//ӦóַϢ--Ƭ
#define UPDATE_APP_ADDR_BEGIN   (0x08010000)//Ӧóʼַ
#define UPDATE_APP_ADDR_END     (0x0807FFFF)//Ӧóַ448kBռ44567
#define UPDATE_APP_SECTOR_BEGIN  CTL_SECTOR_NUMBER_4 //Ӧóʼsector

#define APP_ADD_BEGIN_OFFEST      (0x08000000)

//ȫַ֤Ϣ--w25q128
#define UPDATE_CERT_ADDR_BEGIN   (1024*4*2)//0block 2sector(4k) ͷ1sector
#define UPDATE_CERT_ADDR_END     (1024*4*3-1)
#define UPDATE_CERT_SECTOR_BEGIN (UPDATE_CERT_ADDR_BEGIN / UPDATE_EXT_FLASH_SECTOR_SIZE)//ȫоƬ֤

//ԿַϢ--w25q128
#define UPDATE_KEY_ADDR_BEGIN   (1024*4*4)//0block 4sector(4k) ͷ3sector
#define UPDATE_KEY_ADDR_END     (1024*4*5-1)
#define UPDATE_KEY_SECTOR_BEGIN (UPDATE_KEY_ADDR_BEGIN / UPDATE_EXT_FLASH_SECTOR_SIZE)//ȫоƬԿ

//ļַϢ--w25q128
#define UPDATE_CFG_FILE_ADDR_BEGIN   (1024*4*6)//0block 6sector(4k) ͷ5sector
#define UPDATE_CFG_FILE_ADDR_END     (1024*4*7-1)
#define UPDATE_CFG_FILE_SECTOR_BEGIN (UPDATE_CFG_FILE_ADDR_BEGIN / UPDATE_EXT_FLASH_SECTOR_SIZE)//ļ

//IPļַϢ--w25q128
#define UPDATE_CFG_IP_ADDR_BEGIN   (1024*64*16+1024*4*1)//16block 1sector(4k) ͷ block16 0sector
#define UPDATE_CFG_IP_ADDR_END     (1024*64*16+1024*4*2-1)
#define UPDATE_CFG_IP_SECTOR_BEGIN ((UPDATE_CFG_IP_ADDR_BEGIN - Flash_BLOCKBYTE_LENGTH*16)/ UPDATE_EXT_FLASH_SECTOR_SIZE)//ļ

//̨ϢļַϢ--w25q128
#define UPDATE_CFG_NW_INFO_ADDR_BEGIN    (1024*64*16+1024*4*3)//16block 2sector(8k) ͷ block16 3sector 4sector
#define UPDATE_CFG_NW_INFO_ADDR_END      (1024*64*16+1024*4*5-1)
#define UPDATE_CFG_NW_INFO_SECTOR_BEGIN  ((UPDATE_CFG_NW_INFO_ADDR_BEGIN - Flash_BLOCKBYTE_LENGTH*16)/ UPDATE_EXT_FLASH_SECTOR_SIZE)//ļ



////Ӧóͷ洢ַϢӦóǰ4K--Ƭ
//#define APP_PKG_HEAD_BEGIN         0x0800C000//(APP_ADDR_BEGIN - 4096)
//#define APP_PKG_HEAD_END           0x0800FFFF//(APP_ADDR_BEGIN-1)
//#define APP_PKG_HEAD_SECTOR_BEGIN   CTL_SECTOR_NUMBER_3//3  //ͷ洢sector(APP_PKG_HEAD_BEGIN/ON_CHIP_FLASH_SECTOR_SIZE)
//#define APP_PGK_HEAD               ((hy_release_file_head*)APP_PKG_HEAD_BEGIN)

//Ӧóͷ洢ַϢӦóǰ2sector--Ƭ
#define UPDATE_APP_PKG_HEAD_BEGIN          0x0800C000
#define UPDATE_APP_PKG_HEAD_END            0x0800FFFF
#define UPDATE_APP_PKG_HEAD_SECTOR_BEGIN   CTL_SECTOR_NUMBER_3//ͷ洢sector
#define UPDATE_APP_PKG_HEAD                ((UpdateFileHead*)UPDATE_APP_PKG_HEAD_BEGIN)

//ȫ֤ͷ洢ַϢоƬȫ֤ǰ1sector--w25q128
#define UPDATE_CERT_HEAD_BEGIN          (UPDATE_CERT_ADDR_BEGIN - UPDATE_EXT_FLASH_SECTOR_SIZE)
#define UPDATE_CERT_HEAD_END            (UPDATE_CERT_ADDR_BEGIN-1)
#define UPDATE_CERT_HEAD_SECTOR_BEGIN   (UPDATE_CERT_HEAD_BEGIN/UPDATE_EXT_FLASH_SECTOR_SIZE)//ͷ洢sector

//Կͷ洢ַϢԿǰ1sector--w25q128
#define UPDATE_KEY_HEAD_BEGIN          (UPDATE_KEY_ADDR_BEGIN - UPDATE_EXT_FLASH_SECTOR_SIZE)
#define UPDATE_KEY_HEAD_END            (UPDATE_KEY_ADDR_BEGIN-1)
#define UPDATE_KEY_HEAD_SECTOR_BEGIN   (UPDATE_KEY_HEAD_BEGIN/UPDATE_EXT_FLASH_SECTOR_SIZE)//ͷ洢sector

//ļͷ洢ַϢļǰ1sector--w25q128
#define UPDATE_CFG_FILE_HEAD_BEGIN          (UPDATE_CFG_FILE_ADDR_BEGIN - UPDATE_EXT_FLASH_SECTOR_SIZE)
#define UPDATE_CFG_FILE_HEAD_END            (UPDATE_CFG_FILE_ADDR_BEGIN-1)
#define UPDATE_CFG_FILE_HEAD_SECTOR_BEGIN   (UPDATE_CFG_FILE_HEAD_BEGIN/UPDATE_EXT_FLASH_SECTOR_SIZE)//ͷ洢sector

//IPļͷ洢ַϢļǰ1sector--w25q128
#define UPDATE_CFG_IP_HEAD_BEGIN          (UPDATE_CFG_IP_ADDR_BEGIN - UPDATE_EXT_FLASH_SECTOR_SIZE)
#define UPDATE_CFG_IP_HEAD_END            (UPDATE_CFG_IP_ADDR_BEGIN-1)
#define UPDATE_CFG_IP_HEAD_SECTOR_BEGIN   ((UPDATE_CFG_IP_HEAD_BEGIN - Flash_BLOCKBYTE_LENGTH*16)/UPDATE_EXT_FLASH_SECTOR_SIZE)//ͷ洢sector

//Ϣļͷ洢ַϢļǰ1sector--w25q128
#define UPDATE_CFG_NW_INFO_HEAD_BEGIN          (UPDATE_CFG_NW_INFO_ADDR_BEGIN - UPDATE_EXT_FLASH_SECTOR_SIZE)
#define UPDATE_CFG_NW_INFO_HEAD_END            (UPDATE_CFG_NW_INFO_ADDR_BEGIN-1)
#define UPDATE_CFG_NW_INFO_HEAD_SECTOR_BEGIN   ((UPDATE_CFG_NW_INFO_HEAD_BEGIN - Flash_BLOCKBYTE_LENGTH*16)/UPDATE_EXT_FLASH_SECTOR_SIZE)//ͷ洢sector


#define UPDATE_RELEASE_FILE_FLAG (*((u_int32_t *)"HYPK"))

//е״̬
#define UPDATE_STATE_DEAD 0 //ʼ״̬δӵ
#define UPDATE_STATE_IDEL 1 //״̬ϵͳƽʱ״̬
#define UPDATE_STATE_UPGRADE_DATA_TRANS 2 //ȴά״̬


#define flash_buff_crc16(len) (_flash_buff_crc16(UPDATE_FLASH_BUFF_BEGIN_ADDR, len));


///ݰѭṹ
typedef struct _UpdateRecvFifoBuff_
{
   unsigned short int data_len;//ݳ
   unsigned char data_buff[UPDATE_BUFF_SIZE];//ݰ
}UpdateRecvFifoBuff;

///֡ṹ
typedef struct _UpdateFrame_
{
        unsigned short int flag;         // 2byte ֡ʼ־Ϊ5AA5
        unsigned short int data_len;     // 2byte ݳ
        unsigned char id[DEVICE_ID_LEN];     //豸ID
        unsigned char frame_type;            //֡,ǽݻǷ
        unsigned char pack_type;             //ͣ֡Ĺܣʾָ֡һ
        unsigned char data[2];
}UpdateFrame;

///󣬰ļͷ豸׼ļУļͷһٴη
typedef struct _UpdateRequest_ 
{
        u_int32_t total_len;  //ܳ
        u_int16_t frame_len;  //ÿ󳤶
        u_int16_t frame_count; //ͷƬ
        UpdateFileHead file_head; //ļͷϢ
}UpdateRequest;

//device->servr count == 0ʾҪɹ
typedef struct _UpdateRetransTable_
{
        u_int16_t count;    //
        u_int16_t index[1]; //ű
}UpdateRetransTable;

//ļݣļݷƬ
typedef struct _UpdateData_
{
        u_int16_t index;    //
        u_int16_t data_len; //֡ݳȣдƫΪ
        u_int8_t  data[1];  //
}UpdateData;


RAM_FUNC void OnChip_Flash_init(void);
RAM_FUNC u_int8_t OnChip_Flash_erase_sector(u_int16_t sectorNo);
RAM_FUNC u_int8_t OnChip_Flash_write_in_sector(u_int16_t sectNo,u_int16_t offset,u_int16_t cnt,u_int8_t buf[]);
RAM_FUNC u_int8_t OnChip_Flash_write(u_int32_t addr,u_int16_t cnt, u_int8_t buf[]);
RAM_FUNC u_int32_t OnChip_Flash_cmd_launch(void);
RAM_FUNC u_int8_t OnChip_Flash_read_in_sector(u_int16_t sectNo,u_int16_t offset,u_int16_t cnt,u_int8_t*bBuf);





#pragma pack(pop)

void init_update_module();

#endif
