#include "as5047d.h"
#include  <includes.h>

static BSP_OS_SEM ptz_hori_get_angle_mutex;//Դ
static BSP_OS_SEM ptz_vert_get_angle_mutex;


static void as5047d_delay_nop(int as5047d_delay_time);
static unsigned int as5047d_Parity_bit_even(unsigned int package);
/// AS5047Dʱ
///
/// AS5047DSPIͨŶʱ
/// @param delay_time ʱʱ䳤    
/// @return  
/// @par   ޸־
///        2017-09-06
static void as5047d_delay_nop(int delay_time)
{
    for(int i = 0; i < delay_time; i ++)
    {
      asm("nop");
      asm("nop");
      asm("nop");
      asm("nop");
    }  
}

/// AS5047Dʼ
///
/// ʼAS5047D
/// @param     
/// @return  
/// @par   ޸־
///        2017-09-06
///        LH޸2022.0525
void as5047d_init()
{
  //ʱʹ
  rcu_periph_clock_enable(RCU_GPIOA);
  rcu_periph_clock_enable(RCU_GPIOC);
  rcu_periph_clock_enable(RCU_GPIOD);
  //ˮƽPC10--CLK,PC12--MOSI
  gpio_mode_set(GPIOC, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_10| GPIO_PIN_12);
  gpio_output_options_set(GPIOC, GPIO_OTYPE_PP, GPIO_OSPEED_25MHZ, GPIO_PIN_10| GPIO_PIN_12);
  //PA15--CS
  gpio_mode_set(GPIOA, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_15);
  gpio_output_options_set(GPIOA, GPIO_OTYPE_PP, GPIO_OSPEED_25MHZ, GPIO_PIN_15);
  //PC11--MISO
  gpio_mode_set(GPIOC, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_11);
  
  AS5047D_HORI_CSN_DISABLE;
  AS5047D_HORI_CLK_LOW;
  AS5047D_HORI_MOSI_LOW;
  
  
  
  //ֱPD0--CS,PD1--CLK,PD3--MOSI
  gpio_mode_set(GPIOD, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_0| GPIO_PIN_1| GPIO_PIN_3);
  gpio_output_options_set(GPIOD, GPIO_OTYPE_PP, GPIO_OSPEED_25MHZ, GPIO_PIN_0| GPIO_PIN_1| GPIO_PIN_3);
  //PD2--MISO
  gpio_mode_set(GPIOD, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_2);
  
  AS5047D_VERT_CSN_DISABLE;
  AS5047D_VERT_CLK_LOW;
  AS5047D_VERT_MOSI_LOW;
}

/// AS5047DݰżУ(żУ)
///
/// ݰżУ(żУ)
/// @param  package Ҫݰ   
/// @return żУݰ 
/// @par   ޸־
///        2017-09-06
static unsigned int as5047d_Parity_bit_even(unsigned int package)
{
  unsigned int temp = 0;
  char temp1 = 0;
  ///жÿһλ01
  for(char i = 0; i < 15; i++)
  {
    temp = package & (1 << i);
    if(temp != 0)
    {
      ///λֵΪ1
      temp1++;
    }
    temp = 0;
  }
  ///temp1Ϊż
  if(temp1 % 2 == 0)
  {
    ///żЧλΪ0
    package = package & 0X7FFF; //0111 1111 1111 1111
  }
  ///temp1Ϊ
  else
  {
    ///żЧλΪ1 
    package = package | 0X8000;//1000 0000 0000 0000
  }
  return package;
}
 


/// 趨ݰread/write
///
/// 趨ݰread/write
/// @param  package Ҫ趨ݰ   
/// @return 趨ݰ 
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_command_type(unsigned int package, unsigned int type)
{
  switch(type)
  {
    case AS5047D_WRITE_COMMAND:
    case AS5047D_WRITE_DATA:
      package = package & AS5047D_WRITE_COMMAND;
      break;

    case AS5047D_READ_COMMAND:
      package = package | AS5047D_READ_COMMAND;
      break;

    default :
      return 0;
  }
  return package;  
}

/// жϽյ
///
/// жϽյ
/// @param  package жϵ
/// @param  
/// @return жϽ
/// @par   ޸־
///        2017-09-08
As5047DJudgeReceivePackage as5047d_hori_judge_receive_package(unsigned int package)
{
  unsigned int temp = 0;
  As5047DJudgeReceivePackage temp1;
  memset(&temp1,0,sizeof(temp1));
  
  temp1.package = package;
  temp1.Operation_Result = 1;
  //жݰżУǷȷ
  //Ч
  if(package != as5047d_Parity_bit_even(package))
  {
    temp1.parity_error_package = 1;
    temp1.Operation_Result = 0;
  }
  //Чȷ
  else
  {
    //жϷݰǷǻظָ
    temp = package & AS5047D_JUDGE_RECEIVE_DATA;
    //ظָ
    if(temp != 0)
    {
//      temp1.error_flag_command = 1;
//      temp1.framing_error_command   = package & 0X0001;
//      temp1.command_invalid_command = package & (0X0001 << 1);
//      temp1.parity_error_command    = package & (0X0001 << 2);
      as5047d_hori_cef_command();
      
    }
  }
  return temp1;
}


As5047DJudgeReceivePackage as5047d_vert_judge_receive_package(unsigned int package)
{
  unsigned int temp = 0;
  As5047DJudgeReceivePackage temp1;
  memset(&temp1,0,sizeof(temp1));
  
  temp1.package = package;
  temp1.Operation_Result = 1;
  //жݰżУǷȷ
  //Ч
  if(package != as5047d_Parity_bit_even(package))
  {
    temp1.parity_error_package = 1;
    temp1.Operation_Result = 0;
  }
  //Чȷ
  else
  {
    //жϷݰǷǻظָ
    temp = package & AS5047D_JUDGE_RECEIVE_DATA;
    //ظָ
    if(temp != 0)
    {
//      temp1.error_flag_command = 1;
//      temp1.framing_error_command   = package & 0X0001;
//      temp1.command_invalid_command = package & (0X0001 << 1);
//      temp1.parity_error_command    = package & (0X0001 << 2);
      as5047d_vert_cef_command();
      
    }
  }
  return temp1;
}

/*********************************************************************/




/// ˮƽ
///
/// as5047d
/// @param   
/// @return ؽյ
/// @par   ޸־
///        2017-09-08
unsigned int as5047d_hori_send_package(unsigned int package)
{
  unsigned int temp = 0;
  unsigned int temp1 = 0;
  unsigned int temp2 = 0;
  AS5047D_HORI_CLK_LOW;
  AS5047D_HORI_MOSI_LOW;
  as5047d_delay_nop(2);
  for(int i = 15; i >= 0; i--)
  {
    AS5047D_HORI_CLK_LOW;
    as5047d_delay_nop(2);
    temp = package & (1 << i);
    if(temp != 0)
    {
      AS5047D_HORI_MOSI_HIGH;
    }
    else
    {
      AS5047D_HORI_MOSI_LOW;
    }
    as5047d_delay_nop(2);
    AS5047D_HORI_CLK_HIGH;
    as5047d_delay_nop(2);
    
    temp1 = AS5047D_HORI_MISO_READ;
    temp2 = temp2 | (temp1 << i);
    
    temp1 = 0;
    temp  = 0;
  }
  AS5047D_HORI_CLK_LOW;
  AS5047D_HORI_MOSI_LOW;
  //صһָظ
  return temp2;
}

/// ˮƽ
///
/// as5047dص
/// @param   
/// @return ؽյ
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_hori_receive_package()
{
  unsigned int temp = 0;
  unsigned int temp1 = 0;
  AS5047D_HORI_CLK_LOW;
  as5047d_delay_nop(2);
  for(int j = 15; j >= 0; j--)
  {
    AS5047D_HORI_CLK_HIGH;
    as5047d_delay_nop(2);
    temp = AS5047D_HORI_MISO_READ;
    temp1 = temp1 | (temp << j);
    AS5047D_HORI_CLK_LOW;
    as5047d_delay_nop(2);
    temp = 0;
  }
  AS5047D_HORI_CLK_LOW;
  return temp1;
}


/// ˮƽͶָ
///
/// Ͷȡas5047dָ
/// @param  add Ĵַ   
/// @return ͹нյ 111 1111 1111 1111
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_hori_read_command(unsigned int add)
{
  unsigned int temp = 0;
  add = as5047d_command_type(add,AS5047D_READ_COMMAND);
  add = as5047d_Parity_bit_even(add);
   //ָ
  temp = as5047d_hori_send_package(add);
  //صһָظ
  return temp;
}


/// ˮƽȡas5047dĴеֵ
///
/// ȡas5047dĴеֵ
/// @param  add Ĵַ 
/// @return ضȡļĴеֵ
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_hori_read_data(unsigned int add)
{
  
  unsigned int temp = 0;
 
  AS5047D_HORI_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_HORI_CSN_ENABLE;
  as5047d_delay_nop(4);
  
  //Ͷָ
  as5047d_hori_read_command(add);
  
  AS5047D_HORI_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_HORI_CSN_ENABLE;
  as5047d_delay_nop(4);
  
  //ȡһָõ
  temp = as5047d_hori_nop_command();
  
  AS5047D_HORI_CSN_DISABLE;
  return temp;
}


/// ˮƽдָ
///
/// as5047dдָ
/// @param  add Ĵַ   
/// @return ͹нյ 
/// @par   ޸־
///        2017-09-08
unsigned int as5047d_hori_write_command(unsigned int add)
{
  unsigned int temp = 0;
  add = as5047d_command_type(add,AS5047D_WRITE_COMMAND);
  add = as5047d_Parity_bit_even(add);
  //ָ
  temp = as5047d_hori_send_package(add);
  //صһָظ
  return temp;
}

/// ˮƽNOPָ
///
/// as5047dNOPָ
/// @param  
/// @return ͹нյ 
/// @par   ޸־
///        2017-09-08
unsigned int as5047d_hori_nop_command()
{
  unsigned int temp = 0;
  temp = as5047d_hori_send_package(AS5047D_NOP);
  //صһָظ
  return temp;
}

/// ˮƽָ
///
/// as5047dָCLEAR ERROR FLAG command
/// @param  
/// @return 1ɹ0ʧ
/// @par    ޸־
///        2017-09-08
unsigned int as5047d_hori_cef_command()
{
  unsigned int temp  = 0;
  unsigned int temp1 = 0;
  
  AS5047D_HORI_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_HORI_CSN_ENABLE;
  as5047d_delay_nop(4);
  temp = as5047d_Parity_bit_even(AS5047D_CLEAR_ERROR_FLAG);
  as5047d_hori_send_package(temp);
  
  AS5047D_HORI_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_HORI_CSN_ENABLE;
  as5047d_delay_nop(4);
  temp1 = as5047d_hori_nop_command();
  
  AS5047D_HORI_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_HORI_CSN_ENABLE;
  as5047d_delay_nop(4);
  temp1 = as5047d_hori_nop_command();
  
  AS5047D_HORI_CSN_DISABLE;
  return temp1;
}

/// ˮƽдָȡص
///
/// as5047dдָȡص
/// @param  add Ĵַ 
/// @param  data Ҫд
/// @return ͹нյ 
/// @par   ޸־
///        2017-09-08
As5047DJudgeReceivePackage as5047d_hori_write_data(unsigned int add,unsigned int data)
{
  As5047DJudgeReceivePackage temp;
  int i;
  for(i = 0; i < AS5047D_WRITE_NUM; i++)
  {
    AS5047D_HORI_CSN_DISABLE;
    as5047d_delay_nop(20);
    AS5047D_HORI_CSN_ENABLE;
    as5047d_delay_nop(20);
    
    //дָ
    as5047d_hori_write_command(add);
    //дµݣؼĴоɵ
    add = as5047d_command_type(data,AS5047D_WRITE_DATA);
    add = as5047d_Parity_bit_even(data);
    as5047d_hori_send_package(data);
    //ռĴе0X3FFF 0011 1111 1111 1111
    temp.package = as5047d_hori_nop_command();
    temp = as5047d_hori_judge_receive_package(temp.package);
    
    as5047d_delay_nop(2);
    AS5047D_HORI_CSN_DISABLE;
    
    if(temp.Operation_Result != 1)
    {
      as5047d_hori_cef_command();
      continue;
    }
    else
    {
      //ждݺ·صļĴǷͬ
      if((data & 0X3FFF) == (temp.package & 0X3FFF))
      {
        temp.Operation_Result = 1;
        break;
      }
      else
      {
        continue;
      }
    }
  }
  return temp;
}

/// ȡ̨ˮƽǶ
///
/// ȡ̨ˮƽǶ
/// @param  
/// @param  
/// @return ضȡ-1ȡʧܣֵȡɹ
/// @par   ޸־
///        2017-09-27
float as5047d_hori_get_angle()
{
  BSP_OS_SemWait(&ptz_hori_get_angle_mutex, 0u);
  float angle = 0;
  unsigned int angle1 = 0;
  unsigned int temp = 0;
  As5047DJudgeReceivePackage temp1;
  memset(&temp1, 0, sizeof(temp1));
  //ȡǶ
  temp = as5047d_hori_read_data(AS5047D_ANGLE);
  //жϽյǷ
  temp1 = as5047d_hori_judge_receive_package(temp);
  //ȷ
  if(temp1.Operation_Result == 1)
  {
    angle = (temp & 0x3FFF) * 0.02197265625;//0.02197265625 = 360.0 / 16384.0
    angle1 = (unsigned int)(angle * 1000.0);//ֻС3λ
    angle  = (float)(angle1 / 1000.0);
    BSP_OS_SemPost(&ptz_hori_get_angle_mutex);
    return angle;
  }
  BSP_OS_SemPost(&ptz_hori_get_angle_mutex);
  return -1;
}


/************************************************************************/



/// ֱ
///
/// as5047d
/// @param   
/// @return ؽյ
/// @par   ޸־
///        2017-09-08
unsigned int as5047d_vert_send_package(unsigned int package)
{
  unsigned int temp = 0;
  unsigned int temp1 = 0;
  unsigned int temp2 = 0;
  AS5047D_VERT_CLK_LOW;
  AS5047D_VERT_MOSI_LOW;
  as5047d_delay_nop(2);
  for(int i = 15; i >= 0; i--)
  {
    AS5047D_VERT_CLK_LOW;
    as5047d_delay_nop(2);
    temp = package & (1 << i);
    if(temp != 0)
    {
      AS5047D_VERT_MOSI_HIGH;
    }
    else
    {
      AS5047D_VERT_MOSI_LOW;
    }
    as5047d_delay_nop(2);
    AS5047D_VERT_CLK_HIGH;
    as5047d_delay_nop(2);
    
    temp1 = AS5047D_VERT_MISO_READ;
    temp2 = temp2 | (temp1 << i);
    
    temp1 = 0;
    temp  = 0;
  }
  AS5047D_VERT_CLK_LOW;
  AS5047D_VERT_MOSI_LOW;
  //صһָظ
  return temp2;
}

/// ֱ
///
/// as5047dص
/// @param   
/// @return ؽյ
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_vert_receive_package()
{
  unsigned int temp = 0;
  unsigned int temp1 = 0;
  AS5047D_VERT_CLK_LOW;
  as5047d_delay_nop(2);
  for(int j = 15; j >= 0; j--)
  {
    AS5047D_VERT_CLK_HIGH;
    as5047d_delay_nop(2);
    temp = AS5047D_VERT_MISO_READ;
    temp1 = temp1 | (temp << j);
    AS5047D_VERT_CLK_LOW;
    as5047d_delay_nop(2);
    temp = 0;
  }
  AS5047D_VERT_CLK_LOW;
  return temp1;
}


/// ֱͶָ
///
/// Ͷȡas5047dָ
/// @param  add Ĵַ   
/// @return ͹нյ 111 1111 1111 1111
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_vert_read_command(unsigned int add)
{
  unsigned int temp = 0;
  add = as5047d_command_type(add,AS5047D_READ_COMMAND);
  add = as5047d_Parity_bit_even(add);
   //ָ
  temp = as5047d_vert_send_package(add);
  //صһָظ
  return temp;
}


/// ֱȡas5047dĴеֵ
///
/// ȡas5047dĴеֵ
/// @param  add Ĵַ 
/// @return ضȡļĴеֵ
/// @par   ޸־
///        2017-09-07
unsigned int as5047d_vert_read_data(unsigned int add)
{
  
  unsigned int temp = 0;
 
  AS5047D_VERT_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_VERT_CSN_ENABLE;
  as5047d_delay_nop(4);
  
  //Ͷָ
  as5047d_vert_read_command(add);
  
  AS5047D_VERT_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_VERT_CSN_ENABLE;
  as5047d_delay_nop(4);
  
  //ȡһָõ
  temp = as5047d_vert_nop_command();
  
  AS5047D_VERT_CSN_DISABLE;
  return temp;
}

/// ֱдָ
///
/// as5047dдָ
/// @param  add Ĵַ   
/// @return ͹нյ 
/// @par   ޸־
///        2017-09-08
unsigned int as5047d_vert_write_command(unsigned int add)
{
  unsigned int temp = 0;
  add = as5047d_command_type(add,AS5047D_WRITE_COMMAND);
  add = as5047d_Parity_bit_even(add);
  //ָ
  temp = as5047d_vert_send_package(add);
  //صһָظ
  return temp;
}

/// ֱNOPָ
///
/// as5047dNOPָ
/// @param  
/// @return ͹нյ 
/// @par   ޸־
///        2017-09-08
unsigned int as5047d_vert_nop_command()
{
  unsigned int temp = 0;
  temp = as5047d_vert_send_package(AS5047D_NOP);
  //صһָظ
  return temp;
}

/// ֱָ
///
/// as5047dָCLEAR ERROR FLAG command
/// @param  
/// @return 1ɹ0ʧ
/// @par    ޸־
///        2017-09-08
unsigned int as5047d_vert_cef_command()
{
  unsigned int temp  = 0;
  unsigned int temp1 = 0;
  
  AS5047D_VERT_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_VERT_CSN_ENABLE;
  as5047d_delay_nop(4);
  temp = as5047d_Parity_bit_even(AS5047D_CLEAR_ERROR_FLAG);
  as5047d_vert_send_package(temp);
  
  AS5047D_VERT_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_VERT_CSN_ENABLE;
  as5047d_delay_nop(4);
  temp1 = as5047d_vert_nop_command();
  
  AS5047D_VERT_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_VERT_CSN_ENABLE;
  as5047d_delay_nop(4);
  temp1 = as5047d_vert_nop_command();
  
  AS5047D_VERT_CSN_DISABLE;
  return temp1;
}

/// ֱдָȡص
///
/// as5047dдָȡص
/// @param  add Ĵַ 
/// @param  data Ҫд
/// @return ͹нյ 
/// @par   ޸־
///        2017-09-08
As5047DJudgeReceivePackage as5047d_vert_write_data(unsigned int add,unsigned int data)
{
  As5047DJudgeReceivePackage temp;
  int i;
  for(i = 0; i < AS5047D_WRITE_NUM; i++)
  {
    AS5047D_VERT_CSN_DISABLE;
    as5047d_delay_nop(20);
    AS5047D_VERT_CSN_ENABLE;
    as5047d_delay_nop(20);
    
    //дָ
    as5047d_vert_write_command(add);
    //дµݣؼĴоɵ
    add = as5047d_command_type(data,AS5047D_WRITE_DATA);
    add = as5047d_Parity_bit_even(data);
    as5047d_vert_send_package(data);
    //ռĴе0X3FFF 0011 1111 1111 1111
    temp.package = as5047d_vert_nop_command();
    temp = as5047d_vert_judge_receive_package(temp.package);
    
    as5047d_delay_nop(2);
    AS5047D_VERT_CSN_DISABLE;
    
    if(temp.Operation_Result != 1)
    {
      as5047d_vert_cef_command();
      continue;
    }
    else
    {
      //ждݺ·صļĴǷͬ
      if((data & 0X3FFF) == (temp.package & 0X3FFF))
      {
        temp.Operation_Result = 1;
        break;
      }
      else
      {
        continue;
      }
    }
  }
  return temp;
}

/// ȡֱ̨Ƕ
///
/// ȡֱ̨Ƕ
/// @param  
/// @param  
/// @return ضȡ-1ȡʧܣֵȡɹ
/// @par   ޸־
///        2017-09-27
float as5047d_vert_get_angle()
{
  BSP_OS_SemWait(&ptz_vert_get_angle_mutex, 0u);
  float angle = 0;
  unsigned int angle1 = 0;
  unsigned int temp = 0;
  As5047DJudgeReceivePackage temp1;
  memset(&temp1, 0, sizeof(temp1));
  //ȡǶ
  temp = as5047d_vert_read_data(AS5047D_ANGLE);
  //жϽյǷ
  temp1 = as5047d_vert_judge_receive_package(temp);
  //ȷ
  if(temp1.Operation_Result == 1)
  {
    angle = (temp & 0x3FFF) * 0.02197265625;//0.02197265625 = 360.0 / 16384.0
    angle1 = (unsigned int)(angle * 1000.0);//ֻС3λ
    angle  = (float)(angle1 / 1000.0);
    BSP_OS_SemPost(&ptz_vert_get_angle_mutex);
    return angle;
  }
  BSP_OS_SemPost(&ptz_vert_get_angle_mutex);
  return -1;
}



/********************************************************************************/
/********************************************************************************/
/********************************************************************************/
//ֱͨʱӶȡǶ
unsigned int as5047d_hori_clk_read_angle()
{
  unsigned int temp1 = 0;
  unsigned int temp2 = 0;
  AS5047D_HORI_CLK_LOW;
  AS5047D_HORI_MOSI_HIGH;
  as5047d_delay_nop(2);
  for(int i = 15; i >= 0; i--)
  {
    AS5047D_HORI_CLK_LOW;
    as5047d_delay_nop(2);
    AS5047D_HORI_CLK_HIGH;
    as5047d_delay_nop(2);
    
    temp1 = AS5047D_HORI_MISO_READ;
    temp2 = temp2 | (temp1 << i);
    
    temp1 = 0;
  }
  AS5047D_HORI_CLK_LOW;
  return temp2;
}

//޸ĶȡǶȵķʽǶȶȡٶ
unsigned int as5047d_hori_read_data_a()
{
  
  unsigned int temp = 0;
 
  AS5047D_HORI_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_HORI_CSN_ENABLE;
  as5047d_delay_nop(4);
  
  //Ͷָ
  temp = as5047d_hori_clk_read_angle();
  
  AS5047D_HORI_CSN_DISABLE;
  return temp;
}

//µжϷʽ
As5047DJudgeReceivePackage as5047d_hori_judge_receive_package_a(unsigned int package)
{
  As5047DJudgeReceivePackage temp1;
  memset(&temp1,0,sizeof(temp1));
  
  temp1.package = package;
  temp1.Operation_Result = 1;
  //жݰżУǷȷ
  //Ч
  if(package != as5047d_Parity_bit_even(package))
  {
    temp1.parity_error_package = 1;
    temp1.Operation_Result = 0;
  }
  return temp1;
}



//µĶȡǶȷʽ
float as5047d_hori_get_angle_a()
{
  BSP_OS_SemWait(&ptz_hori_get_angle_mutex, 0u);
  float angle = 0;
  unsigned int angle1 = 0;
  unsigned int temp = 0;
  As5047DJudgeReceivePackage temp1;
  memset(&temp1, 0, sizeof(temp1));
  //ȡǶ
  temp = as5047d_hori_read_data_a();
  //жϽյǷ
  temp1 = as5047d_hori_judge_receive_package_a(temp);
  //ȷ
  if(temp1.Operation_Result == 1)
  {
    angle = (temp & 0x3FFF) * 0.02197265625;//0.02197265625 = 360.0 / 16384.0
    angle1 = (unsigned int)(angle * 1000.0);//ֻС3λ
    angle  = (float)(angle1 / 1000.0);
    BSP_OS_SemPost(&ptz_hori_get_angle_mutex);
    return angle;
  }
  BSP_OS_SemPost(&ptz_hori_get_angle_mutex);
  return -1;
}

/********************************************************************************/
/********************************************************************************/
/********************************************************************************/

//ֱͨʱӶȡǶ
unsigned int as5047d_vert_clk_read_angle()
{
  unsigned int temp1 = 0;
  unsigned int temp2 = 0;
  AS5047D_VERT_CLK_LOW;
  AS5047D_VERT_MOSI_HIGH;
  as5047d_delay_nop(2);
  for(int i = 15; i >= 0; i--)
  {
    AS5047D_VERT_CLK_LOW;
    as5047d_delay_nop(2);
    AS5047D_VERT_CLK_HIGH;
    as5047d_delay_nop(2);
    
    temp1 = AS5047D_VERT_MISO_READ;
    temp2 = temp2 | (temp1 << i);
    
    temp1 = 0;
  }
  AS5047D_VERT_CLK_LOW;
  return temp2;
}

//޸ĶȡǶȵķʽǶȶȡٶ
unsigned int as5047d_vert_read_data_a()
{
  
  unsigned int temp = 0;
 
  AS5047D_VERT_CSN_DISABLE;
  as5047d_delay_nop(4);
  AS5047D_VERT_CSN_ENABLE;
  as5047d_delay_nop(4);
  
  //Ͷָ
  temp = as5047d_vert_clk_read_angle();
  
  AS5047D_VERT_CSN_DISABLE;
  return temp;
}

//µжϷʽ
As5047DJudgeReceivePackage as5047d_vert_judge_receive_package_a(unsigned int package)
{
  As5047DJudgeReceivePackage temp1;
  memset(&temp1,0,sizeof(temp1));
  
  temp1.package = package;
  temp1.Operation_Result = 1;
  //жݰżУǷȷ
  //Ч
  if(package != as5047d_Parity_bit_even(package))
  {
    temp1.parity_error_package = 1;
    temp1.Operation_Result = 0;
  }
  return temp1;
}



//µĶȡǶȷʽ
float as5047d_vert_get_angle_a()
{
  BSP_OS_SemWait(&ptz_vert_get_angle_mutex, 0u);
  float angle = 0;
  unsigned int angle1 = 0;
  unsigned int temp = 0;
  As5047DJudgeReceivePackage temp1;
  memset(&temp1, 0, sizeof(temp1));
  //ȡǶ
  temp = as5047d_vert_read_data_a();
  //жϽյǷ
  temp1 = as5047d_vert_judge_receive_package_a(temp);
  //ȷ
  if(temp1.Operation_Result == 1)
  {
    angle = (temp & 0x3FFF) * 0.02197265625;//0.02197265625 = 360.0 / 16384.0
    angle1 = (unsigned int)(angle * 1000.0);//ֻС3λ
    angle  = (float)(angle1 / 1000.0);
    BSP_OS_SemPost(&ptz_vert_get_angle_mutex);
    return angle;
  }
  BSP_OS_SemPost(&ptz_vert_get_angle_mutex);
  return -1;
}

/********************************************************************************/
/********************************************************************************/
/********************************************************************************/

