#ifndef _CONFIG_INFO_H_
#define _CONFIG_INFO_H_

#include "comm_types.h"

#ifdef __cplusplus
extern "C" {
#endif
#pragma pack(push,1)

#define EXT_FLASH_SECTOR_SIZE   (1024*4)
#define EXT_FLASH_BLOCK_NUM     (0)
#define EXT_FLASH_BLOCK_NUM_1   (1)  
   
//ƬflashʱʹõĵַϢ
#define UPGRADE_FLASH_BUFF_BEGIN_ADDR (1024*1024*1)//1M-2M      
#define UPGRADE_FLASH_BUFF_END_ADDR (1024*1024*2-1)
#define UPGRADE_FLASH_BUFF_SIZE (1024*1024*1)
#define UPGRADE_FLASH_BUFF_BEGIN_BLOCK (UPGRADE_FLASH_BUFF_BEGIN_ADDR / Flash_BLOCKBYTE_LENGTH)

//bootloaderַϢ
#define BOOTLOADER_ADDR_BEGIN (0)
#define BOOTLOADER_ADDR_END (1024*58-1)
#define BOOTLOADER_SECTOR_BEGIN (BOOTLOADER_ADDR_BEGIN / ON_CHIP_FLASH_SECTOR_SIZE) //Bootloaderʼsector

//ӦóַϢ
#define APP_ADDR_BEGIN (1024*64)
#define APP_ADDR_END (1024*500-1)//500k
#define APP_SECTOR_BEGIN (APP_ADDR_BEGIN / ON_CHIP_FLASH_SECTOR_SIZE) //Ӧóʼsector

//ȫַ֤Ϣ--w25q128
#define CERT_ADDR_BEGIN (1024*4*2)//0block 2sector(4k) ͷ1sector
#define CERT_ADDR_END   (1024*4*3-1)
#define CERT_SECTOR_BEGIN (CERT_ADDR_BEGIN / EXT_FLASH_SECTOR_SIZE)//ȫоƬ֤

//ԿַϢ--w25q128
#define KEY_ADDR_BEGIN  (1024*4*4)//0block 4sector(4k) ͷ3sector
#define KEY_ADDR_END    (1024*4*5-1)
#define KEY_SECTOR_BEGIN (KEY_ADDR_BEGIN / EXT_FLASH_SECTOR_SIZE)//ȫоƬԿ

//ļַϢ--w25q128
#define CFG_FILE_ADDR_BEGIN  (1024*4*6)//0block 6sector(4k) ͷ5sector
#define CFG_FILE_ADDR_END    (1024*4*7-1)
#define CFG_FILE_SECTOR_BEGIN (CFG_FILE_ADDR_BEGIN / EXT_FLASH_SECTOR_SIZE)//ļ

//Ӧóͷ洢ַϢӦóǰ2sector
#define APP_PKG_HEAD_BEGIN (APP_ADDR_BEGIN - ON_CHIP_FLASH_SECTOR_SIZE)
#define APP_PKG_HEAD_END (APP_ADDR_BEGIN-1)
#define APP_PKG_HEAD_SECTOR_BEGIN (APP_PKG_HEAD_BEGIN/ON_CHIP_FLASH_SECTOR_SIZE)//ͷ洢sector
#define APP_PGK_HEAD ((hy_release_file_head*)APP_PKG_HEAD_BEGIN)

//ȫ֤ͷ洢ַϢоƬȫ֤ǰ1sector
#define CERT_HEAD_BEGIN (CERT_ADDR_BEGIN - EXT_FLASH_SECTOR_SIZE)
#define CERT_HEAD_END (CERT_ADDR_BEGIN-1)
#define CERT_HEAD_SECTOR_BEGIN (CERT_HEAD_BEGIN/EXT_FLASH_SECTOR_SIZE)//ͷ洢sector

//Կͷ洢ַϢԿǰ2sector
#define KEY_HEAD_BEGIN (KEY_ADDR_BEGIN - EXT_FLASH_SECTOR_SIZE)
#define KEY_HEAD_END (KEY_ADDR_BEGIN-1)
#define KEY_HEAD_SECTOR_BEGIN (KEY_HEAD_BEGIN/EXT_FLASH_SECTOR_SIZE)//ͷ洢sector

//ļͷ洢ַϢļǰ2sector
#define CFG_FILE_HEAD_BEGIN (CFG_FILE_ADDR_BEGIN - EXT_FLASH_SECTOR_SIZE)
#define CFG_FILE_HEAD_END (CFG_FILE_ADDR_BEGIN-1)
#define CFG_FILE_HEAD_SECTOR_BEGIN (CFG_FILE_HEAD_BEGIN/EXT_FLASH_SECTOR_SIZE)//ͷ洢sector  
    
#define HY_RELEASE_FILE_FLAG (*((u_int32_t *)"HYPK"))
  
#define HY_PKG_TYPE_APP         1 //ļapplicationӦó
#define HY_PKG_TYPE_BOOT_LOADER 2 //ļbootloader
#define HY_PKG_TYPE_CERT        3 //оƬ֤
#define HY_PKG_TYPE_PUB_KEY     4 //Կ
#define HY_PKG_TYPE_CFG_FILE    5 //ļ 
  
//ļͷ--------------------------------------------------------------------
typedef struct _hy_release_file_head{
        u_int32_t flag;                 // 4byte ־Ϊ"HYPK"	ļԴ˿ͷΪǷǷļ
        u_int32_t head_len;             //4byte	ͷ	ļͷȣ"־"
        u_int8_t file_type;             //1byte	ļͣ1	1Ӧó 2:bootloader
        u_int16_t file_format_ver;      //2byte ļʽ汾ţ1	ȷļĴʽ
        u_int8_t hardware_type[2];      //2byte	Ӳ	õӲ
        u_int16_t hardware_ver;         //2byte	Ӳ汾	õӲ汾
        u_int32_t software_ver;         //4byte	汾	Ӧ汾
        u_int32_t data_len;             //4byte ݳ  2ֽڵcrc
        u_int32_t addr;                 //4byte дַ
        u_int8_t head_checksum;         //1byte	ͷУ	ݵchecksum"־"ֽ
        u_int8_t data[1];               //
}hy_release_file_head;

#define RELEASE_PKG_HEAD_SIZE(x) ((char *)(&(x)->head_checksum) - (char *)(x) + sizeof(u_int8_t))//
#define RELEASE_PKG_CRC16(x) (*(u_int16_t *)(&((x)->data[(x)->data_len])))
#define RELEASE_PKG_TOTAL_LEN(x) ((x)->data_len + RELEASE_PKG_HEAD_SIZE(x)+sizeof(u_int16_t))//ܳ

//
BOOL get_cert1_from_file(void);
BOOL get_key_from_file(void);
BOOL get_system_config_from_file(void);
BOOL write_file_to_ext_flash(hy_release_file_head *pkg_head);
BOOL write_pack_head_to_ext_flash(hy_release_file_head *pkg_head);
BOOL app_crc_OK(u_int8_t file_type);
BOOL ext_flash_erase(hy_release_file_head *pkg_head);
u_int8_t upgrade_pkg_head_checksum_OK(hy_release_file_head *pkg_head);
BOOL pack_head_verify(u_int8_t file_type);
void erase_ext_flash(u_int8_t block_begin,u_int32_t total_len);
#pragma pack(pop)

#ifdef __cplusplus
}
#endif 
#endif //_CONFIG_INFO_H_