///Copyright (c) 2022, ĴԴͨ޹˾ 
///All rights reserved. 
///@file        mb85rc64.h 
///@brief       mb85rc64 洢
///
///@details     
///@note        
///@author      lqc
///@date        2022/05/26
///
///@version		v1.0 2022/05/26 ʼ汾

#include "mb85rc64.h"


/*
  @ brief  ʱ
  @ param  
  @ return
  @ note   2022-5-23
*/
static void delay_us(int us)
{
  for(int i = 0; i < us; i++ )
  {
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
  }  
}

/*
  @ brief  оƬʼ
  @ param  
  @ return
  @ note  2022-05-26
*/
void mb85rc64_gpio_init()
{
  //ʱ
  rcu_periph_clock_enable(RCU_GPIOB);
  //Ϊģʽ:PB6
  gpio_mode_set(GPIOB, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_6);
  gpio_output_options_set(GPIOB, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_6);
  
  //PB7ģʽ
  gpio_mode_set(GPIOB, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_7);
  gpio_output_options_set(GPIOB, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_7);
  
  MB85RC64_SCL_HIGH;
  MB85RC64_SDA_HIGH;
}

/*
  @ brief  SDAΪģʽ
  @ param  
  @ return 
  @ note  2022-5-26 lqc
*/
static void mb85rc64_sda_output()
{
  gpio_mode_set(GPIOB, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_7);
  gpio_output_options_set(GPIOB, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_7);
  MB85RC64_SDA_HIGH;
}

/*
  @ brief  SDAΪģʽ
  @ param  
  @ return 
  @ note   2022-5-26 lqc
*/
static void mb85rc64_sda_input()
{
  gpio_mode_set(GPIOB, GPIO_MODE_INPUT, GPIO_PUPD_PULLUP, GPIO_PIN_7);
  gpio_output_options_set(GPIOB, GPIO_PUPD_NONE, GPIO_OSPEED_50MHZ, GPIO_PIN_7);
}

/*
  @ brief  I2C startź
  @ param  
  @ return 
  @ note  2022-5-25
*/
static void i2c_start()
{
  MB85RC64_SDA_HIGH;
  delay_us(5);
  MB85RC64_SCL_HIGH;
  delay_us(5);
  MB85RC64_SDA_LOW;
  delay_us(4);
}

/* 
  @ brief  I2C stopź
  @ param
  @ return
  @ note  2022-05-25
*/
static void i2c_stop()
{
  MB85RC64_SDA_LOW;
  delay_us(5);
  MB85RC64_SCL_HIGH;
  delay_us(5);
  MB85RC64_SDA_HIGH;  
  delay_us(4);
}

/*
  @ brief  mb85rc64ݲACKź
  @ param  SDA豸Ϊ͵ƽʾӦ
  @ return
  @ note  2022-05-26
*/
static void mb85rc64_ack()
{
  int i = 0;
  mb85rc64_sda_input();
  delay_us(5);
  MB85RC64_SCL_HIGH;
  delay_us(5);
  while((MB85RC64_SDA_GET) && i<1000)
  {
    i++;
  }
  delay_us(5);
  MB85RC64_SCL_LOW;
  delay_us(5);
  mb85rc64_sda_output();
}

/*
  @ brief  ȡݷACKź,SDAΪ͵ƽ
  @ param  SCL½ط
  @ return 
  @ note   2022-05-26
*/
static void master_ack()
{
  MB85RC64_SDA_LOW;
  delay_us(5);
  MB85RC64_SCL_HIGH;
  delay_us(5);
  MB85RC64_SCL_LOW;
  delay_us(5);
}

/*
  @ brief ȡϣno_ackźţSDAΪߵƽ
  @ param  
  @ return
  @ note   2022-05-26
*/
static void master_no_ack()
{
  MB85RC64_SDA_HIGH;
  delay_us(5);
  MB85RC64_SCL_HIGH;
  delay_us(5);
  MB85RC64_SCL_LOW;
  delay_us(5);
}

/*
  @ brief дһֽ
  @ param
  @ return
  @ note  2022-05-26
*/
static void mb85rc64_write_byte(uint8_t byte)
{
  for(int i = 0; i < 8; i++)
  {
    MB85RC64_SCL_LOW;
    delay_us(5);
    if(byte & 0x80)
    {
      MB85RC64_SDA_HIGH;
    }
    else
    {
      MB85RC64_SDA_LOW;
    }
    
    MB85RC64_SCL_HIGH;
    delay_us(5);
    byte <<= 1;
  }
  MB85RC64_SCL_LOW;
}

/*
  @ brief һֽ
  @ param
  @ return
  @ note  2022-05-26
*/
static uint8_t mb85rc64_read_byte()
{
  uint8_t value = 0;
  MB85RC64_SCL_LOW;
  delay_us(5);
  mb85rc64_sda_input();
  
  
  for(int i = 0; i < 8; i++)
  {
    
    value <<= 1;
    MB85RC64_SCL_LOW;
    delay_us(5);
    MB85RC64_SCL_HIGH;
    
    delay_us(5);
    if(MB85RC64_SDA_GET)
    {
      value = value | 0x01;
    }
    else {
      value = value & 0xfe;
    }
  }
   MB85RC64_SCL_LOW;
  delay_us(5);
  mb85rc64_sda_output();
  return value;
}

/*
  @ brief ݣҳд
  @ param  addr:ݵĵַdata:豣ݣdata_lenݵĳ
  @ return
  @ note   2022-05-27
*/
char mb85rc64_page_write(unsigned short int addr, unsigned char* data, int data_len)
{
  uint8_t addr_H = 0;
  uint8_t addr_L = 0;
  
  addr_H = (addr >> 8) & 0x00ff;
  addr_L = addr & 0x00ff;
  //ź
  i2c_start();
  //дַ,R/Wλ=0
  mb85rc64_write_byte(MB85RC64_ADDRESS_WRITE);
  //ackź
  mb85rc64_ack();
  //д8λַ
  mb85rc64_write_byte(addr_H);
  //ackź
  mb85rc64_ack();
  //д8λַ
  mb85rc64_write_byte(addr_L);
  //ackź
  mb85rc64_ack();
  for(int i = 0; i < data_len; i++)
  {
    mb85rc64_write_byte(*data);
    mb85rc64_ack();
    data++;
  }
  //ֹͣź
  i2c_stop();
  return 1;
}

/*
  @ brief  ȡ ˳ȡַָ
  @ param   addr :Ҫȡݵĵַdata:, data_len:ݳ
  @ return 
  @ note   2022-05-27 lqc
*/
char mb85rc64_add_read(unsigned short int addr, unsigned char *data, int data_len)
{
  uint8_t addr_H = 0;
  uint8_t addr_L = 0;
  
  addr_H = (addr >> 8) & 0x00ff;
  addr_L = addr & 0x00ff;
  //ź
  i2c_start();
  //дַR/WλΪ0
  mb85rc64_write_byte(MB85RC64_ADDRESS_WRITE);
  //ackź
  mb85rc64_ack();
  //д8λַ
  mb85rc64_write_byte(addr_H);
  //ackź
  mb85rc64_ack();
  //д8λַ
  mb85rc64_write_byte(addr_L);
  //ackź
  mb85rc64_ack();
  
  //ź
  i2c_start();
  //дַR/WΪΪ1
  mb85rc64_write_byte(MB85RC64_ADDRESS_READ);
  //ackź
  mb85rc64_ack();
  for(int i = 0; i < data_len; i++)
  {
    //
    data[i] = mb85rc64_read_byte();
    if(i == data_len - 1)
    {
      master_no_ack();
    }
    else
    {
      master_ack();
    }
  }
  //ֹͣź
  i2c_stop();
  return 1;
}

void read_mb_id(uint8_t* buff)
{
  i2c_start();
  mb85rc64_write_byte(0xf8);
  mb85rc64_ack();
  mb85rc64_write_byte(MB85RC64_ADDRESS_WRITE);
  mb85rc64_ack();
  i2c_start();
  mb85rc64_write_byte(0xf9);
  mb85rc64_ack();
  for(int i = 0; i < 3; i++)
  {
    //
    buff[i] = mb85rc64_read_byte();
    if(i == 3 - 1)
    {
      master_no_ack();
    }
    else
    {
      master_ack();
    }
  }
  i2c_stop();
}
