#include "ptz_type_select.h"
#include "ptz_struct.h"
#include "ptz_default_value.h"
#include "tmc2160.h"
#include "w25q128.h"


#ifdef TMC2160
TMC2160Parameter tmc2160_parameter;
TMC2160Regis hori_regis;
TMC2160Regis vert_regis;
unsigned long int version_hori=0;
unsigned long int version_vert=0;

static BSP_OS_SEM ptz_tmc2160_mutex;//Դ
static void delay_time(int time)
{
  for(int i = 0; i < time; i ++)
    {//Ƶ200MHZ
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
       asm("nop");
    }  
}


///ϵԶλȫ
void h_tmc2160_power_on()
{
  //Դ
  TMC2160_H_POWER_ON;
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  //====ʼ
  tmc2160_data_init();
  
  TMC2160_HORI_CSN_DISABLE;
  TMC2160_HORI_DISABLE;
  
  //====ϵȫ״̬־
  tmc2160_write_register(TMC2160_HORI, TMC2160_GSTAT, 0);
  OSTimeDlyHMSM(0u, 0u, 0u, 2u);
  //====Ĵͨ
  //ˮƽ
  tmc2160_write_register(TMC2160_HORI, TMC2160_GLOBAL_SCALER, tmc2160_parameter.hori_global_scaler);
  tmc2160_write_register(TMC2160_HORI, TMC2160_GCONF, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_PWMCONF, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_DRV_CONF, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_TPOWERDOWN, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_CHOPCONF, TMC2160_1_16_STEP);//ϸĬ16
  tmc2160_write_register(TMC2160_HORI, TMC2160_IHOLD_IRUN, tmc2160_parameter.hori_work_torque);//Ĭֵ=20/32*2.3A
  
  tmc2160_write_register(TMC2160_HORI, TMC2160_TPWMTHRS, 0);
  #ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      tmc2160_write_register(TMC2160_HORI, TMC2160_SHORT_CONF, 0);
  #endif
  
}

///ϵԶλȫ
void v_tmc2160_power_on()
{
  //Դ
  TMC2160_V_POWER_ON;
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  //====ʼ
  tmc2160_data_init();
  
  TMC2160_VERT_CSN_DISABLE;
  TMC2160_VERT_DISABLE;
  
  //====ϵȫ״̬־
  tmc2160_write_register(TMC2160_VERT, TMC2160_GSTAT, 0);
  OSTimeDlyHMSM(0u, 0u, 0u, 2u);
  //====Ĵͨ
  //ֱ
  tmc2160_write_register(TMC2160_VERT, TMC2160_GLOBAL_SCALER, tmc2160_parameter.vert_global_scaler);
  tmc2160_write_register(TMC2160_VERT, TMC2160_GCONF, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_PWMCONF, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_DRV_CONF, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_TPOWERDOWN, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_CHOPCONF, TMC2160_1_16_STEP);//ϸĬ16
  tmc2160_write_register(TMC2160_VERT, TMC2160_IHOLD_IRUN, tmc2160_parameter.vert_work_torque);//Ĭֵ=20/32*2.3A
  
  tmc2160_write_register(TMC2160_VERT, TMC2160_TPWMTHRS, 0);
  #ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      tmc2160_write_register(TMC2160_VERT, TMC2160_SHORT_CONF, 0);
  #endif
  
}


///===== ʼ =====
///ϵԶλȫ
void tmc2160_init()
{
  BSP_OS_SemCreate(&ptz_tmc2160_mutex,1u,"ptz_tmc2160_mutex");
  
     //ʱ
  rcu_periph_clock_enable(RCU_GPIOA);
  rcu_periph_clock_enable(RCU_GPIOC);
  rcu_periph_clock_enable(RCU_GPIOD);
  rcu_periph_clock_enable(RCU_GPIOE);
  
  //GDİԽ޸ġԴţĶϵ縴λ
  gpio_mode_set(GPIOE, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_0);//ˮƽԴ
  gpio_mode_set(GPIOE, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_1);//ֱԴ
  gpio_output_options_set(GPIOE, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_0| GPIO_PIN_1);
  //Դ
  TMC2160_H_POWER_ON;
  TMC2160_V_POWER_ON;
  OSTimeDlyHMSM(0u, 0u, 0u, 100u);
  
  //====ʼ
  tmc2160_data_init();
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  //SPI
  gpio_mode_set(GPIOE, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_13);//CLK
  gpio_mode_set(GPIOE, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_14);//SDI
  gpio_mode_set(GPIOE, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_15);//SDOӳ
  gpio_output_options_set(GPIOE, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_13| GPIO_PIN_14);
  //====ˮƽʼ
  gpio_mode_set(GPIOD, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_15);//H_CSN
  gpio_mode_set(GPIOD, GPIO_MODE_INPUT, GPIO_PUPD_PULLUP, GPIO_PIN_14);//DIAG1
  gpio_mode_set(GPIOD, GPIO_MODE_INPUT, GPIO_PUPD_PULLUP, GPIO_PIN_13);//DIAG0
  gpio_mode_set(GPIOD, GPIO_MODE_OUTPUT, GPIO_PUPD_PULLDOWN, GPIO_PIN_10);//DRVEN
  gpio_mode_set(GPIOD, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_11);//DIR
  gpio_output_options_set(GPIOD, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_10| GPIO_PIN_11| GPIO_PIN_5);
  //====ֱʼ
  gpio_mode_set(GPIOA, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_11);//V_CSN
  gpio_mode_set(GPIOA, GPIO_MODE_INPUT, GPIO_PUPD_PULLUP, GPIO_PIN_8);//DIAG1
  gpio_mode_set(GPIOC, GPIO_MODE_INPUT, GPIO_PUPD_PULLUP, GPIO_PIN_9);//DIAG0
  gpio_mode_set(GPIOC, GPIO_MODE_OUTPUT, GPIO_PUPD_PULLDOWN, GPIO_PIN_7);//DRVEN
  gpio_mode_set(GPIOC, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_8);//DIR
  gpio_output_options_set(GPIOC, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_7| GPIO_PIN_8);
  gpio_output_options_set(GPIOA, GPIO_OTYPE_PP, GPIO_OSPEED_50MHZ, GPIO_PIN_11);
  
  TMC2160_HORI_CSN_DISABLE;
  TMC2160_HORI_DISABLE;
  TMC2160_VERT_CSN_DISABLE;
  TMC2160_VERT_DISABLE;
  
  //====ϵȫ״̬־
  tmc2160_write_register(TMC2160_HORI, TMC2160_GSTAT, 0);
  OSTimeDlyHMSM(0u, 0u, 0u, 1u);
  tmc2160_write_register(TMC2160_VERT, TMC2160_GSTAT, 0);
  OSTimeDlyHMSM(0u, 0u, 0u, 1u);
  //====Ĵͨ
  //ˮƽ
  tmc2160_write_register(TMC2160_HORI, TMC2160_GLOBAL_SCALER, tmc2160_parameter.hori_global_scaler);
  tmc2160_write_register(TMC2160_HORI, TMC2160_GCONF, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_PWMCONF, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_DRV_CONF, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_TPOWERDOWN, 0);
  tmc2160_write_register(TMC2160_HORI, TMC2160_CHOPCONF, TMC2160_1_16_STEP);//ϸĬ16
  tmc2160_write_register(TMC2160_HORI, TMC2160_IHOLD_IRUN, tmc2160_parameter.hori_work_torque);//Ĭֵ=20/32*2.3A
  
  tmc2160_write_register(TMC2160_HORI, TMC2160_TPWMTHRS, 0);
  #ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      tmc2160_write_register(TMC2160_HORI, TMC2160_SHORT_CONF, 0);
  #endif
  
  
  tmc2160_write_register(TMC2160_HORI, TMC2160_COOLCONF, 0);
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  //ֱ
  tmc2160_write_register(TMC2160_VERT, TMC2160_GLOBAL_SCALER, tmc2160_parameter.vert_global_scaler);
  tmc2160_write_register(TMC2160_VERT, TMC2160_GCONF, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_PWMCONF, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_DRV_CONF, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_TPOWERDOWN, 0);
  tmc2160_write_register(TMC2160_VERT, TMC2160_CHOPCONF, TMC2160_1_16_STEP);//ϸĬ16
  tmc2160_write_register(TMC2160_VERT, TMC2160_IHOLD_IRUN, tmc2160_parameter.vert_work_torque);//Ĭֵ=20/32*2.3A
  
  tmc2160_write_register(TMC2160_VERT, TMC2160_TPWMTHRS, 0);
  #ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      tmc2160_write_register(TMC2160_VERT, TMC2160_SHORT_CONF, 0);
  #endif
  tmc2160_write_register(TMC2160_VERT, TMC2160_COOLCONF, 0);
  
//  vert_regis.g_conf = tmc2160_write_hori_data(TMC2160_HORI,TMC2160_DRV_STATUS,0,0,0,0);
}

///===== дĴSPIλ40λ8λַ32λ
unsigned long int tmc2160_write_hori_data(char choice, unsigned char x1, unsigned char x2, unsigned char x3,unsigned char x4,unsigned char x5)
{//choiceѡx2/x3/x4/x5дĴ
  SPIpacka packa;
  unsigned long int dat=0;
  unsigned char datak[5] = {0};
   char i,j,k;
  unsigned char temp=0;
  packa.data[0] = x1;//Ĵַλ
  packa.data[1] = x2;//Ĵλ
  packa.data[2] = x3;//Ĵλ
  packa.data[3] = x4;//Ĵλ
  packa.data[4] = x5;//Ĵλ
  for(k = 0; k < 2; k++)
  {//2д룬һȷĴдɹǵǰSPIдʱͬʱĴ᷵һдݣɴʵַΪǰд
    TMC2160_VERT_CSN_DISABLE;
    TMC2160_HORI_CSN_ENABLE;
    delay_time(2);
    TMC2160_SCLK_HIGH;
    delay_time(2);
//    //Ƭѡ
//    if(choice == TMC2160_HORI)
//    {
//      TMC2160_HORI_CSN_ENABLE;
//    }else{//TMC2160_VERT
//      TMC2160_VERT_CSN_ENABLE;
//    }
    delay_time(2);
    TMC2160_SCLK_LOW;
     
    delay_time(10);

    for(j = 0; j < 5; j++)
    {
      for(i = 0; i < 8; i++)
      {
        TMC2160_SCLK_LOW;
        if((packa.data[j] & 0x80) != 0)
        {
          TMC2160_SDATI_1;
        }else{
          TMC2160_SDATI_0;
        }
        packa.data[j] = packa.data[j] << 1;
        delay_time(2);
        TMC2160_SCLK_HIGH;
        temp = TMC2160_SDATO_READ;
        datak[j] = datak[j] | (temp << (7-i));
        delay_time(2);
      }
    }
    TMC2160_SCLK_HIGH;
    delay_time(2); 
//Ƭѡʧ
    TMC2160_HORI_CSN_DISABLE;
    
    dat = datak[0];
    dat = (dat << 8) | datak[1];
    dat = (dat << 8) | datak[2];
    dat = (dat << 8) | datak[3];
    dat = (dat << 8) | datak[4];
//    dat = datak[4];
    
  }
  return dat;
}

///===== SPIλ40λ8λַ32λ
unsigned long int tmc2160_write_vert_data(char choice, unsigned char x1, unsigned char x2, unsigned char x3,unsigned char x4,unsigned char x5)
{//choiceѡx2/x3/x4/x5дĴ
  SPIpacka packa;
  unsigned long int dat=0;
  unsigned char datak[5] = {0};
   char i,j,k;
  unsigned char temp=0;
  packa.data[0] = x1;//0x90;
  packa.data[1] = x2;//0xAB;
  packa.data[2] = x3;//0xef;
  packa.data[3] = x4;//0xCD;
  packa.data[4] = x5;//0xbc;
  for(k = 0; k < 2; k++)
  {//3д
    TMC2160_HORI_CSN_DISABLE;
    TMC2160_VERT_CSN_ENABLE;
    delay_time(2);
    TMC2160_SCLK_HIGH;
    delay_time(2);
//    //Ƭѡ
//    if(choice == TMC2160_HORI)
//    {
//      TMC2160_HORI_CSN_ENABLE;
//    }else{//TMC2160_VERT
//      TMC2160_VERT_CSN_ENABLE;
//    }
    delay_time(2);
    TMC2160_SCLK_LOW;
     
    delay_time(10);

    for(j = 0; j < 5; j++)
    {
      for(i = 0; i < 8; i++)
      {
        TMC2160_SCLK_LOW;
        if((packa.data[j] & 0x80) != 0)
        {
          TMC2160_SDATI_1;
        }else{
          TMC2160_SDATI_0;
        }
        packa.data[j] = packa.data[j] << 1;
        delay_time(2);
        TMC2160_SCLK_HIGH;
        temp = TMC2160_SDATO_READ;
        datak[j] = datak[j] | (temp << (7-i));
        delay_time(2);
      }
    }
    TMC2160_SCLK_HIGH;
    delay_time(2); 
//Ƭѡʧ
    TMC2160_VERT_CSN_DISABLE;
    
    dat = datak[0];
    dat = (dat << 8) | datak[1];
    dat = (dat << 8) | datak[2];
    dat = (dat << 8) | datak[3];
    dat = (dat << 8) | datak[4];
//    dat = datak[4];
    
  }
  return dat;
}

///===== ˮƽת
char tmc2160_set_hori_dir(char dir)
{
  if (dir == TMC2160_MOTOR_DIR_FWD)
  {//ת
    TMC2160_HORI_DIR_F; return 1;
  }
  if (dir == TMC2160_MOTOR_DIR_REV)
  {//ת
    TMC2160_HORI_DIR_R; return 1;
  }
  delay_time(2);
  return 0;
}
///===== ֱת
char tmc2160_set_vert_dir(char dir)
{
  if (dir == TMC2160_MOTOR_DIR_FWD)
  {//ת
    TMC2160_VERT_DIR_F; return 1;
  }
  if (dir == TMC2160_MOTOR_DIR_REV)
  {//ת
    TMC2160_VERT_DIR_R; return 1;
  }
  delay_time(2);
  return 0;
}

///===== ˮƽʹ
char tmc2160_hori_motor_enable(char state)
{
  if (state == TMC2160_MOTOR_ENABLE)
  {//
    TMC2160_HORI_ENABLE; return 1;   
  }
  if (state == TMC2160_MOTOR_DISABLE)
  {//رյ
    TMC2160_HORI_DISABLE; return 1;
  }
  delay_time(2);
  return 0;
}
///===== ֱʹ
char tmc2160_vert_motor_enable(char state)
{
  if (state == TMC2160_MOTOR_ENABLE)
  {//
    TMC2160_VERT_ENABLE; return 1;   
  }
  if (state == TMC2160_MOTOR_DISABLE)
  {//رյ
    TMC2160_VERT_DISABLE; return 1;
  }
  delay_time(2);
  return 0;
}


///===== дĴ,modeΪĴַ,dataΪϸֵȼchoiceΪƬѡ
char tmc2160_write_register(char choice, unsigned char mode, unsigned char data)
{
  u_int8_t buff[5] = {0x00,0x00,0x00,0x00,0x00};
  BSP_OS_SemWait(&ptz_tmc2160_mutex, 0u);

  switch (mode)
  {
    case TMC2160_GCONF:
      buff[0] = TMC2160_GCONF + 0x80;
      buff[1] = 0x00;
      buff[2] = 0x00;
#ifdef PTZ_SUPER_LIGHT_WORM_STEP_TMC2160_AS5047D_24V
      buff[3] = 0x01;//011/16
#endif
      
#ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      buff[3] = 0x41;//411/32
#endif
      buff[4] = 0x4c;//DIAG0ԤDIAG1תźţ͵ƽЧԤʱָʾ48
      if(choice == TMC2160_HORI)
      {//д
        hori_regis.g_conf = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.g_conf = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
      
    case TMC2160_GSTAT://ȫ״̬־д1
      buff[0] = TMC2160_GSTAT +0x80;
      buff[1] = 0xff;
      buff[2] = 0xff;
      buff[3] = 0xff;
      buff[4] = 0xff;
      if(choice == TMC2160_HORI)
      {
        hori_regis.gstae = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.gstae = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
      
    case TMC2160_DRV_CONF://ն¶ȵ
      buff[0] = TMC2160_DRV_CONF +0x80;
      buff[1] = 0x00;      
#ifdef PTZ_SUPER_LIGHT_WORM_STEP_TMC2160_AS5047D_24V
      buff[2] = 0x0c;//3c;//0x24;//0x24;//28,08
      buff[3] = 0x04;//04
#endif
      
#ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      buff[2] = 0x38;//0x24;//38,
      buff[3] = 0x02;//0x04;//02
#endif
      buff[4] = 0x00;//0x10;//0x10;//00
      if(choice == TMC2160_HORI)
      {
        hori_regis.drv_conf = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.drv_conf = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
      
    case TMC2160_GLOBAL_SCALER://ȫţ0
      buff[0] = TMC2160_GLOBAL_SCALER +0x80;
      buff[1] = 0x00;
      buff[2] = 0x00;
      buff[3] = 0x00;
      buff[4] = data;//ȡֵ255
      if(choice == TMC2160_HORI)
      {
        hori_regis.global_scaler = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.global_scaler = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
    
    case TMC2160_IHOLD_IRUN://
      buff[0] = TMC2160_IHOLD_IRUN +0x80;
      buff[1] = 0x00;
      buff[2] = 0x06;//0x04;//ʱֹͣʱϵ磬ɷֹԶת
      buff[3] = data;//е=data/32*4.7AӦ0.05ŷ
      buff[4] = (data>>1);//ֹ0x00,Ϊеһ
      if(choice == TMC2160_HORI)
      {
        hori_regis.i_run = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.i_run = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
      
    case TMC2160_TPOWERDOWN://ʱʱ䣬2
      buff[0] = TMC2160_TPOWERDOWN +0x80;
      buff[1] = 0x00;
      buff[2] = 0x00;
      buff[3] = 0x00;
      buff[4] = 0x0a;
      if(choice == TMC2160_HORI)
      {
        hori_regis.tpowerdown = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.tpowerdown = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
      
    case TMC2160_TPWMTHRS:      //ʱ,,ٶ
      buff[0] = TMC2160_TPWMTHRS +0x80;
      buff[1] = 0x00;
      buff[2] = 0x00;
      buff[3] = 0x00;
      buff[4] = 0xf4;
      if(choice == TMC2160_HORI)
      {
        hori_regis.tpwmthrs = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.tpwmthrs = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;   
      
    case TMC2160_CHOPCONF:        //0x00010083,24-27λϸ֣24λ
      buff[0] = TMC2160_CHOPCONF +0x80;
      buff[1] = tmc2160_chopconf_data(data);
#ifdef PTZ_SUPER_LIGHT_WORM_STEP_TMC2160_AS5047D_24V
      buff[2] = 0xe1;//e1,,4Ϊ˥ʱ䣬ɽг̹
      buff[3] = 0x03;//03
      buff[4] = 0x34;//C3
#endif
      
#ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      buff[2] = 0xf1;//e1,,4Ϊ˥ʱ䣬ɽг̹
      buff[3] = 0x03;//0300
      buff[4] = 0x04;//04644TOFFȡ343hstrtͻСӣն
#endif
      if(choice == TMC2160_HORI)
      {
        hori_regis.chop_conf = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.chop_conf = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
       
  case TMC2160_COOLCONF:      ///ʱд...ܵ
      buff[0] = TMC2160_COOLCONF +0x80;
      buff[1] = 0x00;
      buff[2] = 0x00;
      buff[3] = 0xA8;
      buff[4] = 0x28;
      if(choice == TMC2160_HORI)
      {
        hori_regis.coolconf = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.coolconf = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;
             
    case  TMC2160_PWMCONF:         //0xc401321eʱ35.1KHZ
      buff[0] = TMC2160_PWMCONF +0x80;
      buff[1] = 0xd2;//c4
      buff[2] = 0x0d;//0x0E;//09,0D
      buff[3] = 0x32;
      buff[4] = 0x1e;
#ifdef PTZ_MEDIUM_WORM_STEP_TMC2160_AS5047D_24V
      buff[3] = 0x32;
      buff[4] = 0x24;//0x6e
#endif
      if(choice == TMC2160_HORI)
      {
        tmc2160_write_hori_data(choice, buff[0],buff[1],0x09,buff[3],buff[4]);
        
        hori_regis.pwmconf = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        tmc2160_write_vert_data(choice, buff[0],buff[1],0x09,buff[3],buff[4]);
        
        vert_regis.pwmconf = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }
      break;  
      
    case  TMC2160_SHORT_CONF:
      buff[0] = TMC2160_SHORT_CONF +0x80;
      buff[1] = 0x00;
      buff[2] = 0x06;
      buff[3] = 0x0c;
      buff[4] = 0x0c;
      if(choice == TMC2160_HORI)
      {
        hori_regis.short_conf = tmc2160_write_hori_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }else{
        vert_regis.short_conf = tmc2160_write_vert_data(choice, buff[0],buff[1],buff[2],buff[3],buff[4]);
      }    
      break;
  }
  
  BSP_OS_SemPost(&ptz_tmc2160_mutex);
  return 0;
}

unsigned long int tmc2160_ihold_irun_data(unsigned char data)
{//ù5λ8-12λҪ8λ
  unsigned long int write_data = 0;
  write_data = write_data | data << 8;
  return write_data;
}

unsigned long int tmc2160_chopconf_data(unsigned char data)
{//ϸֹ4λ24-27λ
  //Ĭֵд0x00010083,256ϸ
  unsigned char write_data = 0x10;//0x10;
//  write_data = 0x00010083;
  switch (data)//ʱdataΪϸֵȼ
  {
    case TMC2160_1_8_STEP:    //38Ƶ
      write_data = write_data | 0x05;// << 24;
      break;
      
    case TMC2160_1_16_STEP:   //416Ƶ
      write_data = write_data | 0x04;// << 24;
      break;
      
    case TMC2160_1_32_STEP:   //532Ƶ
      write_data = write_data | 0x03;// << 24;
      break;
      
    case TMC2160_1_64_STEP:   //664Ƶ
      write_data = write_data | 0x02;// << 24;
      break;
      
    case TMC2160_1_128_STEP:  //7128Ƶ
      write_data = write_data | 0x01;// << 24;
      break;
  }
  return write_data;
}


///===== Ч
unsigned int tmc2160_parameter_crc(TMC2160Parameter data)
{
  float crc = 0;
  unsigned int crc1 = 0;
  crc = crc + data.hori_step_1_8_en;
  crc = crc + data.hori_step_1_8_v_max;
  crc = crc + data.hori_step_1_8_v_min;
  
  crc = crc + data.hori_step_1_16_en;
  crc = crc + data.hori_step_1_16_v_max;
  crc = crc + data.hori_step_1_16_v_min;
  
  crc = crc + data.hori_step_1_32_en;
  crc = crc + data.hori_step_1_32_v_max;
  crc = crc + data.hori_step_1_32_v_min;

  crc = crc + data.hori_step_1_64_en;
  crc = crc + data.hori_step_1_64_v_max;
  crc = crc + data.hori_step_1_64_v_min;
  
  crc = crc + data.hori_step_1_128_en;
  crc = crc + data.hori_step_1_128_v_max;
  crc = crc + data.hori_step_1_128_v_min;
  
  crc = crc + data.hori_work_torque;
  crc = crc + data.hori_global_scaler;
  
  crc = crc + data.hori_acc_time_max;//0ٵٶʱ
  crc = crc + data.hori_dec_time_max;//ٶȼٵ0ʱ
  
  
  crc = crc + data.vert_step_1_8_en;
  crc = crc + data.vert_step_1_8_v_max;
  crc = crc + data.vert_step_1_8_v_min;
  
  crc = crc + data.vert_step_1_16_en;
  crc = crc + data.vert_step_1_16_v_max;
  crc = crc + data.vert_step_1_16_v_min;
  
  crc = crc + data.vert_step_1_32_en;
  crc = crc + data.vert_step_1_32_v_max;
  crc = crc + data.vert_step_1_32_v_min;

  crc = crc + data.vert_step_1_64_en;
  crc = crc + data.vert_step_1_64_v_max;
  crc = crc + data.vert_step_1_64_v_min;
  
  crc = crc + data.vert_step_1_128_en;
  crc = crc + data.vert_step_1_128_v_max;
  crc = crc + data.vert_step_1_128_v_min;
  
  crc = crc + data.vert_work_torque;
  crc = crc + data.vert_global_scaler;
  
  crc = crc + data.vert_acc_time_max;//0ٵٶʱ
  crc = crc + data.vert_dec_time_max;//ٶȼٵ0ʱ
  
  crc1 = (unsigned int)crc;
  return crc1;
}

///===== ˶洢
char tmc2160_parameter_save()
{
  TMC2160Parameter tmc2160_parameter_a;
  char i,j;
  //Ч
  tmc2160_parameter.crc = tmc2160_parameter_crc(tmc2160_parameter);
  
  //д洢
  for(i = 0; i < TMC2160_PARAMETER_SAVE_FLASH_NUM; i++)
  {
    memset(&tmc2160_parameter_a, 0, sizeof(tmc2160_parameter_a));
    write_many_data(sizeof(tmc2160_parameter),(unsigned char *)(&tmc2160_parameter),TMC2160_PARAMETER_FLASH_ADD);
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
    Flash_Read((unsigned char *)(&tmc2160_parameter_a),TMC2160_PARAMETER_FLASH_ADD,sizeof(tmc2160_parameter_a));
    if(memcmp(&tmc2160_parameter, &tmc2160_parameter_a, sizeof(tmc2160_parameter)) == 0)//ждǷȷ
    {
      break;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
  }
  //д뱸ݴ洢
  for(j = 0; j < TMC2160_PARAMETER_SAVE_FLASH_NUM; j++)
  {
    memset(&tmc2160_parameter_a, 0, sizeof(tmc2160_parameter_a));
    write_many_data(sizeof(tmc2160_parameter),(unsigned char *)(&tmc2160_parameter),TMC2160_PARAMETER_BACKUP_FLASH_ADD);
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
    Flash_Read((unsigned char *)(&tmc2160_parameter_a),TMC2160_PARAMETER_BACKUP_FLASH_ADD,sizeof(tmc2160_parameter_a));
    if(memcmp(&tmc2160_parameter, &tmc2160_parameter_a, sizeof(tmc2160_parameter)) == 0)//ждǷȷ
    {
      break;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
  }
  
  if(i < TMC2160_PARAMETER_SAVE_FLASH_NUM || j < TMC2160_PARAMETER_SAVE_FLASH_NUM)//ждǷɹ
  {
    //дɹ
    return 1;
  }
  //дʧ
  return 0;
}

///===== ˶ȡ
char tmc2160_parameter_read()
{
  char i;
  //ȴ洢ȡ
  for(i = 0; i < TMC2160_PARAMETER_READ_FLASH_NUM; i++)
  {
    memset(&tmc2160_parameter, 0, sizeof(tmc2160_parameter));
    Flash_Read((unsigned char *)(&tmc2160_parameter),TMC2160_PARAMETER_FLASH_ADD,sizeof(tmc2160_parameter));
    if(tmc2160_parameter.crc == tmc2160_parameter_crc(tmc2160_parameter) && tmc2160_parameter.crc > 0)
    {
      return 1;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 2u);
  }
  //洢ȡǴģӱݴ洢ȡ
  for(i = 0; i < TMC2160_PARAMETER_READ_FLASH_NUM; i++)
  {
    memset(&tmc2160_parameter, 0, sizeof(tmc2160_parameter));
    Flash_Read((unsigned char *)(&tmc2160_parameter),TMC2160_PARAMETER_BACKUP_FLASH_ADD,sizeof(tmc2160_parameter));
    if(tmc2160_parameter.crc == tmc2160_parameter_crc(tmc2160_parameter) && tmc2160_parameter.crc > 0)
    {
      return 1;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 2u);
  }
  return 0;
}

///===== ˶
char tmc2160_parameter_erase()
{
  TMC2160Parameter tmc2160_parameter_a;
  TMC2160Parameter tmc2160_parameter_b;
  char i, j;
 
  //洢
  for(i = 0; i < TMC2160_PARAMETER_SAVE_FLASH_NUM; i++)
  {
    memset(&tmc2160_parameter_a, 0, sizeof(tmc2160_parameter_a));
    write_many_data(sizeof(tmc2160_parameter_a),(unsigned char *)(&tmc2160_parameter_a),TMC2160_PARAMETER_FLASH_ADD);
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
    Flash_Read((unsigned char *)(&tmc2160_parameter_b),TMC2160_PARAMETER_FLASH_ADD,sizeof(tmc2160_parameter_b));
    if(memcmp(&tmc2160_parameter_a, &tmc2160_parameter_b, sizeof(tmc2160_parameter_a)) == 0)//жϲǷȷ
    {
      break;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
  }
  //ݴ洢
  for(j = 0; j < TMC2160_PARAMETER_SAVE_FLASH_NUM; j++)
  {
    memset(&tmc2160_parameter_a, 0, sizeof(tmc2160_parameter_a));
    write_many_data(sizeof(tmc2160_parameter_a),(unsigned char *)(&tmc2160_parameter_a),TMC2160_PARAMETER_BACKUP_FLASH_ADD);
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
    Flash_Read((unsigned char *)(&tmc2160_parameter_b),TMC2160_PARAMETER_BACKUP_FLASH_ADD,sizeof(tmc2160_parameter_b));
    if(memcmp(&tmc2160_parameter_a, &tmc2160_parameter_b, sizeof(tmc2160_parameter_a)) == 0)//жϲǷȷ
    {
      break;
    }
    OSTimeDlyHMSM(0u, 0u, 0u, 5u);
  }
  
  if(i < TMC2160_PARAMETER_SAVE_FLASH_NUM || j < TMC2160_PARAMETER_SAVE_FLASH_NUM)//жϲǷɹ
  {
    //ɹ
    return 1;
  }
  //ʧ
  return 0;
}

///===== ˶ֵ
char tmc2160_data_reset()
{
  tmc2160_parameter.hori_step_1_8_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.hori_step_1_8_v_max = PTZ_HORI_1_8_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.hori_step_1_8_v_min = PTZ_HORI_1_8_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.hori_step_1_16_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.hori_step_1_16_v_max = PTZ_HORI_1_16_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.hori_step_1_16_v_min = PTZ_HORI_1_16_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.hori_step_1_32_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.hori_step_1_32_v_max = PTZ_HORI_1_32_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.hori_step_1_32_v_min = PTZ_HORI_1_32_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.hori_step_1_64_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.hori_step_1_64_v_max = PTZ_HORI_1_64_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.hori_step_1_64_v_min = PTZ_HORI_1_64_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.hori_step_1_128_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.hori_step_1_128_v_max = PTZ_HORI_1_128_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.hori_step_1_128_v_min = PTZ_HORI_1_128_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.hori_work_torque = TMC2160_HORI_TORQUE_VALUE;//ʱtorqueֵ
  tmc2160_parameter.hori_global_scaler = CURR_GLOBAL_SCALER;//ȫ
 
  tmc2160_parameter.hori_acc_time_max = PTZ_HORI_ACC_TIME_MAX;//0ٵٶʱ
  tmc2160_parameter.hori_dec_time_max = PTZ_HORI_DEC_TIME_MAX;//ٶȼٵ0ʱ
  
  
  
  tmc2160_parameter.vert_step_1_8_en = 0;//ǷЧ0Ч1Ч
  tmc2160_parameter.vert_step_1_8_v_max = 0;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.vert_step_1_8_v_min = 0;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.vert_step_1_16_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.vert_step_1_16_v_max = PTZ_VERT_1_16_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.vert_step_1_16_v_min = PTZ_VERT_1_16_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.vert_step_1_32_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.vert_step_1_32_v_max = PTZ_VERT_1_32_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.vert_step_1_32_v_min = PTZ_VERT_1_32_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.vert_step_1_64_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.vert_step_1_64_v_max = PTZ_VERT_1_64_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.vert_step_1_64_v_min = PTZ_VERT_1_64_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.vert_step_1_128_en = 1;//ǷЧ0Ч1Ч
  tmc2160_parameter.vert_step_1_128_v_max = PTZ_VERT_1_128_STEP_V_MAX;//ϸ̶ֳ¶Ӧת
  tmc2160_parameter.vert_step_1_128_v_min = PTZ_VERT_1_128_STEP_V_MIN;//ϸ̶ֳ¶ӦСת
  
  tmc2160_parameter.vert_work_torque = TMC2160_VERT_TORQUE_VALUE;//ʱtorqueֵ
  tmc2160_parameter.vert_global_scaler = CURR_GLOBAL_SCALER;//ȫ
 
  tmc2160_parameter.vert_acc_time_max = PTZ_VERT_ACC_TIME_MAX;//0ٵٶʱ
  tmc2160_parameter.vert_dec_time_max = PTZ_VERT_DEC_TIME_MAX;//ٶȼٵ0ʱ
  
  tmc2160_parameter.crc = tmc2160_parameter_crc(tmc2160_parameter);//Ч
  return 1;
  
}

///===== λ
char tmc2160_reset()
{
  tmc2160_data_reset();
  
  //ˮƽ
  tmc2160_write_register(TMC2160_HORI, TMC2160_IHOLD_IRUN, TMC2160_HORI_TORQUE_VALUE);//Ĭֵ=20/32*2.3A
  tmc2160_write_register(TMC2160_HORI, TMC2160_CHOPCONF, TMC2160_1_16_STEP);//ϸĬ16
  //ֱ
  tmc2160_write_register(TMC2160_VERT, TMC2160_IHOLD_IRUN, TMC2160_VERT_TORQUE_VALUE);//Ĭֵ=20/32*2.3A
  tmc2160_write_register(TMC2160_VERT, TMC2160_CHOPCONF, TMC2160_1_16_STEP);//ϸĬ16
  if (tmc2160_parameter_save() == 1)
  {//λɹ
    return 1;
  }
  return 0;
}

///===== ʼ
char tmc2160_data_init()
{
  tmc2160_parameter_read();
  if (tmc2160_parameter_read() == 1)
  {//ȡɹ
    return 1;
  }else{//ȡʧ
    tmc2160_data_reset();
    tmc2160_parameter_save();
    return 0;
  }
}

///===== ϴ
void tmc2160_parameter_upload(char dev)
{
  unsigned char data[7] = {0};
//*****************************ˮƽ**********************************//
  /*********************************1_8*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x09;
  data[4] = tmc2160_parameter.hori_step_1_8_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
 
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0a;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_8_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_8_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
 
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0b;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_8_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_8_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************1_16*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0c;
  data[4] = tmc2160_parameter.hori_step_1_16_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0d;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_16_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_16_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0e;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_16_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_16_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  
  /*********************************1_32*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0f;
  data[4] = tmc2160_parameter.hori_step_1_32_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
 
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x10;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_32_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_32_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x11;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_32_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_32_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
 
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  
  /*********************************1_64*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x12;
  data[4] = tmc2160_parameter.hori_step_1_64_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x13;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_64_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_64_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x14;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_64_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_64_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  
  /*********************************1_128*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x15;
  data[4] = tmc2160_parameter.hori_step_1_128_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x16;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_128_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_128_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x17;
  data[4] = ((unsigned short int)(tmc2160_parameter.hori_step_1_128_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.hori_step_1_128_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
 
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************work_torque*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x20;
  data[4] = tmc2160_parameter.hori_work_torque;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /********************************global_scaler***********************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x21;
  data[4] = tmc2160_parameter.hori_global_scaler;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************acc_time*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x23;
  data[4] = tmc2160_parameter.hori_acc_time_max >> 8;
  data[5] = tmc2160_parameter.hori_acc_time_max & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************dec_time*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x51;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x24;
  data[4] = tmc2160_parameter.hori_dec_time_max >> 8;
  data[5] = tmc2160_parameter.hori_dec_time_max & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
//************************************************************************************************************************/
  
  
  
//****************************ʹֱ************************************//
  /*********************************1_8*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x09;
  data[4] = tmc2160_parameter.vert_step_1_8_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0a;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_8_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_8_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0b;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_8_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_8_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
   
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************1_16*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0c;
  data[4] = tmc2160_parameter.vert_step_1_16_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
   
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0d;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_16_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_16_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
   
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0e;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_16_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_16_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  
  /*********************************1_32*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x0f;
  data[4] = tmc2160_parameter.vert_step_1_32_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
   
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x10;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_32_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_32_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x11;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_32_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_32_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  
  /*********************************1_64*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x12;
  data[4] = tmc2160_parameter.vert_step_1_64_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x13;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_64_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_64_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x14;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_64_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_64_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  
  /**********************************1_128**************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x15;
  data[4] = tmc2160_parameter.vert_step_1_128_en;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x16;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_128_v_min * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_128_v_min * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x17;
  data[4] = ((unsigned short int)(tmc2160_parameter.vert_step_1_128_v_max * 10)) >> 8;
  data[5] = ((unsigned short int)(tmc2160_parameter.vert_step_1_128_v_max * 10)) & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
   
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************work_torque**********************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x20;
  data[4] = tmc2160_parameter.vert_work_torque;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /********************************global_scaler*********************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x21;
  data[4] = tmc2160_parameter.vert_global_scaler;
  data[5] = 0;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************acc_time*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x23;
  data[4] = tmc2160_parameter.vert_acc_time_max >> 8;
  data[5] = tmc2160_parameter.vert_acc_time_max & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  
  /*********************************dec_time*************************************/
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = 0x52;//0X51͵ˮƽ,0X52͵Ǵֱ
  data[3] = 0x24;
  data[4] = tmc2160_parameter.vert_dec_time_max >> 8;
  data[5] = tmc2160_parameter.vert_dec_time_max & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
   
//************************************************************************************************************************/
}

///===== tmc2160ݴ
void tmc2160_parameter_process(char dev, PTZ_DATA_PACK *pack)
{
  float speed;
  if(pack->command[0] == 0x51)//ˮƽ
  {
    speed = (float)((pack->data[0] << 8) | pack->data[1]) / 10.0;
    if(speed > PTZ_HORI_MOTOR_MAX_SPEED)
    {
      speed = PTZ_HORI_MOTOR_MAX_SPEED;
    }
    if(speed < 0)
    {
      speed = 0;
    }
    
    switch(pack->command[1]) 
    {
      case 0x09:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.hori_step_1_8_en = 1;
        }
        else
        {
          tmc2160_parameter.hori_step_1_8_en = 0;
        }
        break;
        
      case 0x0a:
        tmc2160_parameter.hori_step_1_8_v_min = speed;
        break;
        
      case 0x0b:
        tmc2160_parameter.hori_step_1_8_v_max = speed;
        break;
        
/*******************************************************************************************/
         
      case 0x0c:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.hori_step_1_16_en = 1;
        }
        else
        {
          tmc2160_parameter.hori_step_1_16_en = 0;
        }
        break;
        
      case 0x0d:
        tmc2160_parameter.hori_step_1_16_v_min = speed;
        break;
        
      case 0x0e:
        tmc2160_parameter.hori_step_1_16_v_max = speed;
        break;
       
/*******************************************************************************************/
         
      case 0x0f:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.hori_step_1_32_en = 1;
        }
        else
        {
          tmc2160_parameter.hori_step_1_32_en = 0;
        }
        break;
        
      case 0x10:
        tmc2160_parameter.hori_step_1_32_v_min = speed;
        break;
        
      case 0x11:
        tmc2160_parameter.hori_step_1_32_v_max = speed;
        break;
       
/*******************************************************************************************/
         
      case 0x12:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.hori_step_1_64_en = 1;
        }
        else
        {
          tmc2160_parameter.hori_step_1_64_en = 0;
        }
        break;
        
      case 0x13:
        tmc2160_parameter.hori_step_1_64_v_min = speed;
        break;
        
      case 0x14:
        tmc2160_parameter.hori_step_1_64_v_max = speed;
        break;
        
/*******************************************************************************************/
         
      case 0x15:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.hori_step_1_128_en = 1;
        }
        else
        {
          tmc2160_parameter.hori_step_1_128_en = 0;
        }
        break;
        
      case 0x16:
        tmc2160_parameter.hori_step_1_128_v_min = speed;
        break;
        
      case 0x17:
        tmc2160_parameter.hori_step_1_128_v_max = speed;
        break;
       
/*******************************************************************************************/
  
      
    case 0x20:
      tmc2160_parameter.hori_work_torque = pack->data[0];
      if(tmc2160_parameter.hori_work_torque > TMC2160_WORK_TORQUE_MAX)
      {
        tmc2160_parameter.hori_work_torque = TMC2160_WORK_TORQUE_MAX;
      }
      if(tmc2160_parameter.hori_work_torque < TMC2160_WORK_TORQUE_MIN)
      {
        tmc2160_parameter.hori_work_torque = TMC2160_WORK_TORQUE_MIN;
      }
      tmc2160_write_register(TMC2160_HORI, TMC2160_IHOLD_IRUN, tmc2160_parameter.hori_work_torque);
      break;
      
      case 0x21:
      tmc2160_parameter.hori_global_scaler = pack->data[0];      
      tmc2160_write_register(TMC2160_HORI, TMC2160_GLOBAL_SCALER, tmc2160_parameter.hori_global_scaler);
      break;
      
    case 0x23:
      tmc2160_parameter.hori_acc_time_max =  (pack->data[0] << 8) | pack->data[1];
      break;

    case 0x24:
      tmc2160_parameter.hori_dec_time_max =  (pack->data[0] << 8) | pack->data[1];
      break;
    }
        
  }
  
  if(pack->command[0] == 0x52)//ֱ
  {
    speed = (float)((pack->data[0] << 8) | pack->data[1]) / 10.0;
    if(speed > PTZ_VERT_MOTOR_MAX_SPEED)
    {
      speed = PTZ_VERT_MOTOR_MAX_SPEED;
    }
    if(speed < 0)
    {
      speed = 0;
    }
    
    switch(pack->command[1]) 
    {
      case 0x09:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.vert_step_1_8_en = 1;
        }
        else
        {
          tmc2160_parameter.vert_step_1_8_en = 0;
        }
        break;
        
      case 0x0a:
        tmc2160_parameter.vert_step_1_8_v_min = speed;
        break;
        
      case 0x0b:
        tmc2160_parameter.vert_step_1_8_v_max = speed;
        break;
        
/*******************************************************************************************/
         
      case 0x0c:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.vert_step_1_16_en = 1;
        }
        else
        {
          tmc2160_parameter.vert_step_1_16_en = 0;
        }
        break;
        
      case 0x0d:
        tmc2160_parameter.vert_step_1_16_v_min = speed;
        break;
        
      case 0x0e:
        tmc2160_parameter.vert_step_1_16_v_max = speed;
        break;
       
/*******************************************************************************************/
         
      case 0x0f:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.vert_step_1_32_en = 1;
        }
        else
        {
          tmc2160_parameter.vert_step_1_32_en = 0;
        }
        break;
        
      case 0x10:
        tmc2160_parameter.vert_step_1_32_v_min = speed;
        break;
        
      case 0x11:
        tmc2160_parameter.vert_step_1_32_v_max = speed;
        break;
       
/*******************************************************************************************/
         
      case 0x12:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.vert_step_1_64_en = 1;
        }
        else
        {
          tmc2160_parameter.vert_step_1_64_en = 0;
        }
        break;
        
      case 0x13:
        tmc2160_parameter.vert_step_1_64_v_min = speed;
        break;
        
      case 0x14:
        tmc2160_parameter.vert_step_1_64_v_max = speed;
        break;
        
/*******************************************************************************************/
         
      case 0x15:
        if(pack->data[0] == 1)
        {
          tmc2160_parameter.vert_step_1_128_en = 1;
        }
        else
        {
          tmc2160_parameter.vert_step_1_128_en = 0;
        }
        break;
        
      case 0x16:
        tmc2160_parameter.vert_step_1_128_v_min = speed;
        break;
        
      case 0x17:
        tmc2160_parameter.vert_step_1_128_v_max = speed;
        break;
       
/*******************************************************************************************/
        
      case 0x20:
        tmc2160_parameter.vert_work_torque = pack->data[0];
        if(tmc2160_parameter.vert_work_torque > TMC2160_WORK_TORQUE_MAX)
        {
          tmc2160_parameter.vert_work_torque = TMC2160_WORK_TORQUE_MAX;
        }
        if(tmc2160_parameter.vert_work_torque < TMC2160_WORK_TORQUE_MIN)
        {
          tmc2160_parameter.vert_work_torque = TMC2160_WORK_TORQUE_MIN;
        }
        tmc2160_write_register(TMC2160_VERT, TMC2160_IHOLD_IRUN, tmc2160_parameter.vert_work_torque);
        break;
        
     case 0x21:
        tmc2160_parameter.vert_global_scaler = pack->data[0];      
        tmc2160_write_register(TMC2160_VERT, TMC2160_GLOBAL_SCALER, tmc2160_parameter.vert_global_scaler);
        break;
        
      case 0x23:
        tmc2160_parameter.vert_acc_time_max =  (pack->data[0] << 8) | pack->data[1];
        break;

      case 0x24:
        tmc2160_parameter.vert_dec_time_max =  (pack->data[0] << 8) | pack->data[1];
        break;

    }
        
  }

  if(pack->command[0] == 0x53)//ݲ
  {
    switch(pack->command[1]) 
    {
      case 0x00://ȡشDRV8711
        //ȡ
        tmc2160_parameter_read();
        //ش
        tmc2160_parameter_upload(dev);
        break;
        
      case 0x01://DRV8711
        tmc2160_parameter_save();
        break;
        
      case 0x02://ɾDRV8711FLASHеĲ
        tmc2160_parameter_erase();
        break;
        
      case 0x03://λDRV8711FLASHбĲ
//        tmc2160_write_register(TMC2160_HORI, TMC2160_GSTAT, 0);
//        OSTimeDlyHMSM(0u, 0u, 0u, 1u);
//        tmc2160_write_register(TMC2160_VERT, TMC2160_GSTAT, 0);
//        OSTimeDlyHMSM(0u, 0u, 0u, 1u);
        tmc2160_reset();
        
        break;

    }
  }

}

///===== ״̬ȡ
unsigned int tmc2160_state_read(char choice, char regis)
{
  unsigned long int status;
  if(choice == TMC2160_HORI)
  {
    status = tmc2160_write_hori_data(choice, regis,0xff,0xff,0xff,0xff);//choiceѡx2/x3/x4/x5дĴ
  }
  if(choice == TMC2160_VERT)
  {
    status = tmc2160_write_vert_data(choice, regis,0xff,0xff,0xff,0xff);//choiceѡx2/x3/x4/x5дĴ
  }
  return status;
}

void tmc2160_state_return(char dev)
{
  unsigned char data[7] = {0};
  unsigned long int status;
  //****************************ˮƽ״̬******************//
  status = tmc2160_state_read(TMC2160_HORI,TMC2160_DRV_STATUS);
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = (status >> 24) & 0x00ff;//ֹͣԴ··¾桢´ת״̬,8λ
  data[3] = (status >> 16) & 0x00ff;
  data[4] = (status >> 8) & 0x00ff;
  data[5] = status & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  //****************************״̬******************//
  status = tmc2160_state_read(TMC2160_HORI,TMC2160_IOIN);
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = (status >> 24) & 0x00ff;//8λΪ汾ţ8λΪ״̬
  data[3] = 0x00ff;
  data[4] = 0x00ff;
  data[5] = status & 0x00ff;//˵8λΪ״̬0λźš1λתźš4λʹźš
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  OSTimeDlyHMSM(0u, 0u, 0u, 20u);
  //**************************ʹֱ״̬******************//
  status = tmc2160_state_read(TMC2160_VERT,TMC2160_DRV_STATUS);
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = (status >> 24) & 0x00ff;//ֹͣԴ··¾桢´ת״̬,8λ
  data[3] = (status >> 16) & 0x00ff;
  data[4] = (status >> 8) & 0x00ff;
  data[5] = status & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  OSTimeDlyHMSM(0u, 0u, 0u, 10u);
  //****************************״̬******************//
  status = tmc2160_state_read(TMC2160_VERT,TMC2160_IOIN);
  data[0] = 0xff;
  data[1] = g_ptz.address;
  data[2] = (status >> 24) & 0x00ff;//8λΪ汾ţ8λΪ״̬
  data[3] = 0x00ff;
  data[4] = 0x00ff;
  data[5] = status & 0x00ff;
  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
  ptz_send_data(dev, data, sizeof(data));
  
  /**********************²ãstealthchop*********************/
  
//  OSTimeDlyHMSM(0u, 0u, 0u, 20u);
//  //****************************ˮƽֵ******************//
//  status = tmc2160_state_read(TMC2160_HORI,TMC2160_PWM_AUTO);
//  data[0] = 0xff;
//  data[1] = g_ptz.address;
//  data[2] = (status >> 24) & 0x00ff;
//  data[3] = (status >> 16) & 0x00ff;
//  data[4] = (status >> 8) & 0x00ff;
//  data[5] = status & 0x00ff;
//  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
//  ptz_send_data(dev, data, sizeof(data));
//  
//  OSTimeDlyHMSM(0u, 0u, 0u, 20u);
//  //****************************ʹֱֵ******************//
//  status = tmc2160_state_read(TMC2160_VERT,TMC2160_PWM_AUTO);
//  data[0] = 0xff;
//  data[1] = g_ptz.address;
//  data[2] = (status >> 24) & 0x00ff;
//  data[3] = (status >> 16) & 0x00ff;
//  data[4] = (status >> 8) & 0x00ff;
//  data[5] = status & 0x00ff;
//  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
//  ptz_send_data(dev, data, sizeof(data));
//  
//  OSTimeDlyHMSM(0u, 0u, 0u, 20u);
//  //*****************************ˮƽ******************//
//  status = tmc2160_state_read(TMC2160_HORI,TMC2160_PWM_SCALE);
//  data[0] = 0xff;
//  data[1] = g_ptz.address;
//  data[2] = (status >> 24) & 0x00ff;
//  data[3] = (status >> 16) & 0x00ff;
//  data[4] = (status >> 8) & 0x00ff;
//  data[5] = status & 0x00ff;
//  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
//  ptz_send_data(dev, data, sizeof(data));
//  
//  OSTimeDlyHMSM(0u, 0u, 0u, 20u);
//  //*****************************ʹֱ******************//
//  status = tmc2160_state_read(TMC2160_VERT,TMC2160_PWM_SCALE);
//  data[0] = 0xff;
//  data[1] = g_ptz.address;
//  data[2] = (status >> 24) & 0x00ff;
//  data[3] = (status >> 16) & 0x00ff;
//  data[4] = (status >> 8) & 0x00ff;
//  data[5] = status & 0x00ff;
//  data[6] = MotorCalPelcoDSUM(data,sizeof(data));
//  ptz_send_data(dev, data, sizeof(data));
}



#endif 