#ifndef _USART_H
#define _USART_H

#include "gd32f4xx.h"
#include "ring_queue.h"
#include "includes.h"
#include "comm_types.h"
#include "agent_hyt.h"

typedef u_int32_t device_handle;

#define TEST           USART0
#define UART_485       USART1
#define UART_422       USART2


#define PTZ_UART_485_BUFF_SIZE       100
#define PTZ_UART_422_BUFF_SIZE       100

#define PTZ_UART_485_INDEX           1 //485ʹô1
#define PTZ_UART_422_INDEX           2 //422ʹô2

#define PTZ_UART_485_TX      gpio_bit_set(GPIOD, GPIO_PIN_7)//485
#define PTZ_UART_485_RX      gpio_bit_reset(GPIOD, GPIO_PIN_7)//485




extern device_handle uart_485_handle ;
extern device_handle uart_422_handle ;

extern BSP_OS_SEM ser_mutex;
//
//RS422
extern u_int8_t ptz_uart_422_buff[PTZ_UART_422_BUFF_SIZE];
extern char uart_422_state ;
//RS485
extern u_int8_t ptz_uart_485_buff[PTZ_UART_485_BUFF_SIZE];
extern char uart_485_state ;



typedef struct _uart_device_info{
  u_int8_t init;  //豸Ƿʼ׼ݱ־
  u_int8_t index; //uart豸012...
  RingQueue  uart_ring_queue; //ά豸Ľջѭ
  BSP_OS_SEM ser_mutex;//÷һֽں
  BSP_OS_SEM port_mutex;//һֽ
  BSP_OS_SEM read_mutex;//ڶbuffer
  BSP_OS_SEM sem_recv_data;//֪ͨյ
}uart_device_info;






void Usart_init_module();
void IRQHandler_485_process(u_int8_t data);
void IRQHandler_422_process(u_int8_t data);
void ptz_uart_dev_send(device_handle device, void *data, int len);
char ptz_uart_dev_in_char(device_handle device);
int ptz_uart_dev_char_present(device_handle device);
void init_term_uart();

#endif