/*****************************************************************************
** ļƣflash.c
**     ܣ
** ޸־
******************************************************************************/
#include "w25q128.h"
#include "bsp_os.h"

unsigned short int ID=0;
unsigned char only_id[8] = {0};
static BSP_OS_SEM w25q128_mutex;//Դ

/*******************************************************************************
** ƣvoid Flash_GPIO_Init(void)
**     ܣ
** ޸־
*******************************************************************************/
void Flash_GPIO_Init(void)
{   
    BSP_OS_SemCreate(&w25q128_mutex,1u,"w25q128_mutex");//ź
    
    rcu_periph_clock_enable(RCU_GPIOB);
    rcu_periph_clock_enable(RCU_GPIOE);
    //MOSI_PIN3,,,,SCK_PIN5
    gpio_mode_set(GPIOB, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_3| GPIO_PIN_5);
    gpio_output_options_set(GPIOB, GPIO_OTYPE_PP, GPIO_OSPEED_25MHZ, GPIO_PIN_3| GPIO_PIN_5);
    //MISO
    gpio_mode_set(GPIOB, GPIO_MODE_INPUT, GPIO_PUPD_NONE, GPIO_PIN_4);
    //CS

    gpio_mode_set(GPIOB, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO_PIN_8);
    gpio_output_options_set(GPIOB, GPIO_OTYPE_PP, GPIO_OSPEED_25MHZ, GPIO_PIN_8);

   
    FLASH_CS_DISABLE;
    FLASH_CLK_HIGH;
    FLASH_DI_LOW;	
}

/*****************************************************************************
** ļƣ Flash_ReadOneByte
**     ܣ
** ޸־
******************************************************************************/
static u_int8_t Flash_ReadOneByte(void)
{
    u_int8_t retValue = 0;

    FLASH_CLK_HIGH;            //ʱ,ָʱΪߵƽ
    for(u_int8_t i= 0; i < 8; i++)
    {
        retValue <<= 1;
        FLASH_CLK_HIGH;            //ʱ,ָʱΪߵƽ
        if(FLASH_DO_READ)
        {
            retValue |= 0x01;
        }
        else
        {
            retValue &= 0xFE;
        }
        FLASH_CLK_LOW;            //ʱ,½ض
    }
    FLASH_CLK_HIGH;
   
    return (retValue);
}

/*****************************************************************************
** ļƣFlash_WriteOneByte
**     ܣ
** ޸־
******************************************************************************/

static void Flash_WriteOneByte(u_int8_t DataBuffer)
{
    FLASH_CLK_LOW;          //ʱָͣʱΪ͵ƽ
    for(u_int8_t i = 0; i < 8; i++)
    {
        FLASH_CLK_LOW;          //ʱָͣʱΪ͵ƽ
        if(DataBuffer & 0x80)
        {
            FLASH_DI_HIGH;
        }
        else
        {
            FLASH_DI_LOW;
        }
        DataBuffer <<= 1;
        FLASH_CLK_HIGH; //ʱߣд
    }
    FLASH_CLK_LOW;
    FLASH_DI_HIGH; //һֽݴϣMOSIø߱ʾ״̬
   
}

/*****************************************************************************
** ļƣ  Flash_Write_CMD
**     ܣ
** ޸־
******************************************************************************/

static void Flash_Write_CMD(u_int8_t *pCMD)
{
#ifdef FLASH_W25Q256  
     for(u_int8_t i = 0; i < 4; i++)  //new add 
    {
        Flash_WriteOneByte(pCMD[i]);
    }
#endif
    
#ifdef FLASH_W25Q128  
     for(u_int8_t i = 0; i < 3; i++)  //new add 
    {
        Flash_WriteOneByte(pCMD[i]);
    }
#endif    
    
    
}

/*****************************************************************************
** ļƣ u_int16_t Flash_ReadSR
**     ܣ
** ޸־
******************************************************************************/

static u_int8_t Flash_ReadSR(void)
{
    u_int8_t retValue = 0;

    FLASH_CS_ENABLE;
    Flash_WriteOneByte(Flash_ReadSR_CMD);
    retValue = Flash_ReadOneByte();
    FLASH_CS_DISABLE;

    return retValue;
}


/*****************************************************************************
** ļƣFlash_Wait_Busy
**     ܣ
** ޸־
******************************************************************************/

static void Flash_Wait_Busy(void)
{
   u_int32_t i =0;

   while(((Flash_ReadSR() & FLASH_WRITE_BUSYBIT) == 0x01) && (i<0x1ffff))
   {
      i ++;
   }
}

/*****************************************************************************
** ļƣstatic void Flash_Write_Enable(void)
**     ܣ
** ޸־
******************************************************************************/

static void Flash_Write_Enable(void)
{
    FLASH_CS_ENABLE;
    Flash_WriteOneByte(Flash_WriteEnable_CMD);
    FLASH_CS_DISABLE;
}


void Enter4ByteAddrMode(void) 
{ 
    FLASH_CS_ENABLE;                                //ʹ    
    Flash_WriteOneByte(W25Q_4ByteAddrModeEnable);   //4ByteַģʽW25Q128ʹ 
    FLASH_CS_DISABLE; 
}


void Exit4ByteAddrMode(void) 
{ 
    FLASH_CS_ENABLE;                                //ʹ    
    Flash_WriteOneByte(W25Q_Exit4ByteAddrModeEnable);   //4ByteַģʽW25Q128ʹ 
    FLASH_CS_DISABLE; 
}
/*****************************************************************************
** ļƣ void Flash_Erase_Sector(u_int16_t Block_Num,u_int16_t Sector_Number)
**     ܣ
** ޸־
******************************************************************************/

void Flash_Erase_Sector(u_int8_t Block_Num,u_int8_t Sector_Number)
{

    BSP_OS_SemWait(&w25q128_mutex, 0u);
    
    u_int8_t pcmd[3] = {0};
    Flash_Write_Enable();
    FLASH_CS_ENABLE;
    Flash_WriteOneByte(Flash_SecErase_CMD);

    pcmd[0] = Block_Num;
    pcmd[1] = Sector_Number<<4;
    pcmd[2] = 0;
    Flash_Write_CMD(pcmd);
    FLASH_CS_DISABLE;
    Flash_Wait_Busy();//ÿβݶҪʱȴд
   
    BSP_OS_SemPost(&w25q128_mutex);
    return ;
}

/*****************************************************************************
** ļƣvoid Flash_Erase_Block(u_int8_t BlockNum)
**     ܣBLOCK
** ޸־
******************************************************************************/

void Flash_Erase_Block(u_int8_t BlockNum)
{
    BSP_OS_SemWait(&w25q128_mutex, 0u);
    
    u_int8_t pcmd[3] = {0};
    Flash_Write_Enable();   //дʹ
    FLASH_CS_ENABLE;        //Ƭѡ
    Flash_WriteOneByte(Flash_BlockErase_CMD);  //Blockָ
    pcmd[0] = BlockNum ;     //24λַ
    Flash_Write_CMD(pcmd);
    FLASH_CS_DISABLE;
    Flash_Wait_Busy();      //ÿβݶҪʱȴд
   
    BSP_OS_SemPost(&w25q128_mutex);
    return ;
}

/*****************************************************************************
** ļƣvoid Flash_Write_Page(u_int8_t *pBuffer, u_int32_t WriteAddr, u_int32_t WriteBytesNum)
**     ܣ
** ޸־
******************************************************************************/
void Flash_Write_Page(u_int8_t *pBuffer, u_int32_t WriteAddr, u_int32_t WriteBytesNum)
{
    u_int8_t pcmd[4] = {0};    
                        
    Flash_Write_Enable();
    FLASH_CS_ENABLE;
    Flash_WriteOneByte(Flash_PageProgram_CMD);
#ifdef FLASH_W25Q256    
    pcmd[0] = (u_int8_t)((WriteAddr&0xff000000)>>24);     //new add
    pcmd[1] = (u_int8_t)((WriteAddr&0x00ff0000)>>16);
    pcmd[2] = (u_int8_t)((WriteAddr&0x0000ff00)>>8);
    pcmd[3] = (u_int8_t)WriteAddr;
#endif
    
#ifdef FLASH_W25Q128    
    pcmd[0] = (u_int8_t)((WriteAddr&0x00ff0000)>>16);
    pcmd[1] = (u_int8_t)((WriteAddr&0x0000ff00)>>8);
    pcmd[2] = (u_int8_t)WriteAddr;
#endif    
    
    Flash_Write_CMD(pcmd);

    for(u_int32_t  i = 0;i < WriteBytesNum; i++)
    {

        Flash_WriteOneByte(pBuffer[i]);  //Flashдһҳ256bytesֽ
    }
    FLASH_CS_DISABLE;
    Flash_Wait_Busy();                   //ÿдһݶҪʱȴд
    return;
}

/*****************************************************************************
** ļƣvoid Flash_Write_MorePage(u_int8_t *pBuffer, u_int32_t WriteAddr, u_int32_t WriteBytesNum)
**     ܣ
** ޸־
******************************************************************************/
void Flash_Write_MorePage(u_int8_t *pBuffer, u_int32_t WriteAddr, u_int32_t WriteBytesNum)
{
    BSP_OS_SemWait(&w25q128_mutex, 0u); 
    
    u_int16_t PageByteRemain = 0;
    PageByteRemain = Flash_PAGEBYTE_LENGTH - WriteAddr%Flash_PAGEBYTE_LENGTH;
    if(WriteBytesNum <= PageByteRemain)
    {
        PageByteRemain = WriteBytesNum;
    }
    while(1)
    {
        Flash_Write_Page(pBuffer,WriteAddr,PageByteRemain);
        if(WriteBytesNum == PageByteRemain)
        {
            break;
        }
        else
        {
            pBuffer       += PageByteRemain;
            WriteAddr     += PageByteRemain;
            WriteBytesNum -= PageByteRemain;
            if(WriteBytesNum > Flash_PAGEBYTE_LENGTH)
            {
                PageByteRemain = Flash_PAGEBYTE_LENGTH;
            }
            else
            {
                PageByteRemain = WriteBytesNum;
            }
        }
    }
    
    BSP_OS_SemPost(&w25q128_mutex);
    
    return;
}

/*****************************************************************************
** ļƣvoid Flash_Read(u_int8_t *pBuffer,u_int32_t ReadAddr,u_int32_t ReadBytesNum)
**     ܣ
** ޸־
******************************************************************************/

void Flash_Read(u_int8_t *pBuffer,u_int32_t ReadAddr,u_int32_t ReadBytesNum)
{
    BSP_OS_SemWait(&w25q128_mutex, 0u); 
    
    u_int8_t pcmd[4] = {0}; 
    FLASH_CS_ENABLE; //spiflashƬѡ
    Flash_WriteOneByte(Flash_ReadData_CMD);
#ifdef FLASH_W25Q256
    pcmd[0] = (u_int8_t)((ReadAddr&0xff000000)>>24); //new add
    pcmd[1] = (u_int8_t)((ReadAddr&0x00ff0000)>>16);
    pcmd[2] = (u_int8_t)((ReadAddr&0x0000ff00)>>8);
    pcmd[3] = (u_int8_t)ReadAddr;
#endif
    
#ifdef FLASH_W25Q128  
    pcmd[0] = (u_int8_t)((ReadAddr&0x00ff0000)>>16);
    pcmd[1] = (u_int8_t)((ReadAddr&0x0000ff00)>>8);
    pcmd[2] = (u_int8_t)ReadAddr;    
#endif   
    
    Flash_Write_CMD(pcmd);

    for(u_int32_t i = 0;i < ReadBytesNum; i++)
    {
       pBuffer[i] = Flash_ReadOneByte();  //ȡSPIflashָbytesֽ

    }
    FLASH_CS_DISABLE;
    
    BSP_OS_SemPost(&w25q128_mutex);
    return ;
}



/*дFLASH*/
void write_many_data(int n,unsigned char *p,unsigned int start_address)
{ /*nܳ,*pҪдݵĵַstart_addressдFlashĵַ֡ͷͶ֮ȫдFLASH*/
  unsigned char block;
 if((start_address%65536)==0)
  {
    block=(start_address/65536);
    Flash_Erase_Block(block);
  }
  Flash_Write_MorePage(p,start_address,n);//дǳ֡ͷͶʣµ
}






//falsh洢FLASHһַ洢
//write_addд׵ַ
//cache_addַСĬΪһsector4KBflashдҪsectorΪ˲ӰsectorҪ޸ĵݣҪһ
//*dataҪдݵָ
//lenҪдݵĳ

//дУ
unsigned int w25q128_random_crc(char *data, unsigned int len)
{
  unsigned int i = 0;
  unsigned int crc = 0;
  for(i = 0; i < len; i++)
  {
    crc = crc + data[i];
  }
  return crc;
}


//BLOCKSECTORϸĵַ
w25q128_add_inf w25q128_block_sector_to_add(unsigned char block, unsigned char sector)
{
  w25q128_add_inf inf;
  inf.block = block;
  inf.sector = sector;
  
  //block׵ַ
  inf.block_first_add = 64 * 1024 * inf.block;
  //blockβַ
  inf.block_tail_add  = 64 * 1024 * (inf.block + 1) - 1;
  
  //sector׵ַ
  inf.sector_first_add = 64 * 1024 * inf.block + 4 * 1024 * inf.sector;
  //sectorβַ
  inf.sector_tail_add  = 64 * 1024 * inf.block + 4 * 1024 * (inf.sector + 1) - 1;
  
  inf.add = inf.sector_first_add;//˴ظsector׵ַ
  
  return inf;
}

//ͨĳַõַӦblocksectorϸĵַϢ
w25q128_add_inf w25q128_add_to_block_sector(unsigned int add)
{
  w25q128_add_inf inf;
  
  inf.add = add;
  
  //㴦ĸblock
  if((add + 1) >= (64 * 1024))
  {
    if((add + 1) % (64 * 1024) == 0)
    {
      inf.block = (add + 1) / (64 * 1024) - 1;
    }
    else
    {
      inf.block = (add + 1) / (64 * 1024);
    }
  }
  else
  {
    inf.block = 0;
  }
  //block׵ַ
  inf.block_first_add = 64 * 1024 * inf.block;
  //blockβַ
  inf.block_tail_add  = 64 * 1024 * (inf.block + 1) - 1;
  
  //㴦ĸsector
  if((add + 1 - inf.block * 64 * 1024) >= (4 * 1024))
  {
    if((add + 1 - inf.block * 64 * 1024) % (4 * 1024) == 0)
    {
      inf.sector = (add + 1 - inf.block * 64 * 1024) / (4 * 1024) - 1;
    }
    else
    {
      inf.sector = (add + 1 - inf.block * 64 * 1024) / (4 * 1024);
    }
  }
  else
  {
    inf.sector = 0;
  }
  
  //sector׵ַ
  inf.sector_first_add = 64 * 1024 * inf.block + 4 * 1024 * inf.sector;
  //sectorβַ
  inf.sector_tail_add  = 64 * 1024 * inf.block + 4 * 1024 * (inf.sector + 1) - 1;
  
  return inf;
}




//д
//write_addдĵַcache_addַĳsector׵ַ*dataҪдݵָ룻lenҪдݵĳ
char w25q128_random_write(unsigned int write_add, unsigned int cache_add, char *data, unsigned int len)
{

  unsigned int  save_write_add, save_read_add, cache_write_add, cache_read_add;
  
  unsigned char data_buffer[W25Q128_BUFFER_LEN];
  unsigned int i ,j;
  unsigned int total_byte, replace_len, replace_len_total; //Ҫдֽ,Ҫ滻ĳ
  w25q128_add_inf save_write_inf, save_first_sector_inf, save_tail_sector_inf, cache_inf;

  
  save_first_sector_inf = w25q128_add_to_block_sector(write_add);
  save_tail_sector_inf  = w25q128_add_to_block_sector(write_add + len - 1);
  cache_inf             = w25q128_add_to_block_sector(cache_add);
  //SECTOR
  Flash_Erase_Sector(cache_inf.block, cache_inf.sector);
  
  total_byte = 
    (save_tail_sector_inf.block - save_first_sector_inf.block + 1) * 64 * 1024 - save_first_sector_inf.sector * 4 * 1024 - ( 15 - save_tail_sector_inf.sector) * 4 * 1024;
  
  save_read_add = 
    w25q128_block_sector_to_add(save_first_sector_inf.block, save_first_sector_inf.sector).sector_first_add;//Ҫݵĵһsector׵ַ
  save_write_add = save_read_add;
  
  
  cache_read_add = cache_inf.sector_first_add;
  cache_write_add = cache_read_add;
  
  replace_len_total = 0;

  
  for(i = 0; i < total_byte; i = i + W25Q128_BUFFER_LEN)
  {
    memset(data_buffer, 0, sizeof(data_buffer));
    //256ֽ 
    Flash_Read((unsigned char *)data_buffer, save_read_add, W25Q128_BUFFER_LEN);
    
    //ж϶256ֽûҪĵĵط
    if((write_add + replace_len_total) >= save_read_add && (write_add + replace_len_total) <= (save_read_add + W25Q128_BUFFER_LEN - 1))
    {
      //βַҲڸ256ֽ
      if((write_add + len - 1) >= save_read_add && (write_add + len - 1) <= (save_read_add + W25Q128_BUFFER_LEN - 1))
      {
        //Ҫ滻ݳ
        replace_len = (write_add + len - 1) - (write_add + replace_len_total) + 1;
      }
      else
      {
        //Ҫ滻ݳ
        replace_len = (save_read_add + W25Q128_BUFFER_LEN - 1) - (write_add + replace_len_total) + 1;
      }
      //滻
      memcpy((data_buffer + (write_add + replace_len_total - save_read_add)), (data + replace_len_total), replace_len);//滻
      
      replace_len_total = replace_len_total + replace_len;
    }

    //򻺴д
    Flash_Write_MorePage(data_buffer, cache_write_add, W25Q128_BUFFER_LEN);
      
    cache_write_add = cache_write_add + W25Q128_BUFFER_LEN;
    save_read_add   = save_read_add + W25Q128_BUFFER_LEN;
    
    //дʱݸд뵽ԭݴ洢
    if(cache_write_add == cache_inf.sector_tail_add + 1)
    {
      //ԭsectorе
      save_write_inf = w25q128_add_to_block_sector(save_write_add);
      Flash_Erase_Sector(save_write_inf.block, save_write_inf.sector);
      
      for(j = 0; j < 4 * 1024; j = j + W25Q128_BUFFER_LEN)
      {
        memset(data_buffer, 0, sizeof(data_buffer));
        //е
        Flash_Read((unsigned char *)data_buffer, cache_read_add, W25Q128_BUFFER_LEN);
        //洢д
        Flash_Write_MorePage(data_buffer, save_write_add, W25Q128_BUFFER_LEN);
        
        cache_read_add = cache_read_add + W25Q128_BUFFER_LEN;
        save_write_add = save_write_add + W25Q128_BUFFER_LEN;
      }
      
      Flash_Erase_Sector(cache_inf.block, cache_inf.sector);
      cache_read_add = cache_inf.sector_first_add;
      cache_write_add = cache_read_add;
    }
  }
  return 1;
}


/*****************************************************************************
** ļƣvoid FLASH_BulkErase()
**     ܣ
** ޸־LiHong@2021.09.29
******************************************************************************/
void FLASH_BulkErase()
{
        BSP_OS_SemWait(&w25q128_mutex, 0u);
        
	Flash_Write_Enable();   //дʹ
	Flash_Wait_Busy();
	 FLASH_CS_ENABLE;        //Ƭѡ
	Flash_WriteOneByte(Flash_Chip_Erase_CMD);
	// ָcsߣָִ
	FLASH_CS_DISABLE;
	Flash_Wait_Busy();
        BSP_OS_SemPost(&w25q128_mutex);
        return ;
}



/*****************************************************************************
** ļƣvoid Read_w25q128_ID()
**     ܣϵID
** ޸־LiHong@2022.05.20
******************************************************************************/
void Read_w25q128_ID()
{
  FLASH_CS_ENABLE;//Ƭѡʹ
  Flash_WriteOneByte(Flash_ReadID);
  Flash_WriteOneByte(0x00);
  Flash_WriteOneByte(0x00);
  Flash_WriteOneByte(0x00);
  
  
  ID |= Flash_ReadOneByte() << 8;
  ID |= Flash_ReadOneByte();
  
  FLASH_CS_DISABLE;//Ƭѡʧ
}

/*****************************************************************************
** ļƣvoid Read_w25q128_only_ID()
**     ܣΨһID
** ޸־LiHong@2021.05.20
******************************************************************************/
void Read_w25q128_only_ID()
{
  FLASH_CS_ENABLE;//Ƭѡʹ
  Flash_WriteOneByte(Flash_ReadID_only);
  Flash_WriteOneByte(0x00);
  Flash_WriteOneByte(0x00);
  Flash_WriteOneByte(0x00);
  Flash_WriteOneByte(0x00);
  
  
  only_id[0] = Flash_ReadOneByte();
  only_id[1] = Flash_ReadOneByte();
  only_id[2] = Flash_ReadOneByte();
  only_id[3] = Flash_ReadOneByte();
  only_id[4] = Flash_ReadOneByte();
  only_id[5] = Flash_ReadOneByte();
  only_id[6] = Flash_ReadOneByte();
  only_id[7] = Flash_ReadOneByte();
  
  FLASH_CS_DISABLE;//Ƭѡʧ
}

